// Compiled by ClojureScript 0.0-3211 {:static-fns true, :target :nodejs}
goog.provide('aqua_node.dtls_comm');
goog.require('cljs.core');
goog.require('aqua_node.log');
goog.require('cljs.core');
goog.require('cljs.core.async');
goog.require('aqua_node.conns');
goog.require('clojure.set');
goog.require('aqua_node.parse');
goog.require('cljs.nodejs');
goog.require('aqua_node.buf');



aqua_node.dtls_comm.to_cmd = cljs.core.PersistentHashMap.fromArrays([(0),(7),(1),(4),(15),(13),(6),(3),(12),(2),(11),(9),(5),(14),(10),(8)],[new cljs.core.Keyword(null,"init","init",-1875481434),new cljs.core.Keyword(null,"ack","ack",-913609387),new cljs.core.Keyword(null,"connect-to-node","connect-to-node",-1558104516),new cljs.core.Keyword(null,"forward","forward",-557345303),new cljs.core.Keyword(null,"ping","ping",-1670114784),new cljs.core.Keyword(null,"update-role","update-role",-1683681068),new cljs.core.Keyword(null,"new-circuit","new-circuit",-1360792812),new cljs.core.Keyword(null,"update-local-udp-dest","update-local-udp-dest",857941359),new cljs.core.Keyword(null,"rm-local-udp","rm-local-udp",-717913670),new cljs.core.Keyword(null,"open-local-udp","open-local-udp",-420464700),new cljs.core.Keyword(null,"rm-mix-fp","rm-mix-fp",1608120639),new cljs.core.Keyword(null,"rm-node","rm-node",-1891219043),new cljs.core.Keyword(null,"data","data",-232669377),new cljs.core.Keyword(null,"update-node-secret","update-node-secret",-723611096),new cljs.core.Keyword(null,"new-mix-fp","new-mix-fp",441177812),new cljs.core.Keyword(null,"new-client","new-client",-625323755)]);
aqua_node.dtls_comm.from_cmd = clojure.set.map_invert(aqua_node.dtls_comm.to_cmd);
aqua_node.dtls_comm.mk_send_fn = (function aqua_node$dtls_comm$mk_send_fn(socket){
var header = aqua_node.buf.new$((5));
header.writeUInt8((function (){var G__14538 = new cljs.core.Keyword(null,"forward","forward",-557345303);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14538) : aqua_node.dtls_comm.from_cmd.call(null,G__14538));
})(),(0));

header.writeUInt32BE(new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(socket),(1));

return ((function (header){
return (function (p1__14535_SHARP_){
header.copy(p1__14535_SHARP_);

var G__14539 = p1__14535_SHARP_;
return (aqua_node.dtls_comm.send_to_dtls.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.send_to_dtls.cljs$core$IFn$_invoke$arity$1(G__14539) : aqua_node.dtls_comm.send_to_dtls.call(null,G__14539));
});
;})(header))
});
aqua_node.dtls_comm.send_to_dtls = (function aqua_node$dtls_comm$send_to_dtls(buf){

var vec__14541 = aqua_node.dtls_comm.dtls_handler_socket_data;
var soc = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14541,(0),null);
var soc_ctrl = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14541,(1),null);
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14541,(2),null);
return soc.send(buf,(0),buf.length,port,"127.0.0.1");
});
aqua_node.dtls_comm.send_init = (function aqua_node$dtls_comm$send_init(config){
var key_file = new cljs.core.Keyword(null,"key","key",-1516042587).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"openssl","openssl",-632979726).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth-files","auth-files",1875038776).cljs$core$IFn$_invoke$arity$1(config)));
var cert_file = new cljs.core.Keyword(null,"cert","cert",648499243).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"openssl","openssl",-632979726).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth-files","auth-files",1875038776).cljs$core$IFn$_invoke$arity$1(config)));
var aqua_pub = new cljs.core.Keyword(null,"pub","pub",-1189143908).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"aqua-id","aqua-id",-1107267730).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(config)));
var aqua_sec = new cljs.core.Keyword(null,"sec","sec",-1580376553).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"aqua-id","aqua-id",-1107267730).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(config)));
var aqua_id = new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"aqua-id","aqua-id",-1107267730).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(config)));
var mk_size_and_buf = ((function (key_file,cert_file,aqua_pub,aqua_sec,aqua_id){
return (function (p1__14542_SHARP_){
var buf = aqua_node.buf.new$(p1__14542_SHARP_);
return aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new2(buf.length),buf], 0));
});})(key_file,cert_file,aqua_pub,aqua_sec,aqua_id))
;
return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14544 = new cljs.core.Keyword(null,"init","init",-1875481434);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14544) : aqua_node.dtls_comm.from_cmd.call(null,G__14544));
})()),aqua_node.buf.new1(aqua_node.parse.role_to_int(cljs.core.first(new cljs.core.Keyword(null,"roles","roles",143379530).cljs$core$IFn$_invoke$arity$1(config)))),mk_size_and_buf(cert_file),mk_size_and_buf(key_file),mk_size_and_buf(aqua_pub),mk_size_and_buf(aqua_sec),mk_size_and_buf(aqua_id),aqua_node.buf.new2(new cljs.core.Keyword(null,"port","port",1534937262).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"aqua","aqua",745022417).cljs$core$IFn$_invoke$arity$1(config)))], 0)));
});
aqua_node.dtls_comm.send_connect = (function aqua_node$dtls_comm$send_connect(dest,cookie){
return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14546 = new cljs.core.Keyword(null,"connect-to-node","connect-to-node",-1558104516);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14546) : aqua_node.dtls_comm.from_cmd.call(null,G__14546));
})()),aqua_node.buf.new4(cookie),aqua_node.buf.new1(aqua_node.parse.role_to_int(new cljs.core.Keyword(null,"role","role",-736691072).cljs$core$IFn$_invoke$arity$1(dest))),aqua_node.buf.new$(aqua_node.parse.dest_to_tor_str(dest)),aqua_node.buf.zero,new cljs.core.Keyword(null,"srv-id","srv-id",636936260).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(dest))], 0)));
});
aqua_node.dtls_comm.send_role = (function aqua_node$dtls_comm$send_role(socket,role){

return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14548 = new cljs.core.Keyword(null,"update-role","update-role",-1683681068);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14548) : aqua_node.dtls_comm.from_cmd.call(null,G__14548));
})()),aqua_node.buf.new1(aqua_node.parse.role_to_int(role)),aqua_node.buf.new4(new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(socket))], 0)));
});
aqua_node.dtls_comm.send_new_local_udp = (function aqua_node$dtls_comm$send_new_local_udp(cookie){

return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14550 = new cljs.core.Keyword(null,"open-local-udp","open-local-udp",-420464700);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14550) : aqua_node.dtls_comm.from_cmd.call(null,G__14550));
})()),aqua_node.buf.new4(cookie)], 0)));
});
aqua_node.dtls_comm.send_update_local_udp_dest = (function aqua_node$dtls_comm$send_update_local_udp_dest(index,circ_id,direction,dest,secrets){

var message = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [aqua_node.buf.new1((function (){var G__14552 = new cljs.core.Keyword(null,"update-local-udp-dest","update-local-udp-dest",857941359);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14552) : aqua_node.dtls_comm.from_cmd.call(null,G__14552));
})()),aqua_node.buf.new4(index),aqua_node.buf.new4(circ_id)], null);
var message__$1 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(message,((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(direction,new cljs.core.Keyword(null,"in","in",-1531184865)))?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [aqua_node.buf.new1((0)),aqua_node.buf.new$(aqua_node.parse.dest_to_tor_str(dest)),aqua_node.buf.zero], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [aqua_node.buf.new1((1)),aqua_node.buf.new4(dest)], null)));
var message__$2 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(message__$1,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [aqua_node.buf.new4(cljs.core.count(secrets))], null));
var message__$3 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(message__$2,secrets);
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["sending local udp dest",direction,"using circ",circ_id,"with",cljs.core.count(cljs.core.filter.cljs$core$IFn$_invoke$arity$2(cljs.core.identity,secrets)),"secrets"], 0));

return aqua_node.dtls_comm.send_to_dtls(cljs.core.apply.cljs$core$IFn$_invoke$arity$2(aqua_node.buf.cat,message__$3));
});
aqua_node.dtls_comm.send_new_mix_fp = (function aqua_node$dtls_comm$send_new_mix_fp(circ_data_fwd,circ_data_bwd){
var fwd_secs = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__14553_SHARP_){
return new cljs.core.Keyword(null,"secret","secret",618547054).cljs$core$IFn$_invoke$arity$1(p1__14553_SHARP_);
}),new cljs.core.Keyword(null,"path","path",-188191168).cljs$core$IFn$_invoke$arity$1(circ_data_fwd));
var bwd_secs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (fwd_secs){
return (function (p1__14554_SHARP_){
return new cljs.core.Keyword(null,"secret","secret",618547054).cljs$core$IFn$_invoke$arity$1(p1__14554_SHARP_);
});})(fwd_secs))
,new cljs.core.Keyword(null,"path","path",-188191168).cljs$core$IFn$_invoke$arity$1(circ_data_bwd));
var message = new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [aqua_node.buf.new1((function (){var G__14556 = new cljs.core.Keyword(null,"new-mix-fp","new-mix-fp",441177812);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14556) : aqua_node.dtls_comm.from_cmd.call(null,G__14556));
})()),aqua_node.buf.new4(new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"forward-hop","forward-hop",-1257556924).cljs$core$IFn$_invoke$arity$1(circ_data_fwd))),aqua_node.buf.new4(new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"backward-hop","backward-hop",1523480527).cljs$core$IFn$_invoke$arity$1(circ_data_bwd))),aqua_node.buf.new4(new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(circ_data_fwd)),aqua_node.buf.new4(new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(circ_data_bwd)),aqua_node.buf.new4(cljs.core.count(fwd_secs))], null);
var message__$1 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(message,fwd_secs);
var message__$2 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(message__$1,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [aqua_node.buf.new4(cljs.core.count(bwd_secs))], null));
var message__$3 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(message__$2,bwd_secs);
return aqua_node.dtls_comm.send_to_dtls(cljs.core.apply.cljs$core$IFn$_invoke$arity$2(aqua_node.buf.cat,message__$3));
});
aqua_node.dtls_comm.send_rm_local_udp = (function aqua_node$dtls_comm$send_rm_local_udp(socket){
return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14558 = new cljs.core.Keyword(null,"rm-local-udp","rm-local-udp",-717913670);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14558) : aqua_node.dtls_comm.from_cmd.call(null,G__14558));
})()),aqua_node.buf.new4(new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(socket))], 0)));
});
aqua_node.dtls_comm.send_rm_mix_fp = (function aqua_node$dtls_comm$send_rm_mix_fp(circ_id){
return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14560 = new cljs.core.Keyword(null,"rm-mix-fp","rm-mix-fp",1608120639);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14560) : aqua_node.dtls_comm.from_cmd.call(null,G__14560));
})()),aqua_node.buf.new4(circ_id)], 0)));
});
aqua_node.dtls_comm.send_rm_node = (function aqua_node$dtls_comm$send_rm_node(socket){
return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14562 = new cljs.core.Keyword(null,"rm-node","rm-node",-1891219043);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14562) : aqua_node.dtls_comm.from_cmd.call(null,G__14562));
})()),aqua_node.buf.new4(new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(socket))], 0)));
});
aqua_node.dtls_comm.send_node_secret = (function aqua_node$dtls_comm$send_node_secret(sp_socket,shared_sec){
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["FIXM send-node-secret",sp_socket], 0));

return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14564 = new cljs.core.Keyword(null,"update-node-secret","update-node-secret",-723611096);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14564) : aqua_node.dtls_comm.from_cmd.call(null,G__14564));
})()),aqua_node.buf.new4(new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(sp_socket)),shared_sec], 0)));
});
aqua_node.dtls_comm.relay_ping = (function aqua_node$dtls_comm$relay_ping(config,circ){
return aqua_node.dtls_comm.send_to_dtls(aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__14566 = new cljs.core.Keyword(null,"ping","ping",-1670114784);
return (aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.from_cmd.cljs$core$IFn$_invoke$arity$1(G__14566) : aqua_node.dtls_comm.from_cmd.call(null,G__14566));
})()),aqua_node.buf.new4(circ)], 0)));
});
aqua_node.dtls_comm.connect = (function aqua_node$dtls_comm$connect(dest,conn_info,conn_handler,err){
var c = (function (){var G__14637 = "crypto";
return (cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1 ? cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1(G__14637) : cljs.nodejs.require.call(null,G__14637));
})();
var cookie = c.randomBytes((4)).readUInt32BE((0));
var ctrl = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
aqua_node.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["DTLS: Connecting to",cljs.core.select_keys(dest,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"host","host",-1558485167),new cljs.core.Keyword(null,"port","port",1534937262),new cljs.core.Keyword(null,"role","role",-736691072)], null)),aqua_node.buf.hx(new cljs.core.Keyword(null,"srv-id","srv-id",636936260).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(dest)))], 0));

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3(aqua_node.dtls_comm.dispatch_pub,cookie,ctrl);

var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__,c,cookie,ctrl){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__,c,cookie,ctrl){
return (function (state_14680){
var state_val_14681 = (state_14680[(1)]);
if((state_val_14681 === (7))){
var state_14680__$1 = state_14680;
var statearr_14682_14707 = state_14680__$1;
(statearr_14682_14707[(2)] = null);

(statearr_14682_14707[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (1))){
var inst_14638 = aqua_node.dtls_comm.send_connect(dest,cookie);
var state_14680__$1 = (function (){var statearr_14683 = state_14680;
(statearr_14683[(7)] = inst_14638);

return statearr_14683;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_14680__$1,(2),ctrl);
} else {
if((state_val_14681 === (4))){
var state_14680__$1 = state_14680;
if(cljs.core.truth_(conn_handler)){
var statearr_14684_14708 = state_14680__$1;
(statearr_14684_14708[(1)] = (9));

} else {
var statearr_14685_14709 = state_14680__$1;
(statearr_14685_14709[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (6))){
var inst_14647 = (state_14680[(8)]);
var inst_14654 = (function (){var G__14686 = inst_14647;
return (err.cljs$core$IFn$_invoke$arity$1 ? err.cljs$core$IFn$_invoke$arity$1(G__14686) : err.call(null,G__14686));
})();
var state_14680__$1 = state_14680;
var statearr_14687_14710 = state_14680__$1;
(statearr_14687_14710[(2)] = inst_14654);

(statearr_14687_14710[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (3))){
var inst_14643 = (state_14680[(9)]);
var inst_14652 = aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["got fail on",cookie,"/ err",inst_14643], 0));
var state_14680__$1 = (function (){var statearr_14688 = state_14680;
(statearr_14688[(10)] = inst_14652);

return statearr_14688;
})();
if(cljs.core.truth_(err)){
var statearr_14689_14711 = state_14680__$1;
(statearr_14689_14711[(1)] = (6));

} else {
var statearr_14690_14712 = state_14680__$1;
(statearr_14690_14712[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (2))){
var inst_14644 = (state_14680[(11)]);
var inst_14643 = (state_14680[(9)]);
var inst_14640 = (state_14680[(12)]);
var inst_14640__$1 = (state_14680[(2)]);
var inst_14641 = inst_14640__$1.length;
var inst_14642 = aqua_node.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([inst_14641], 0));
var inst_14643__$1 = inst_14640__$1.readUInt32BE((5));
var inst_14644__$1 = inst_14640__$1.readUInt32BE((9));
var inst_14645 = [new cljs.core.Keyword(null,"index","index",-1531685915),new cljs.core.Keyword(null,"type","type",1174270348)];
var inst_14646 = [inst_14644__$1,new cljs.core.Keyword(null,"aqua-dtls","aqua-dtls",1053269107)];
var inst_14647 = cljs.core.PersistentHashMap.fromArrays(inst_14645,inst_14646);
var inst_14648 = cljs.core.async.unsub(aqua_node.dtls_comm.dispatch_pub,cookie,ctrl);
var inst_14649 = cljs.core.async.close_BANG_(ctrl);
var inst_14650 = cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2((0),inst_14643__$1);
var state_14680__$1 = (function (){var statearr_14691 = state_14680;
(statearr_14691[(11)] = inst_14644__$1);

(statearr_14691[(13)] = inst_14642);

(statearr_14691[(9)] = inst_14643__$1);

(statearr_14691[(8)] = inst_14647);

(statearr_14691[(14)] = inst_14649);

(statearr_14691[(12)] = inst_14640__$1);

(statearr_14691[(15)] = inst_14648);

return statearr_14691;
})();
if(inst_14650){
var statearr_14692_14713 = state_14680__$1;
(statearr_14692_14713[(1)] = (3));

} else {
var statearr_14693_14714 = state_14680__$1;
(statearr_14693_14714[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (11))){
var inst_14644 = (state_14680[(11)]);
var inst_14642 = (state_14680[(13)]);
var inst_14643 = (state_14680[(9)]);
var inst_14647 = (state_14680[(8)]);
var inst_14640 = (state_14680[(12)]);
var inst_14663 = (state_14680[(2)]);
var inst_14664 = aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["got dtls-handler ok on cookie",cookie,"given node id =",inst_14644], 0));
var inst_14665 = [new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"cs","cs",-1757555990),new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"host","host",-1558485167),new cljs.core.Keyword(null,"port","port",1534937262),new cljs.core.Keyword(null,"send-fn","send-fn",351002041),new cljs.core.Keyword(null,"on-destroy","on-destroy",-248732403)];
var inst_14666 = new cljs.core.Keyword(null,"host","host",-1558485167).cljs$core$IFn$_invoke$arity$1(dest);
var inst_14667 = new cljs.core.Keyword(null,"port","port",1534937262).cljs$core$IFn$_invoke$arity$1(dest);
var inst_14668 = aqua_node.dtls_comm.mk_send_fn(inst_14647);
var inst_14669 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_14670 = (function (){var answer = inst_14640;
var _ = inst_14642;
var state = inst_14643;
var id = inst_14644;
var soc = inst_14647;
return ((function (answer,_,state,id,soc,inst_14644,inst_14642,inst_14643,inst_14647,inst_14640,inst_14663,inst_14664,inst_14665,inst_14666,inst_14667,inst_14668,inst_14669,state_val_14681,c__11552__auto__,c,cookie,ctrl){
return (function (){
return aqua_node.dtls_comm.send_rm_node(soc);
});
;})(answer,_,state,id,soc,inst_14644,inst_14642,inst_14643,inst_14647,inst_14640,inst_14663,inst_14664,inst_14665,inst_14666,inst_14667,inst_14668,inst_14669,state_val_14681,c__11552__auto__,c,cookie,ctrl))
})();
var inst_14671 = [inst_14670];
var inst_14672 = (new cljs.core.PersistentVector(null,1,(5),inst_14669,inst_14671,null));
var inst_14673 = [inst_14644,new cljs.core.Keyword(null,"client","client",-1323448117),new cljs.core.Keyword(null,"aqua","aqua",745022417),inst_14666,inst_14667,inst_14668,inst_14672];
var inst_14674 = cljs.core.PersistentHashMap.fromArrays(inst_14665,inst_14673);
var inst_14675 = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([conn_info,inst_14674], 0));
var inst_14676 = aqua_node.conns.add.cljs$core$IFn$_invoke$arity$variadic(inst_14647,cljs.core.array_seq([inst_14675], 0));
var state_14680__$1 = (function (){var statearr_14694 = state_14680;
(statearr_14694[(16)] = inst_14663);

(statearr_14694[(17)] = inst_14664);

return statearr_14694;
})();
var statearr_14695_14715 = state_14680__$1;
(statearr_14695_14715[(2)] = inst_14676);

(statearr_14695_14715[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (9))){
var inst_14660 = (function (){return (conn_handler.cljs$core$IFn$_invoke$arity$0 ? conn_handler.cljs$core$IFn$_invoke$arity$0() : conn_handler.call(null));
})();
var state_14680__$1 = state_14680;
var statearr_14696_14716 = state_14680__$1;
(statearr_14696_14716[(2)] = inst_14660);

(statearr_14696_14716[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (5))){
var inst_14678 = (state_14680[(2)]);
var state_14680__$1 = state_14680;
return cljs.core.async.impl.ioc_helpers.return_chan(state_14680__$1,inst_14678);
} else {
if((state_val_14681 === (10))){
var state_14680__$1 = state_14680;
var statearr_14697_14717 = state_14680__$1;
(statearr_14697_14717[(2)] = null);

(statearr_14697_14717[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14681 === (8))){
var inst_14657 = (state_14680[(2)]);
var state_14680__$1 = (function (){var statearr_14698 = state_14680;
(statearr_14698[(18)] = inst_14657);

return statearr_14698;
})();
var statearr_14699_14718 = state_14680__$1;
(statearr_14699_14718[(2)] = new cljs.core.Keyword(null,"fail","fail",1706214930));

(statearr_14699_14718[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto__,c,cookie,ctrl))
;
return ((function (switch__11474__auto__,c__11552__auto__,c,cookie,ctrl){
return (function() {
var aqua_node$dtls_comm$connect_$_state_machine__11475__auto__ = null;
var aqua_node$dtls_comm$connect_$_state_machine__11475__auto____0 = (function (){
var statearr_14703 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_14703[(0)] = aqua_node$dtls_comm$connect_$_state_machine__11475__auto__);

(statearr_14703[(1)] = (1));

return statearr_14703;
});
var aqua_node$dtls_comm$connect_$_state_machine__11475__auto____1 = (function (state_14680){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_14680);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e14704){if((e14704 instanceof Object)){
var ex__11478__auto__ = e14704;
var statearr_14705_14719 = state_14680;
(statearr_14705_14719[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_14680);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14704;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14720 = state_14680;
state_14680 = G__14720;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
aqua_node$dtls_comm$connect_$_state_machine__11475__auto__ = function(state_14680){
switch(arguments.length){
case 0:
return aqua_node$dtls_comm$connect_$_state_machine__11475__auto____0.call(this);
case 1:
return aqua_node$dtls_comm$connect_$_state_machine__11475__auto____1.call(this,state_14680);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
aqua_node$dtls_comm$connect_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = aqua_node$dtls_comm$connect_$_state_machine__11475__auto____0;
aqua_node$dtls_comm$connect_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = aqua_node$dtls_comm$connect_$_state_machine__11475__auto____1;
return aqua_node$dtls_comm$connect_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__,c,cookie,ctrl))
})();
var state__11554__auto__ = (function (){var statearr_14706 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_14706[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_14706;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__,c,cookie,ctrl))
);

return c__11552__auto__;
});
aqua_node.dtls_comm.process = (function aqua_node$dtls_comm$process(socket,config,buf,rinfo,dispatch_rq){
var vec__14756 = aqua_node.buf.mk_readers(buf);
var r1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14756,(0),null);
var r2 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14756,(1),null);
var r4 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14756,(2),null);
var cmd = (function (){var G__14757 = (function (){var G__14758 = (0);
return (r1.cljs$core$IFn$_invoke$arity$1 ? r1.cljs$core$IFn$_invoke$arity$1(G__14758) : r1.call(null,G__14758));
})();
return (aqua_node.dtls_comm.to_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.dtls_comm.to_cmd.cljs$core$IFn$_invoke$arity$1(G__14757) : aqua_node.dtls_comm.to_cmd.call(null,G__14757));
})();
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["recvd",cmd,"on socket",socket], 0));

var pred__14759 = cljs.core._EQ_;
var expr__14760 = cmd;
if(cljs.core.truth_((function (){var G__14762 = new cljs.core.Keyword(null,"ack","ack",-913609387);
var G__14763 = expr__14760;
return (pred__14759.cljs$core$IFn$_invoke$arity$2 ? pred__14759.cljs$core$IFn$_invoke$arity$2(G__14762,G__14763) : pred__14759.call(null,G__14762,G__14763));
})())){
var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd){
return (function (state_14769){
var state_val_14770 = (state_14769[(1)]);
if((state_val_14770 === (1))){
var inst_14764 = buf.readUInt32BE((1));
var inst_14765 = aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["FIXME: got ack with cookie",inst_14764], 0));
var state_14769__$1 = (function (){var statearr_14771 = state_14769;
(statearr_14771[(7)] = inst_14765);

return statearr_14771;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_14769__$1,(2),dispatch_rq,buf);
} else {
if((state_val_14770 === (2))){
var inst_14767 = (state_14769[(2)]);
var state_14769__$1 = state_14769;
return cljs.core.async.impl.ioc_helpers.return_chan(state_14769__$1,inst_14767);
} else {
return null;
}
}
});})(c__11552__auto__,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd))
;
return ((function (switch__11474__auto__,c__11552__auto__,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd){
return (function() {
var aqua_node$dtls_comm$process_$_state_machine__11475__auto__ = null;
var aqua_node$dtls_comm$process_$_state_machine__11475__auto____0 = (function (){
var statearr_14775 = [null,null,null,null,null,null,null,null];
(statearr_14775[(0)] = aqua_node$dtls_comm$process_$_state_machine__11475__auto__);

(statearr_14775[(1)] = (1));

return statearr_14775;
});
var aqua_node$dtls_comm$process_$_state_machine__11475__auto____1 = (function (state_14769){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_14769);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e14776){if((e14776 instanceof Object)){
var ex__11478__auto__ = e14776;
var statearr_14777_14791 = state_14769;
(statearr_14777_14791[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_14769);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14776;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14792 = state_14769;
state_14769 = G__14792;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
aqua_node$dtls_comm$process_$_state_machine__11475__auto__ = function(state_14769){
switch(arguments.length){
case 0:
return aqua_node$dtls_comm$process_$_state_machine__11475__auto____0.call(this);
case 1:
return aqua_node$dtls_comm$process_$_state_machine__11475__auto____1.call(this,state_14769);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
aqua_node$dtls_comm$process_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = aqua_node$dtls_comm$process_$_state_machine__11475__auto____0;
aqua_node$dtls_comm$process_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = aqua_node$dtls_comm$process_$_state_machine__11475__auto____1;
return aqua_node$dtls_comm$process_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd))
})();
var state__11554__auto__ = (function (){var statearr_14778 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_14778[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_14778;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd))
);

return c__11552__auto__;
} else {
if(cljs.core.truth_((function (){var G__14779 = new cljs.core.Keyword(null,"data","data",-232669377);
var G__14780 = expr__14760;
return (pred__14759.cljs$core$IFn$_invoke$arity$2 ? pred__14759.cljs$core$IFn$_invoke$arity$2(G__14779,G__14780) : pred__14759.call(null,G__14779,G__14780));
})())){
var socket_id = (function (){var G__14781 = (1);
return (r4.cljs$core$IFn$_invoke$arity$1 ? r4.cljs$core$IFn$_invoke$arity$1(G__14781) : r4.call(null,G__14781));
})();
var socket__$1 = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"index","index",-1531685915),socket_id,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"aqua-dtls","aqua-dtls",1053269107)], null);
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([new cljs.core.Keyword(null,"total-len","total-len",1835222224),buf.length], 0));

if((aqua_node.conns.get_data(socket__$1) == null)){
return aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["Got data for an invalid/unknown DTLS socket id",socket_id], 0));
} else {
var G__14782 = config;
var G__14783 = socket__$1;
var G__14784 = buf.slice((5));
return (aqua_node.dtls_comm.circ_process.cljs$core$IFn$_invoke$arity$3 ? aqua_node.dtls_comm.circ_process.cljs$core$IFn$_invoke$arity$3(G__14782,G__14783,G__14784) : aqua_node.dtls_comm.circ_process.call(null,G__14782,G__14783,G__14784));
}
} else {
if(cljs.core.truth_((function (){var G__14785 = new cljs.core.Keyword(null,"new-client","new-client",-625323755);
var G__14786 = expr__14760;
return (pred__14759.cljs$core$IFn$_invoke$arity$2 ? pred__14759.cljs$core$IFn$_invoke$arity$2(G__14785,G__14786) : pred__14759.call(null,G__14785,G__14786));
})())){
var socket_id = (function (){var G__14787 = (1);
return (r4.cljs$core$IFn$_invoke$arity$1 ? r4.cljs$core$IFn$_invoke$arity$1(G__14787) : r4.call(null,G__14787));
})();
var socket__$1 = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"index","index",-1531685915),socket_id,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"aqua-dtls","aqua-dtls",1053269107)], null);
aqua_node.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["New client on socket-id:",socket_id], 0));

return aqua_node.conns.add.cljs$core$IFn$_invoke$arity$variadic(socket__$1,cljs.core.array_seq([new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"id","id",-1388402092),socket_id,new cljs.core.Keyword(null,"cs","cs",-1757555990),new cljs.core.Keyword(null,"server","server",1499190120),new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"aqua","aqua",745022417),new cljs.core.Keyword(null,"send-fn","send-fn",351002041),aqua_node.dtls_comm.mk_send_fn(socket__$1),new cljs.core.Keyword(null,"on-destroy","on-destroy",-248732403),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [((function (socket_id,socket__$1,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd){
return (function (){
return aqua_node.dtls_comm.send_rm_node(socket__$1);
});})(socket_id,socket__$1,pred__14759,expr__14760,vec__14756,r1,r2,r4,cmd))
], null)], null)], 0));
} else {
if(cljs.core.truth_((function (){var G__14788 = new cljs.core.Keyword(null,"rm-node","rm-node",-1891219043);
var G__14789 = expr__14760;
return (pred__14759.cljs$core$IFn$_invoke$arity$2 ? pred__14759.cljs$core$IFn$_invoke$arity$2(G__14788,G__14789) : pred__14759.call(null,G__14788,G__14789));
})())){
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([new cljs.core.Keyword(null,"rm-node","rm-node",-1891219043),new cljs.core.Keyword(null,"buffer","buffer",617295198),buf.length], 0));

return null;
} else {
return aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["DTLS comm: unsupported command",cmd,(function (){var G__14790 = (0);
return (r1.cljs$core$IFn$_invoke$arity$1 ? r1.cljs$core$IFn$_invoke$arity$1(G__14790) : r1.call(null,G__14790));
})()], 0));
}
}
}
}
});
aqua_node.dtls_comm.init = (function aqua_node$dtls_comm$init(p__14798,circ_process,circ_accept){
var map__14831 = p__14798;
var map__14831__$1 = ((cljs.core.seq_QMARK_(map__14831))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__14831):map__14831);
var config = map__14831__$1;
var port = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14831__$1,new cljs.core.Keyword(null,"dtls-handler-port","dtls-handler-port",747111376));
var fixme = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14831__$1,new cljs.core.Keyword(null,"files-for-certs","files-for-certs",-1679676532));
var exec = (function (){var G__14832 = "child_process";
return (cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1 ? cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1(G__14832) : cljs.nodejs.require.call(null,G__14832));
})().exec;
var dtls_handler = (function (){var G__14833 = [cljs.core.str(new cljs.core.Keyword(null,"dtls-handler-path","dtls-handler-path",101691603).cljs$core$IFn$_invoke$arity$1(config)),cljs.core.str(" "),cljs.core.str(port)].join('');
var G__14834 = null;
var G__14835 = ((function (G__14833,G__14834,exec,map__14831,map__14831__$1,config,port,fixme){
return (function() { 
var G__14863__delegate = function (p1__14793_SHARP_,rest__14794_SHARP_){
aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["dtls-handler exited with",p1__14793_SHARP_], 0));

return aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([rest__14794_SHARP_], 0));
};
var G__14863 = function (p1__14793_SHARP_,var_args){
var rest__14794_SHARP_ = null;
if (arguments.length > 1) {
var G__14864__i = 0, G__14864__a = new Array(arguments.length -  1);
while (G__14864__i < G__14864__a.length) {G__14864__a[G__14864__i] = arguments[G__14864__i + 1]; ++G__14864__i;}
  rest__14794_SHARP_ = new cljs.core.IndexedSeq(G__14864__a,0);
} 
return G__14863__delegate.call(this,p1__14793_SHARP_,rest__14794_SHARP_);};
G__14863.cljs$lang$maxFixedArity = 1;
G__14863.cljs$lang$applyTo = (function (arglist__14865){
var p1__14793_SHARP_ = cljs.core.first(arglist__14865);
var rest__14794_SHARP_ = cljs.core.rest(arglist__14865);
return G__14863__delegate(p1__14793_SHARP_,rest__14794_SHARP_);
});
G__14863.cljs$core$IFn$_invoke$arity$variadic = G__14863__delegate;
return G__14863;
})()
;})(G__14833,G__14834,exec,map__14831,map__14831__$1,config,port,fixme))
;
return (exec.cljs$core$IFn$_invoke$arity$3 ? exec.cljs$core$IFn$_invoke$arity$3(G__14833,G__14834,G__14835) : exec.call(null,G__14833,G__14834,G__14835));
})();
var soc = (function (){var G__14836 = "dgram";
return (cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1 ? cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1(G__14836) : cljs.nodejs.require.call(null,G__14836));
})().createSocket("udp4");
var soc_ctrl = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var dispatch_rq = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
aqua_node.dtls_comm.circ_process = circ_process;

aqua_node.dtls_comm.circ_accept = circ_accept;

aqua_node.dtls_comm.dispatch_pub = cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2(dispatch_rq,((function (exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (p1__14795_SHARP_){
return p1__14795_SHARP_.readUInt32BE((1));
});})(exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
);

soc.bind((0),"127.0.0.1");

aqua_node.conns.add_listeners(soc,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"message","message",-406056002),((function (exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (p1__14796_SHARP_,p2__14797_SHARP_){
return aqua_node.dtls_comm.process(soc,config,p1__14796_SHARP_,p2__14797_SHARP_,dispatch_rq);
});})(exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
,new cljs.core.Keyword(null,"listening","listening",1028216980),((function (exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (){
var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (state_14840){
var state_val_14841 = (state_14840[(1)]);
if((state_val_14841 === (1))){
var state_14840__$1 = state_14840;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_14840__$1,(2),soc_ctrl,new cljs.core.Keyword(null,"listening","listening",1028216980));
} else {
if((state_val_14841 === (2))){
var inst_14838 = (state_14840[(2)]);
var state_14840__$1 = state_14840;
return cljs.core.async.impl.ioc_helpers.return_chan(state_14840__$1,inst_14838);
} else {
return null;
}
}
});})(c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
;
return ((function (switch__11474__auto__,c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function() {
var aqua_node$dtls_comm$init_$_state_machine__11475__auto__ = null;
var aqua_node$dtls_comm$init_$_state_machine__11475__auto____0 = (function (){
var statearr_14845 = [null,null,null,null,null,null,null];
(statearr_14845[(0)] = aqua_node$dtls_comm$init_$_state_machine__11475__auto__);

(statearr_14845[(1)] = (1));

return statearr_14845;
});
var aqua_node$dtls_comm$init_$_state_machine__11475__auto____1 = (function (state_14840){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_14840);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e14846){if((e14846 instanceof Object)){
var ex__11478__auto__ = e14846;
var statearr_14847_14866 = state_14840;
(statearr_14847_14866[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_14840);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14846;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14867 = state_14840;
state_14840 = G__14867;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
aqua_node$dtls_comm$init_$_state_machine__11475__auto__ = function(state_14840){
switch(arguments.length){
case 0:
return aqua_node$dtls_comm$init_$_state_machine__11475__auto____0.call(this);
case 1:
return aqua_node$dtls_comm$init_$_state_machine__11475__auto____1.call(this,state_14840);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
aqua_node$dtls_comm$init_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = aqua_node$dtls_comm$init_$_state_machine__11475__auto____0;
aqua_node$dtls_comm$init_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = aqua_node$dtls_comm$init_$_state_machine__11475__auto____1;
return aqua_node$dtls_comm$init_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
})();
var state__11554__auto__ = (function (){var statearr_14848 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_14848[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_14848;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
);

return c__11552__auto__;
});})(exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
,new cljs.core.Keyword(null,"error","error",-978969032),((function (exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (){
return aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["DTLS control socket error"], 0));
});})(exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
,new cljs.core.Keyword(null,"close","close",1835149582),((function (exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (){
return aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["DTLS control socket closed"], 0));
});})(exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
], null));

aqua_node.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["Started dtls handler, PID:",dtls_handler.pid,"Port:",port], 0));

aqua_node.dtls_comm.dtls_handler_socket_data = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [soc,soc_ctrl,port], null);

var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function (state_14853){
var state_val_14854 = (state_14853[(1)]);
if((state_val_14854 === (1))){
var state_14853__$1 = state_14853;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_14853__$1,(2),soc_ctrl);
} else {
if((state_val_14854 === (2))){
var inst_14850 = (state_14853[(2)]);
var inst_14851 = aqua_node.dtls_comm.send_init(config);
var state_14853__$1 = (function (){var statearr_14855 = state_14853;
(statearr_14855[(7)] = inst_14850);

return statearr_14855;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_14853__$1,inst_14851);
} else {
return null;
}
}
});})(c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
;
return ((function (switch__11474__auto__,c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme){
return (function() {
var aqua_node$dtls_comm$init_$_state_machine__11475__auto__ = null;
var aqua_node$dtls_comm$init_$_state_machine__11475__auto____0 = (function (){
var statearr_14859 = [null,null,null,null,null,null,null,null];
(statearr_14859[(0)] = aqua_node$dtls_comm$init_$_state_machine__11475__auto__);

(statearr_14859[(1)] = (1));

return statearr_14859;
});
var aqua_node$dtls_comm$init_$_state_machine__11475__auto____1 = (function (state_14853){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_14853);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e14860){if((e14860 instanceof Object)){
var ex__11478__auto__ = e14860;
var statearr_14861_14868 = state_14853;
(statearr_14861_14868[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_14853);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14860;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14869 = state_14853;
state_14853 = G__14869;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
aqua_node$dtls_comm$init_$_state_machine__11475__auto__ = function(state_14853){
switch(arguments.length){
case 0:
return aqua_node$dtls_comm$init_$_state_machine__11475__auto____0.call(this);
case 1:
return aqua_node$dtls_comm$init_$_state_machine__11475__auto____1.call(this,state_14853);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
aqua_node$dtls_comm$init_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = aqua_node$dtls_comm$init_$_state_machine__11475__auto____0;
aqua_node$dtls_comm$init_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = aqua_node$dtls_comm$init_$_state_machine__11475__auto____1;
return aqua_node$dtls_comm$init_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
})();
var state__11554__auto__ = (function (){var statearr_14862 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_14862[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_14862;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__,exec,dtls_handler,soc,soc_ctrl,dispatch_rq,map__14831,map__14831__$1,config,port,fixme))
);

return c__11552__auto__;
});
