// Compiled by ClojureScript 0.0-3211 {:static-fns true, :target :nodejs}
goog.provide('aqua_node.ntor');
goog.require('cljs.core');
goog.require('aqua_node.config');
goog.require('cljs.core');
goog.require('cljs.nodejs');
goog.require('aqua_node.crypto');
goog.require('aqua_node.buf');
aqua_node.ntor.conf = new cljs.core.Keyword(null,"ntor-values","ntor-values",-499543719).cljs$core$IFn$_invoke$arity$1(aqua_node.config.static_conf);
aqua_node.ntor.hmac = (function aqua_node$ntor$hmac(key,message){
var crypto = (function (){var G__15383 = "crypto";
return (cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1 ? cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1(G__15383) : cljs.nodejs.require.call(null,G__15383));
})();
return crypto.createHmac("sha256",key).update(message).digest();
});
aqua_node.ntor.h_mac = cljs.core.partial.cljs$core$IFn$_invoke$arity$2(aqua_node.ntor.hmac,new cljs.core.Keyword(null,"mac","mac",-1879391650).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf));
aqua_node.ntor.h_verify = cljs.core.partial.cljs$core$IFn$_invoke$arity$2(aqua_node.ntor.hmac,new cljs.core.Keyword(null,"verify","verify",-1196899752).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf));
aqua_node.ntor.expand = (function aqua_node$ntor$expand(k,n){
var prk = aqua_node.ntor.hmac(new cljs.core.Keyword(null,"t-key","t-key",1481974920).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf),k);
var info = aqua_node.buf.new$(new cljs.core.Keyword(null,"m-expand","m-expand",-1814942623).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf));
var out = aqua_node.buf.new$((0));
var prev = aqua_node.buf.new$((0));
var i = (1);
while(true){
if((out.length >= n)){
return out.slice((0),n);
} else {
var h = aqua_node.ntor.hmac(prk,aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([prev,info,aqua_node.buf.new$((new cljs.core.clj__GT_js(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [i], null))))], 0)));
var out__$1 = aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([out,h], 0));
var G__15384 = out__$1;
var G__15385 = h;
var G__15386 = (i + (1));
out = G__15384;
prev = G__15385;
i = G__15386;
continue;
}
break;
}
});
aqua_node.ntor.client_init = (function aqua_node$ntor$client_init(config,p__15387){
var map__15390 = p__15387;
var map__15390__$1 = ((cljs.core.seq_QMARK_(map__15390))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__15390):map__15390);
var auth = map__15390__$1;
var srv_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15390__$1,new cljs.core.Keyword(null,"srv-id","srv-id",636936260));
var pub_B = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15390__$1,new cljs.core.Keyword(null,"pub-B","pub-B",-343032755));
var vec__15391 = aqua_node.crypto.gen_keys(config);
var secret_x = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15391,(0),null);
var public_X = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15391,(1),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([auth,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"sec-x","sec-x",660405512),secret_x,new cljs.core.Keyword(null,"pub-X","pub-X",-1037180767),public_X], null)], 0)),aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([srv_id,pub_B,public_X], 0))], null);
});
aqua_node.ntor.server_reply = (function aqua_node$ntor$server_reply(config,p__15392,req,key_len){
var map__15399 = p__15392;
var map__15399__$1 = ((cljs.core.seq_QMARK_(map__15399))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__15399):map__15399);
var auth = map__15399__$1;
var pub_B = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15399__$1,new cljs.core.Keyword(null,"pub-B","pub-B",-343032755));
var sec_b = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15399__$1,new cljs.core.Keyword(null,"sec-b","sec-b",465631972));
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15399__$1,new cljs.core.Keyword(null,"node-id","node-id",779482292));
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(req.length,((new cljs.core.Keyword(null,"node-id-len","node-id-len",1320641217).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf) + new cljs.core.Keyword(null,"h-len","h-len",-1059201309).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)) + new cljs.core.Keyword(null,"h-len","h-len",-1059201309).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("bad client req ntor length"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,".-length",".-length",-280799999,null),new cljs.core.Symbol(null,"req","req",1314083224,null)),cljs.core.list(new cljs.core.Symbol(null,"+","+",-740910886,null),cljs.core.list(new cljs.core.Keyword(null,"node-id-len","node-id-len",1320641217),new cljs.core.Symbol(null,"conf","conf",656610243,null)),cljs.core.list(new cljs.core.Keyword(null,"h-len","h-len",-1059201309),new cljs.core.Symbol(null,"conf","conf",656610243,null)),cljs.core.list(new cljs.core.Keyword(null,"h-len","h-len",-1059201309),new cljs.core.Symbol(null,"conf","conf",656610243,null))))], 0)))].join('')));
}

var curve = (function (){var G__15401 = "curve25519";
return (cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1 ? cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1(G__15401) : cljs.nodejs.require.call(null,G__15401));
})();
var vec__15400 = aqua_node.buf.cut.cljs$core$IFn$_invoke$arity$variadic(req,cljs.core.array_seq([new cljs.core.Keyword(null,"node-id-len","node-id-len",1320641217).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf),(new cljs.core.Keyword(null,"node-id-len","node-id-len",1320641217).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf) + new cljs.core.Keyword(null,"h-len","h-len",-1059201309).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf))], 0));
var req_nid = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15400,(0),null);
var req_pub = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15400,(1),null);
var pub_X = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15400,(2),null);
if(cljs.core.truth_(aqua_node.buf.b_EQ_(req_nid,id))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("received create request with bad node-id"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(new cljs.core.Symbol("b","b=","b/b=",212711715,null),new cljs.core.Symbol(null,"req-nid","req-nid",1435795901,null),new cljs.core.Symbol(null,"id","id",252129435,null))], 0)))].join('')));
}

if(cljs.core.truth_(aqua_node.buf.b_EQ_(req_pub,pub_B))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("received create request with bad pub key"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(new cljs.core.Symbol("b","b=","b/b=",212711715,null),new cljs.core.Symbol(null,"req-pub","req-pub",-1123513536,null),new cljs.core.Symbol(null,"pub-B","pub-B",1297498772,null))], 0)))].join('')));
}

var vec__15402 = aqua_node.crypto.gen_keys(config);
var sec_y = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15402,(0),null);
var pub_Y = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15402,(1),null);
var x_y = curve.deriveSharedSecret(sec_y,pub_X);
var x_b = curve.deriveSharedSecret(sec_b,pub_X);
var secret_input = aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([x_y,x_b,id,pub_B,pub_X,pub_Y,new cljs.core.Keyword(null,"protoid","protoid",1171497196).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)], 0));
var auth_input = aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([(function (){var G__15403 = secret_input;
return (aqua_node.ntor.h_verify.cljs$core$IFn$_invoke$arity$1 ? aqua_node.ntor.h_verify.cljs$core$IFn$_invoke$arity$1(G__15403) : aqua_node.ntor.h_verify.call(null,G__15403));
})(),id,pub_B,pub_Y,pub_X,new cljs.core.Keyword(null,"protoid","protoid",1171497196).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf),new cljs.core.Keyword(null,"server","server",1499190120).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)], 0));
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [aqua_node.ntor.expand(secret_input,key_len),aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([pub_Y,(function (){var G__15404 = auth_input;
return (aqua_node.ntor.h_mac.cljs$core$IFn$_invoke$arity$1 ? aqua_node.ntor.h_mac.cljs$core$IFn$_invoke$arity$1(G__15404) : aqua_node.ntor.h_mac.call(null,G__15404));
})()], 0))], null);
});
aqua_node.ntor.client_finalise = (function aqua_node$ntor$client_finalise(p__15405,req,key_len){
var map__15411 = p__15405;
var map__15411__$1 = ((cljs.core.seq_QMARK_(map__15411))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__15411):map__15411);
var auth = map__15411__$1;
var srv_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15411__$1,new cljs.core.Keyword(null,"srv-id","srv-id",636936260));
var pub_B = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15411__$1,new cljs.core.Keyword(null,"pub-B","pub-B",-343032755));
var pub_X = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15411__$1,new cljs.core.Keyword(null,"pub-X","pub-X",-1037180767));
var sec_x = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__15411__$1,new cljs.core.Keyword(null,"sec-x","sec-x",660405512));
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(req.length,(new cljs.core.Keyword(null,"g-len","g-len",-649878423).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf) + new cljs.core.Keyword(null,"h-len","h-len",-1059201309).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("bad server req ntor length"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,".-length",".-length",-280799999,null),new cljs.core.Symbol(null,"req","req",1314083224,null)),cljs.core.list(new cljs.core.Symbol(null,"+","+",-740910886,null),cljs.core.list(new cljs.core.Keyword(null,"g-len","g-len",-649878423),new cljs.core.Symbol(null,"conf","conf",656610243,null)),cljs.core.list(new cljs.core.Keyword(null,"h-len","h-len",-1059201309),new cljs.core.Symbol(null,"conf","conf",656610243,null))))], 0)))].join('')));
}

var curve = (function (){var G__15413 = "curve25519";
return (cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1 ? cljs.nodejs.require.cljs$core$IFn$_invoke$arity$1(G__15413) : cljs.nodejs.require.call(null,G__15413));
})();
var vec__15412 = aqua_node.buf.cut.cljs$core$IFn$_invoke$arity$variadic(req,cljs.core.array_seq([new cljs.core.Keyword(null,"g-len","g-len",-649878423).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)], 0));
var pub_Y = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15412,(0),null);
var srv_auth = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__15412,(1),null);
var x_y = curve.deriveSharedSecret(sec_x,pub_Y);
var x_b = curve.deriveSharedSecret(sec_x,pub_B);
var secret_input = aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([x_y,x_b,srv_id,pub_B,pub_X,pub_Y,new cljs.core.Keyword(null,"protoid","protoid",1171497196).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)], 0));
var auth__$1 = (function (){var G__15414 = aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([(function (){var G__15415 = secret_input;
return (aqua_node.ntor.h_verify.cljs$core$IFn$_invoke$arity$1 ? aqua_node.ntor.h_verify.cljs$core$IFn$_invoke$arity$1(G__15415) : aqua_node.ntor.h_verify.call(null,G__15415));
})(),srv_id,pub_B,pub_Y,pub_X,new cljs.core.Keyword(null,"protoid","protoid",1171497196).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf),new cljs.core.Keyword(null,"server","server",1499190120).cljs$core$IFn$_invoke$arity$1(aqua_node.ntor.conf)], 0));
return (aqua_node.ntor.h_mac.cljs$core$IFn$_invoke$arity$1 ? aqua_node.ntor.h_mac.cljs$core$IFn$_invoke$arity$1(G__15414) : aqua_node.ntor.h_mac.call(null,G__15414));
})();
if(cljs.core.truth_(aqua_node.buf.b_EQ_(auth__$1,srv_auth))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("mismatching auth"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(new cljs.core.Symbol("b","b=","b/b=",212711715,null),new cljs.core.Symbol(null,"auth","auth",-1264680843,null),new cljs.core.Symbol(null,"srv-auth","srv-auth",-109707753,null))], 0)))].join('')));
}

return aqua_node.ntor.expand(secret_input,key_len);
});
