// Compiled by ClojureScript 0.0-3211 {:static-fns true, :target :nodejs}
goog.provide('aqua_node.parse');
goog.require('cljs.core');
goog.require('aqua_node.log');
goog.require('cljs.core');
goog.require('clojure.walk');
goog.require('cljs.nodejs');
goog.require('aqua_node.buf');
aqua_node.parse.ip4_to_bin = (function aqua_node$parse$ip4_to_bin(ip){

var re = /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/;
return aqua_node.buf.new$(cljs.core.clj__GT_js(cljs.core.next(ip.match(re))));
});
aqua_node.parse.ip6_to_bin = (function aqua_node$parse$ip6_to_bin(ip){
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("FIXME"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([null], 0)))].join('')));

});
aqua_node.parse.port_to_bin = (function aqua_node$parse$port_to_bin(port){

var p = aqua_node.buf.new$((2));
p.writeUInt16BE(port,(0));

return p;
});
aqua_node.parse.ip4_to_str = (function aqua_node$parse$ip4_to_str(buf4){

return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.str,cljs.core.interpose.cljs$core$IFn$_invoke$arity$2(".",cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__14363_SHARP_){
return buf4.readUInt8(p1__14363_SHARP_);
}),cljs.core.range.cljs$core$IFn$_invoke$arity$2((0),(4)))));
});
aqua_node.parse.ip6_to_str = (function aqua_node$parse$ip6_to_str(buf16){

return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.str,cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,cljs.core.interpose.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [":"], null),cljs.core.partition.cljs$core$IFn$_invoke$arity$2((4),buf16.toString("hex")))));
});
aqua_node.parse.dest_to_tor_str = (function aqua_node$parse$dest_to_tor_str(p__14364){
var map__14366 = p__14364;
var map__14366__$1 = ((cljs.core.seq_QMARK_(map__14366))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__14366):map__14366);
var proto = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14366__$1,new cljs.core.Keyword(null,"proto","proto",811784976));
var host = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14366__$1,new cljs.core.Keyword(null,"host","host",-1558485167));
var port = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14366__$1,new cljs.core.Keyword(null,"port","port",1534937262));
var type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14366__$1,new cljs.core.Keyword(null,"type","type",1174270348));

var host__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(type,new cljs.core.Keyword(null,"ip6","ip6",173144629)))?[cljs.core.str("["),cljs.core.str(host),cljs.core.str("]")].join(''):host);
return [cljs.core.str(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"udp","udp",-1470533806),proto))?"u":"t")),cljs.core.str(":"),cljs.core.str(host__$1),cljs.core.str(":"),cljs.core.str(port)].join('');
});
aqua_node.parse.parse_addr = (function aqua_node$parse$parse_addr(buf){

var z = cljs.core.some(cljs.core.identity,cljs.core.doall.cljs$core$IFn$_invoke$arity$1(cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__14367_SHARP_){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((0),buf.readUInt8(p1__14367_SHARP_))){
return p1__14367_SHARP_;
} else {
return null;
}
}),cljs.core.range.cljs$core$IFn$_invoke$arity$1(buf.length))));
if(cljs.core.truth_(z)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("bad buffer: no zero delimiter"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([new cljs.core.Symbol(null,"z","z",851004344,null)], 0)))].join('')));
}

var str = buf.toString("ascii",(0),z);
var ip4_re = /^([utr]):((\d+\.){3}\d+):(\d+)$/;
var ip6_re = /^([utr]):\[((\d|[a-fA-F]|:)+)\]:(\d+)$/;
var dns_re = /^([utr]):(.*):(\d+)$/;
var re = ((function (str,ip4_re,ip6_re,dns_re,z){
return (function() { 
var G__14393__delegate = function (p1__14369_SHARP_,p2__14368_SHARP_,rest__14370_SHARP_){
var res = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(p2__14368_SHARP_.match(p1__14369_SHARP_));
return cljs.core.doall.cljs$core$IFn$_invoke$arity$1(cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.nth,res),rest__14370_SHARP_));
};
var G__14393 = function (p1__14369_SHARP_,p2__14368_SHARP_,var_args){
var rest__14370_SHARP_ = null;
if (arguments.length > 2) {
var G__14394__i = 0, G__14394__a = new Array(arguments.length -  2);
while (G__14394__i < G__14394__a.length) {G__14394__a[G__14394__i] = arguments[G__14394__i + 2]; ++G__14394__i;}
  rest__14370_SHARP_ = new cljs.core.IndexedSeq(G__14394__a,0);
} 
return G__14393__delegate.call(this,p1__14369_SHARP_,p2__14368_SHARP_,rest__14370_SHARP_);};
G__14393.cljs$lang$maxFixedArity = 2;
G__14393.cljs$lang$applyTo = (function (arglist__14395){
var p1__14369_SHARP_ = cljs.core.first(arglist__14395);
arglist__14395 = cljs.core.next(arglist__14395);
var p2__14368_SHARP_ = cljs.core.first(arglist__14395);
var rest__14370_SHARP_ = cljs.core.rest(arglist__14395);
return G__14393__delegate(p1__14369_SHARP_,p2__14368_SHARP_,rest__14370_SHARP_);
});
G__14393.cljs$core$IFn$_invoke$arity$variadic = G__14393__delegate;
return G__14393;
})()
;})(str,ip4_re,ip6_re,dns_re,z))
;
var vec__14382 = cljs.core.first(cljs.core.doall.cljs$core$IFn$_invoke$arity$1(cljs.core.filter.cljs$core$IFn$_invoke$arity$2(cljs.core.second,cljs.core.map.cljs$core$IFn$_invoke$arity$3(cljs.core.cons,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ip4","ip4",980997778),new cljs.core.Keyword(null,"ip6","ip6",173144629),new cljs.core.Keyword(null,"dns","dns",-922767306)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [re.cljs$core$IFn$_invoke$arity$variadic(ip4_re,str,cljs.core.array_seq([(1),(2),(4)], 0)),re.cljs$core$IFn$_invoke$arity$variadic(ip6_re,str,cljs.core.array_seq([(1),(2),(4)], 0)),re.cljs$core$IFn$_invoke$arity$variadic(dns_re,str,cljs.core.array_seq([(1),(2),(3)], 0))], null)))));
var ip = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14382,(0),null);
var prot = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14382,(1),null);
var h = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14382,(2),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__14382,(3),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"proto","proto",811784976),(function (){var pred__14383 = cljs.core._EQ_;
var expr__14384 = prot;
if(cljs.core.truth_((function (){var G__14386 = "u";
var G__14387 = expr__14384;
return (pred__14383.cljs$core$IFn$_invoke$arity$2 ? pred__14383.cljs$core$IFn$_invoke$arity$2(G__14386,G__14387) : pred__14383.call(null,G__14386,G__14387));
})())){
return new cljs.core.Keyword(null,"udp","udp",-1470533806);
} else {
if(cljs.core.truth_((function (){var G__14388 = "t";
var G__14389 = expr__14384;
return (pred__14383.cljs$core$IFn$_invoke$arity$2 ? pred__14383.cljs$core$IFn$_invoke$arity$2(G__14388,G__14389) : pred__14383.call(null,G__14388,G__14389));
})())){
return new cljs.core.Keyword(null,"tcp","tcp",-827447003);
} else {
if(cljs.core.truth_((function (){var G__14390 = "r";
var G__14391 = expr__14384;
return (pred__14383.cljs$core$IFn$_invoke$arity$2 ? pred__14383.cljs$core$IFn$_invoke$arity$2(G__14390,G__14391) : pred__14383.call(null,G__14390,G__14391));
})())){
return new cljs.core.Keyword(null,"rtp","rtp",-2009461645);
} else {
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(expr__14384)].join('')));
}
}
}
})(),new cljs.core.Keyword(null,"type","type",1174270348),ip,new cljs.core.Keyword(null,"host","host",-1558485167),h,new cljs.core.Keyword(null,"port","port",1534937262),(function (){var G__14392 = p;
return parseInt(G__14392);
})()], null),buf.slice((z + (1)))], null);
});
aqua_node.parse.role_to_int = (function aqua_node$parse$role_to_int(role){
var pred__14413 = cljs.core._EQ_;
var expr__14414 = role;
if(cljs.core.truth_((function (){var G__14416 = new cljs.core.Keyword(null,"app-proxy","app-proxy",661280637);
var G__14417 = expr__14414;
return (pred__14413.cljs$core$IFn$_invoke$arity$2 ? pred__14413.cljs$core$IFn$_invoke$arity$2(G__14416,G__14417) : pred__14413.call(null,G__14416,G__14417));
})())){
return (0);
} else {
if(cljs.core.truth_((function (){var G__14418 = new cljs.core.Keyword(null,"mix","mix",480842236);
var G__14419 = expr__14414;
return (pred__14413.cljs$core$IFn$_invoke$arity$2 ? pred__14413.cljs$core$IFn$_invoke$arity$2(G__14418,G__14419) : pred__14413.call(null,G__14418,G__14419));
})())){
return (1);
} else {
if(cljs.core.truth_((function (){var G__14420 = new cljs.core.Keyword(null,"sip-dir","sip-dir",-1717000071);
var G__14421 = expr__14414;
return (pred__14413.cljs$core$IFn$_invoke$arity$2 ? pred__14413.cljs$core$IFn$_invoke$arity$2(G__14420,G__14421) : pred__14413.call(null,G__14420,G__14421));
})())){
return (2);
} else {
if(cljs.core.truth_((function (){var G__14422 = new cljs.core.Keyword(null,"rdv","rdv",2145065332);
var G__14423 = expr__14414;
return (pred__14413.cljs$core$IFn$_invoke$arity$2 ? pred__14413.cljs$core$IFn$_invoke$arity$2(G__14422,G__14423) : pred__14413.call(null,G__14422,G__14423));
})())){
return (3);
} else {
if(cljs.core.truth_((function (){var G__14424 = new cljs.core.Keyword(null,"super-peer","super-peer",-2110985144);
var G__14425 = expr__14414;
return (pred__14413.cljs$core$IFn$_invoke$arity$2 ? pred__14413.cljs$core$IFn$_invoke$arity$2(G__14424,G__14425) : pred__14413.call(null,G__14424,G__14425));
})())){
return (4);
} else {
if(cljs.core.truth_((function (){var G__14426 = new cljs.core.Keyword(null,"app-proxy-dummy","app-proxy-dummy",-1543457257);
var G__14427 = expr__14414;
return (pred__14413.cljs$core$IFn$_invoke$arity$2 ? pred__14413.cljs$core$IFn$_invoke$arity$2(G__14426,G__14427) : pred__14413.call(null,G__14426,G__14427));
})())){
return (5);
} else {
if(cljs.core.truth_((function (){var G__14428 = new cljs.core.Keyword(null,"dir","dir",1734754661);
var G__14429 = expr__14414;
return (pred__14413.cljs$core$IFn$_invoke$arity$2 ? pred__14413.cljs$core$IFn$_invoke$arity$2(G__14428,G__14429) : pred__14413.call(null,G__14428,G__14429));
})())){
return (6);
} else {
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(expr__14414)].join('')));
}
}
}
}
}
}
}
});
aqua_node.parse.int_to_role = (function aqua_node$parse$int_to_role(role){
var pred__14447 = cljs.core._EQ_;
var expr__14448 = role;
if(cljs.core.truth_((function (){var G__14450 = (0);
var G__14451 = expr__14448;
return (pred__14447.cljs$core$IFn$_invoke$arity$2 ? pred__14447.cljs$core$IFn$_invoke$arity$2(G__14450,G__14451) : pred__14447.call(null,G__14450,G__14451));
})())){
return new cljs.core.Keyword(null,"app-proxy","app-proxy",661280637);
} else {
if(cljs.core.truth_((function (){var G__14452 = (1);
var G__14453 = expr__14448;
return (pred__14447.cljs$core$IFn$_invoke$arity$2 ? pred__14447.cljs$core$IFn$_invoke$arity$2(G__14452,G__14453) : pred__14447.call(null,G__14452,G__14453));
})())){
return new cljs.core.Keyword(null,"mix","mix",480842236);
} else {
if(cljs.core.truth_((function (){var G__14454 = (2);
var G__14455 = expr__14448;
return (pred__14447.cljs$core$IFn$_invoke$arity$2 ? pred__14447.cljs$core$IFn$_invoke$arity$2(G__14454,G__14455) : pred__14447.call(null,G__14454,G__14455));
})())){
return new cljs.core.Keyword(null,"sip-dir","sip-dir",-1717000071);
} else {
if(cljs.core.truth_((function (){var G__14456 = (3);
var G__14457 = expr__14448;
return (pred__14447.cljs$core$IFn$_invoke$arity$2 ? pred__14447.cljs$core$IFn$_invoke$arity$2(G__14456,G__14457) : pred__14447.call(null,G__14456,G__14457));
})())){
return new cljs.core.Keyword(null,"rdv","rdv",2145065332);
} else {
if(cljs.core.truth_((function (){var G__14458 = (4);
var G__14459 = expr__14448;
return (pred__14447.cljs$core$IFn$_invoke$arity$2 ? pred__14447.cljs$core$IFn$_invoke$arity$2(G__14458,G__14459) : pred__14447.call(null,G__14458,G__14459));
})())){
return new cljs.core.Keyword(null,"super-peer","super-peer",-2110985144);
} else {
if(cljs.core.truth_((function (){var G__14460 = (5);
var G__14461 = expr__14448;
return (pred__14447.cljs$core$IFn$_invoke$arity$2 ? pred__14447.cljs$core$IFn$_invoke$arity$2(G__14460,G__14461) : pred__14447.call(null,G__14460,G__14461));
})())){
return new cljs.core.Keyword(null,"app-proxy-dummy","app-proxy-dummy",-1543457257);
} else {
if(cljs.core.truth_((function (){var G__14462 = (6);
var G__14463 = expr__14448;
return (pred__14447.cljs$core$IFn$_invoke$arity$2 ? pred__14447.cljs$core$IFn$_invoke$arity$2(G__14462,G__14463) : pred__14447.call(null,G__14462,G__14463));
})())){
return new cljs.core.Keyword(null,"dir","dir",1734754661);
} else {
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(expr__14448)].join('')));
}
}
}
}
}
}
}
});
aqua_node.parse.int_to_ack = (function aqua_node$parse$int_to_ack(ack){
var pred__14471 = cljs.core._EQ_;
var expr__14472 = ack;
if(cljs.core.truth_((function (){var G__14474 = new cljs.core.Keyword(null,"ok","ok",967785236);
var G__14475 = expr__14472;
return (pred__14471.cljs$core$IFn$_invoke$arity$2 ? pred__14471.cljs$core$IFn$_invoke$arity$2(G__14474,G__14475) : pred__14471.call(null,G__14474,G__14475));
})())){
return (0);
} else {
if(cljs.core.truth_((function (){var G__14476 = new cljs.core.Keyword(null,"fail","fail",1706214930);
var G__14477 = expr__14472;
return (pred__14471.cljs$core$IFn$_invoke$arity$2 ? pred__14471.cljs$core$IFn$_invoke$arity$2(G__14476,G__14477) : pred__14471.call(null,G__14476,G__14477));
})())){
return (1);
} else {
return null;
}
}
});
aqua_node.parse.ack_to_int = (function aqua_node$parse$ack_to_int(ack){
var pred__14485 = cljs.core._EQ_;
var expr__14486 = ack;
if(cljs.core.truth_((function (){var G__14488 = (0);
var G__14489 = expr__14486;
return (pred__14485.cljs$core$IFn$_invoke$arity$2 ? pred__14485.cljs$core$IFn$_invoke$arity$2(G__14488,G__14489) : pred__14485.call(null,G__14488,G__14489));
})())){
return new cljs.core.Keyword(null,"ok","ok",967785236);
} else {
if(cljs.core.truth_((function (){var G__14490 = (1);
var G__14491 = expr__14486;
return (pred__14485.cljs$core$IFn$_invoke$arity$2 ? pred__14485.cljs$core$IFn$_invoke$arity$2(G__14490,G__14491) : pred__14485.call(null,G__14490,G__14491));
})())){
return new cljs.core.Keyword(null,"fail","fail",1706214930);
} else {
return null;
}
}
});
aqua_node.parse.to_clj = (function aqua_node$parse$to_clj(js_map){

return clojure.walk.keywordize_keys(cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(js_map));
});
aqua_node.parse.to_js = (function aqua_node$parse$to_js(clj_map){

return cljs.core.clj__GT_js(clojure.walk.stringify_keys(clj_map));
});
