// Compiled by ClojureScript 0.0-3211 {:static-fns true, :target :nodejs}
goog.provide('aqua_node.sip_dir');
goog.require('cljs.core');
goog.require('aqua_node.sip_helpers');
goog.require('aqua_node.circ');
goog.require('aqua_node.log');
goog.require('aqua_node.conn_mgr');
goog.require('cljs.core');
goog.require('aqua_node.path');
goog.require('aqua_node.conns');
goog.require('aqua_node.dir');
goog.require('clojure.walk');
goog.require('aqua_node.parse');
goog.require('cljs.core.async');
goog.require('cljs.nodejs');
goog.require('aqua_node.buf');
aqua_node.sip_dir.dir = (function (){var G__21300 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__21300) : cljs.core.atom.call(null,G__21300));
})();
aqua_node.sip_dir.rm = (function aqua_node$sip_dir$rm(name){

return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(aqua_node.sip_dir.dir,cljs.core.dissoc,name);
});
aqua_node.sip_dir.register = (function aqua_node$sip_dir$register(config,name,out_rdv_id,rdv_cid,rdv_id){

var cmd = aqua_node.buf.new1((function (){var G__21302 = new cljs.core.Keyword(null,"register","register",1968522516);
return (aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1(G__21302) : aqua_node.sip_helpers.from_cmd.call(null,G__21302));
})());
var rdv_b = aqua_node.buf.new4(rdv_cid);
var name_b = aqua_node.buf.new$(name);
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP: registering",name,"on RDV circ:",rdv_cid,"RDV ID:",aqua_node.buf.hx(rdv_id)], 0));

return aqua_node.circ.relay_sip(config,out_rdv_id,new cljs.core.Keyword(null,"f-enc","f-enc",-1817353431),aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cmd,rdv_b,rdv_id,name_b], 0)));
});
aqua_node.sip_dir.query = (function aqua_node$sip_dir$query(config,name,rdv_id,call_id){

var cmd = aqua_node.buf.new1((function (){var G__21304 = new cljs.core.Keyword(null,"query","query",-1288509510);
return (aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1(G__21304) : aqua_node.sip_helpers.from_cmd.call(null,G__21304));
})());
var name_b = aqua_node.buf.new$(name);
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP: querying for",name,"on RDV",rdv_id], 0));

return aqua_node.circ.relay_sip(config,rdv_id,new cljs.core.Keyword(null,"f-enc","f-enc",-1817353431),aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cmd,aqua_node.buf.new$(call_id),aqua_node.buf.zero,name_b], 0)));
});
aqua_node.sip_dir.mk_query_reply = (function aqua_node$sip_dir$mk_query_reply(name,dir,call_id){
var temp__4404__auto__ = (function (){var G__21307 = dir;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__21307) : cljs.core.deref.call(null,G__21307));
})().call(null,name);
if(cljs.core.truth_(temp__4404__auto__)){
var entry = temp__4404__auto__;
var cmd = aqua_node.buf.new1((function (){var G__21308 = new cljs.core.Keyword(null,"query-reply","query-reply",-1649184487);
return (aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1(G__21308) : aqua_node.sip_helpers.from_cmd.call(null,G__21308));
})());
return aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cmd,aqua_node.buf.new$(call_id),aqua_node.buf.zero,aqua_node.buf.new4(new cljs.core.Keyword(null,"rdv-cid","rdv-cid",-868358016).cljs$core$IFn$_invoke$arity$1(entry)),new cljs.core.Keyword(null,"rdv-id","rdv-id",1879551157).cljs$core$IFn$_invoke$arity$1(entry)], 0));
} else {
return null;
}
});
aqua_node.sip_dir.create_dir = (function aqua_node$sip_dir$create_dir(config){

var sip_chan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var node_id_len = new cljs.core.Keyword(null,"node-id-len","node-id-len",1320641217).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"ntor-values","ntor-values",-499543719).cljs$core$IFn$_invoke$arity$1(config));
var p_register = ((function (sip_chan,node_id_len){
return (function (p__21375){
var map__21376 = p__21375;
var map__21376__$1 = ((cljs.core.seq_QMARK_(map__21376))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21376):map__21376);
var rq = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21376__$1,new cljs.core.Keyword(null,"sip-rq","sip-rq",512321652));
var rdv_cid = rq.readUInt32BE((1));
var rdv_id = rq.slice((5),(node_id_len + (5)));
var name = rq.slice((node_id_len + (5))).toString();
var timeout_id = (function (){var G__21377 = ((function (rdv_cid,rdv_id,name,map__21376,map__21376__$1,rq,sip_chan,node_id_len){
return (function (){
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR: timeout for",name], 0));

return aqua_node.sip_dir.rm(name);
});})(rdv_cid,rdv_id,name,map__21376,map__21376__$1,rq,sip_chan,node_id_len))
;
var G__21378 = new cljs.core.Keyword(null,"sip-register-interval","sip-register-interval",1282680300).cljs$core$IFn$_invoke$arity$1(config);
return setTimeout(G__21377,G__21378);
})();
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR, registering",name,"on RDV circ-id:",rdv_cid,"RDV ID:",aqua_node.buf.hx(rdv_id)], 0));

if(cljs.core.truth_((function (){var G__21379 = aqua_node.sip_dir.dir;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__21379) : cljs.core.deref.call(null,G__21379));
})().call(null,name))){
var G__21380_21441 = new cljs.core.Keyword(null,"timeout","timeout",-318625318).cljs$core$IFn$_invoke$arity$1((function (){var G__21381 = aqua_node.sip_dir.dir;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__21381) : cljs.core.deref.call(null,G__21381));
})().call(null,name));
clearTimeout(G__21380_21441);
} else {
}

return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(aqua_node.sip_dir.dir,cljs.core.merge,new cljs.core.PersistentArrayMap.fromArray([name,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"rdv-cid","rdv-cid",-868358016),rdv_cid,new cljs.core.Keyword(null,"rdv-id","rdv-id",1879551157),rdv_id,new cljs.core.Keyword(null,"timeout","timeout",-318625318),timeout_id], null)], true, false));
});})(sip_chan,node_id_len))
;
var p_query = ((function (sip_chan,node_id_len,p_register){
return (function (p__21382){
var map__21383 = p__21382;
var map__21383__$1 = ((cljs.core.seq_QMARK_(map__21383))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21383):map__21383);
var circ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21383__$1,new cljs.core.Keyword(null,"circ-id","circ-id",-1158925161));
var rq = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21383__$1,new cljs.core.Keyword(null,"sip-rq","sip-rq",512321652));
var vec__21384 = aqua_node.sip_helpers.get_call_id(rq);
var call_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21384,(0),null);
var name = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21384,(1),null);
var name__$1 = name.toString();
var reply = aqua_node.sip_dir.mk_query_reply(name__$1,aqua_node.sip_dir.dir,call_id);
if(cljs.core.truth_(reply)){
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR, query for",name__$1], 0));

return aqua_node.circ.relay_sip(config,circ,new cljs.core.Keyword(null,"b-enc","b-enc",-1200559977),reply);
} else {
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR, could not find",name__$1], 0));

return aqua_node.circ.relay_sip(config,circ,new cljs.core.Keyword(null,"b-enc","b-enc",-1200559977),aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__21385 = new cljs.core.Keyword(null,"error","error",-978969032);
return (aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1(G__21385) : aqua_node.sip_helpers.from_cmd.call(null,G__21385));
})()),aqua_node.buf.new$(call_id),aqua_node.buf.zero,aqua_node.buf.new$("404")], 0)));
}
});})(sip_chan,node_id_len,p_register))
;
var c__11552__auto___21442 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___21442,sip_chan,node_id_len,p_register,p_query){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___21442,sip_chan,node_id_len,p_register,p_query){
return (function (state_21416){
var state_val_21417 = (state_21416[(1)]);
if((state_val_21417 === (7))){
var inst_21409 = (state_21416[(2)]);
var state_21416__$1 = (function (){var statearr_21418 = state_21416;
(statearr_21418[(7)] = inst_21409);

return statearr_21418;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_21416__$1,(11),sip_chan);
} else {
if((state_val_21417 === (1))){
var state_21416__$1 = state_21416;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_21416__$1,(2),sip_chan);
} else {
if((state_val_21417 === (4))){
var inst_21414 = (state_21416[(2)]);
var state_21416__$1 = state_21416;
return cljs.core.async.impl.ioc_helpers.return_chan(state_21416__$1,inst_21414);
} else {
if((state_val_21417 === (6))){
var inst_21395 = (state_21416[(8)]);
var inst_21400 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"query","query",-1288509510),inst_21395);
var state_21416__$1 = state_21416;
if(inst_21400){
var statearr_21419_21443 = state_21416__$1;
(statearr_21419_21443[(1)] = (8));

} else {
var statearr_21420_21444 = state_21416__$1;
(statearr_21420_21444[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21417 === (3))){
var inst_21388 = (state_21416[(9)]);
var inst_21395 = (state_21416[(8)]);
var inst_21391 = (state_21416[(10)]);
var inst_21390 = new cljs.core.Keyword(null,"sip-rq","sip-rq",512321652).cljs$core$IFn$_invoke$arity$1(inst_21388);
var inst_21391__$1 = inst_21390.readUInt8((0));
var inst_21395__$1 = (function (){var G__21421 = inst_21391__$1;
return (aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1(G__21421) : aqua_node.sip_helpers.to_cmd.call(null,G__21421));
})();
var inst_21396 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"register","register",1968522516),inst_21395__$1);
var state_21416__$1 = (function (){var statearr_21422 = state_21416;
(statearr_21422[(8)] = inst_21395__$1);

(statearr_21422[(10)] = inst_21391__$1);

return statearr_21422;
})();
if(inst_21396){
var statearr_21423_21445 = state_21416__$1;
(statearr_21423_21445[(1)] = (5));

} else {
var statearr_21424_21446 = state_21416__$1;
(statearr_21424_21446[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21417 === (2))){
var inst_21387 = (state_21416[(2)]);
var inst_21388 = inst_21387;
var state_21416__$1 = (function (){var statearr_21425 = state_21416;
(statearr_21425[(9)] = inst_21388);

return statearr_21425;
})();
var statearr_21426_21447 = state_21416__$1;
(statearr_21426_21447[(2)] = null);

(statearr_21426_21447[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21417 === (11))){
var inst_21411 = (state_21416[(2)]);
var inst_21388 = inst_21411;
var state_21416__$1 = (function (){var statearr_21427 = state_21416;
(statearr_21427[(9)] = inst_21388);

return statearr_21427;
})();
var statearr_21428_21448 = state_21416__$1;
(statearr_21428_21448[(2)] = null);

(statearr_21428_21448[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21417 === (9))){
var inst_21391 = (state_21416[(10)]);
var inst_21404 = (function (){var G__21429 = inst_21391;
return (aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1(G__21429) : aqua_node.sip_helpers.to_cmd.call(null,G__21429));
})();
var inst_21405 = aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR, received unknown command",inst_21404,inst_21391], 0));
var state_21416__$1 = state_21416;
var statearr_21430_21449 = state_21416__$1;
(statearr_21430_21449[(2)] = inst_21405);

(statearr_21430_21449[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21417 === (5))){
var inst_21388 = (state_21416[(9)]);
var inst_21398 = p_register(inst_21388);
var state_21416__$1 = state_21416;
var statearr_21431_21450 = state_21416__$1;
(statearr_21431_21450[(2)] = inst_21398);

(statearr_21431_21450[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21417 === (10))){
var inst_21407 = (state_21416[(2)]);
var state_21416__$1 = state_21416;
var statearr_21432_21451 = state_21416__$1;
(statearr_21432_21451[(2)] = inst_21407);

(statearr_21432_21451[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21417 === (8))){
var inst_21388 = (state_21416[(9)]);
var inst_21402 = p_query(inst_21388);
var state_21416__$1 = state_21416;
var statearr_21433_21452 = state_21416__$1;
(statearr_21433_21452[(2)] = inst_21402);

(statearr_21433_21452[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___21442,sip_chan,node_id_len,p_register,p_query))
;
return ((function (switch__11474__auto__,c__11552__auto___21442,sip_chan,node_id_len,p_register,p_query){
return (function() {
var aqua_node$sip_dir$create_dir_$_state_machine__11475__auto__ = null;
var aqua_node$sip_dir$create_dir_$_state_machine__11475__auto____0 = (function (){
var statearr_21437 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_21437[(0)] = aqua_node$sip_dir$create_dir_$_state_machine__11475__auto__);

(statearr_21437[(1)] = (1));

return statearr_21437;
});
var aqua_node$sip_dir$create_dir_$_state_machine__11475__auto____1 = (function (state_21416){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_21416);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e21438){if((e21438 instanceof Object)){
var ex__11478__auto__ = e21438;
var statearr_21439_21453 = state_21416;
(statearr_21439_21453[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_21416);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e21438;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__21454 = state_21416;
state_21416 = G__21454;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
aqua_node$sip_dir$create_dir_$_state_machine__11475__auto__ = function(state_21416){
switch(arguments.length){
case 0:
return aqua_node$sip_dir$create_dir_$_state_machine__11475__auto____0.call(this);
case 1:
return aqua_node$sip_dir$create_dir_$_state_machine__11475__auto____1.call(this,state_21416);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
aqua_node$sip_dir$create_dir_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = aqua_node$sip_dir$create_dir_$_state_machine__11475__auto____0;
aqua_node$sip_dir$create_dir_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = aqua_node$sip_dir$create_dir_$_state_machine__11475__auto____1;
return aqua_node$sip_dir$create_dir_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___21442,sip_chan,node_id_len,p_register,p_query))
})();
var state__11554__auto__ = (function (){var statearr_21440 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_21440[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___21442);

return statearr_21440;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___21442,sip_chan,node_id_len,p_register,p_query))
);


return sip_chan;
});
aqua_node.sip_dir.mix_dir = (function (){var G__21455 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__21455) : cljs.core.atom.call(null,G__21455));
})();
aqua_node.sip_dir.create_mix_dir = (function aqua_node$sip_dir$create_mix_dir(config){

var sip_chan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var p_register = ((function (sip_chan){
return (function (p__21538){
var map__21539 = p__21538;
var map__21539__$1 = ((cljs.core.seq_QMARK_(map__21539))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21539):map__21539);
var rq = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21539__$1,new cljs.core.Keyword(null,"sip-rq","sip-rq",512321652));
var vec__21540 = aqua_node.parse.parse_addr(rq.slice((1)));
var client_dest = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21540,(0),null);
var rq__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21540,(1),null);
var vec__21541 = aqua_node.buf.cut_at_null_byte(rq__$1);
var name = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21541,(0),null);
var rq__$2 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21541,(1),null);
var name__$1 = name.toString();
var vec__21542 = aqua_node.buf.cut.cljs$core$IFn$_invoke$arity$variadic(rq__$2,cljs.core.array_seq([new cljs.core.Keyword(null,"node-id-len","node-id-len",1320641217).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"ntor-values","ntor-values",-499543719).cljs$core$IFn$_invoke$arity$1(config))], 0));
var id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21542,(0),null);
var pub = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21542,(1),null);
var timeout_id = (function (){var G__21543 = ((function (vec__21540,client_dest,rq__$1,vec__21541,name,rq__$2,name__$1,vec__21542,id,pub,map__21539,map__21539__$1,rq,sip_chan){
return (function (){
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR: timeout for",name__$1], 0));

return aqua_node.sip_dir.rm(name__$1);
});})(vec__21540,client_dest,rq__$1,vec__21541,name,rq__$2,name__$1,vec__21542,id,pub,map__21539,map__21539__$1,rq,sip_chan))
;
var G__21544 = new cljs.core.Keyword(null,"sip-register-interval","sip-register-interval",1282680300).cljs$core$IFn$_invoke$arity$1(config);
return setTimeout(G__21543,G__21544);
})();
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP MIX DIR, registering",name__$1,"dest:",client_dest], 0));

if(cljs.core.truth_((function (){var G__21545 = aqua_node.sip_dir.mix_dir;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__21545) : cljs.core.deref.call(null,G__21545));
})().call(null,name__$1))){
var G__21546_21620 = new cljs.core.Keyword(null,"timeout","timeout",-318625318).cljs$core$IFn$_invoke$arity$1((function (){var G__21547 = aqua_node.sip_dir.mix_dir;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__21547) : cljs.core.deref.call(null,G__21547));
})().call(null,name__$1));
clearTimeout(G__21546_21620);
} else {
}

return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(aqua_node.sip_dir.mix_dir,cljs.core.merge,new cljs.core.PersistentArrayMap.fromArray([name__$1,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"dest","dest",-34569477),client_dest,new cljs.core.Keyword(null,"state","state",-1988618099),new cljs.core.Keyword(null,"inactive","inactive",-306247616),new cljs.core.Keyword(null,"auth","auth",1389754926),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pub-B","pub-B",-343032755),pub,new cljs.core.Keyword(null,"srv-id","srv-id",636936260),id], null)], null)], true, false));
});})(sip_chan))
;
var p_extend = ((function (sip_chan,p_register){
return (function (p__21548){
var map__21549 = p__21548;
var map__21549__$1 = ((cljs.core.seq_QMARK_(map__21549))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21549):map__21549);
var circ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21549__$1,new cljs.core.Keyword(null,"circ-id","circ-id",-1158925161));
var rq = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21549__$1,new cljs.core.Keyword(null,"sip-rq","sip-rq",512321652));
aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["This shouldn't be called any more. what are you doing?"], 0));

var vec__21550 = aqua_node.sip_helpers.get_call_id(rq);
var call_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21550,(0),null);
var name = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21550,(1),null);
var name__$1 = name.toString();
var reply = aqua_node.sip_dir.mk_query_reply(name__$1,aqua_node.sip_dir.mix_dir,call_id);
if(cljs.core.truth_(reply)){
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR, query for",name__$1], 0));

return aqua_node.circ.relay_sip(config,circ,new cljs.core.Keyword(null,"b-enc","b-enc",-1200559977),reply);
} else {
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP DIR, could not find",name__$1], 0));

return aqua_node.circ.relay_sip(config,circ,new cljs.core.Keyword(null,"b-enc","b-enc",-1200559977),aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([aqua_node.buf.new1((function (){var G__21551 = new cljs.core.Keyword(null,"error","error",-978969032);
return (aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1(G__21551) : aqua_node.sip_helpers.from_cmd.call(null,G__21551));
})()),aqua_node.buf.new$(call_id),aqua_node.buf.zero,aqua_node.buf.new$("404")], 0)));
}
});})(sip_chan,p_register))
;
var p_relay_invite = ((function (sip_chan,p_register,p_extend){
return (function (p__21552){
var map__21553 = p__21552;
var map__21553__$1 = ((cljs.core.seq_QMARK_(map__21553))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21553):map__21553);
var rq = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21553__$1,new cljs.core.Keyword(null,"sip-rq","sip-rq",512321652));
var vec__21554 = aqua_node.sip_helpers.get_call_id(rq);
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21554,(0),null);
var data = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21554,(1),null);
var rdv_id = data.readUInt32BE((0));
if(cljs.core.truth_(aqua_node.circ.get_data(rdv_id))){
return aqua_node.circ.relay_sip(config,rdv_id,new cljs.core.Keyword(null,"b-enc","b-enc",-1200559977),rq);
} else {
return null;
}
});})(sip_chan,p_register,p_extend))
;
var c__11552__auto___21621 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___21621,sip_chan,p_register,p_extend,p_relay_invite){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___21621,sip_chan,p_register,p_extend,p_relay_invite){
return (function (state_21591){
var state_val_21592 = (state_21591[(1)]);
if((state_val_21592 === (7))){
var inst_21584 = (state_21591[(2)]);
var state_21591__$1 = (function (){var statearr_21593 = state_21591;
(statearr_21593[(7)] = inst_21584);

return statearr_21593;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_21591__$1,(14),sip_chan);
} else {
if((state_val_21592 === (1))){
var state_21591__$1 = state_21591;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_21591__$1,(2),sip_chan);
} else {
if((state_val_21592 === (4))){
var inst_21589 = (state_21591[(2)]);
var state_21591__$1 = state_21591;
return cljs.core.async.impl.ioc_helpers.return_chan(state_21591__$1,inst_21589);
} else {
if((state_val_21592 === (13))){
var inst_21580 = (state_21591[(2)]);
var state_21591__$1 = state_21591;
var statearr_21594_21622 = state_21591__$1;
(statearr_21594_21622[(2)] = inst_21580);

(statearr_21594_21622[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (6))){
var inst_21564 = (state_21591[(8)]);
var inst_21569 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"extend","extend",1836484006),inst_21564);
var state_21591__$1 = state_21591;
if(inst_21569){
var statearr_21595_21623 = state_21591__$1;
(statearr_21595_21623[(1)] = (8));

} else {
var statearr_21596_21624 = state_21591__$1;
(statearr_21596_21624[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (3))){
var inst_21560 = (state_21591[(9)]);
var inst_21564 = (state_21591[(8)]);
var inst_21557 = (state_21591[(10)]);
var inst_21559 = new cljs.core.Keyword(null,"sip-rq","sip-rq",512321652).cljs$core$IFn$_invoke$arity$1(inst_21557);
var inst_21560__$1 = inst_21559.readUInt8((0));
var inst_21564__$1 = (function (){var G__21597 = inst_21560__$1;
return (aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1(G__21597) : aqua_node.sip_helpers.to_cmd.call(null,G__21597));
})();
var inst_21565 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"register-to-mix","register-to-mix",721776763),inst_21564__$1);
var state_21591__$1 = (function (){var statearr_21598 = state_21591;
(statearr_21598[(9)] = inst_21560__$1);

(statearr_21598[(8)] = inst_21564__$1);

return statearr_21598;
})();
if(inst_21565){
var statearr_21599_21625 = state_21591__$1;
(statearr_21599_21625[(1)] = (5));

} else {
var statearr_21600_21626 = state_21591__$1;
(statearr_21600_21626[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (12))){
var inst_21560 = (state_21591[(9)]);
var inst_21577 = (function (){var G__21601 = inst_21560;
return (aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.to_cmd.cljs$core$IFn$_invoke$arity$1(G__21601) : aqua_node.sip_helpers.to_cmd.call(null,G__21601));
})();
var inst_21578 = aqua_node.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP MIX DIR, received unknown command",inst_21577,inst_21560], 0));
var state_21591__$1 = state_21591;
var statearr_21602_21627 = state_21591__$1;
(statearr_21602_21627[(2)] = inst_21578);

(statearr_21602_21627[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (2))){
var inst_21556 = (state_21591[(2)]);
var inst_21557 = inst_21556;
var state_21591__$1 = (function (){var statearr_21603 = state_21591;
(statearr_21603[(10)] = inst_21557);

return statearr_21603;
})();
var statearr_21604_21628 = state_21591__$1;
(statearr_21604_21628[(2)] = null);

(statearr_21604_21628[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (11))){
var inst_21557 = (state_21591[(10)]);
var inst_21575 = p_relay_invite(inst_21557);
var state_21591__$1 = state_21591;
var statearr_21605_21629 = state_21591__$1;
(statearr_21605_21629[(2)] = inst_21575);

(statearr_21605_21629[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (9))){
var inst_21564 = (state_21591[(8)]);
var inst_21573 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"invite","invite",126355381),inst_21564);
var state_21591__$1 = state_21591;
if(inst_21573){
var statearr_21606_21630 = state_21591__$1;
(statearr_21606_21630[(1)] = (11));

} else {
var statearr_21607_21631 = state_21591__$1;
(statearr_21607_21631[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (5))){
var inst_21557 = (state_21591[(10)]);
var inst_21567 = p_register(inst_21557);
var state_21591__$1 = state_21591;
var statearr_21608_21632 = state_21591__$1;
(statearr_21608_21632[(2)] = inst_21567);

(statearr_21608_21632[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (14))){
var inst_21586 = (state_21591[(2)]);
var inst_21557 = inst_21586;
var state_21591__$1 = (function (){var statearr_21609 = state_21591;
(statearr_21609[(10)] = inst_21557);

return statearr_21609;
})();
var statearr_21610_21633 = state_21591__$1;
(statearr_21610_21633[(2)] = null);

(statearr_21610_21633[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (10))){
var inst_21582 = (state_21591[(2)]);
var state_21591__$1 = state_21591;
var statearr_21611_21634 = state_21591__$1;
(statearr_21611_21634[(2)] = inst_21582);

(statearr_21611_21634[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_21592 === (8))){
var inst_21557 = (state_21591[(10)]);
var inst_21571 = p_extend(inst_21557);
var state_21591__$1 = state_21591;
var statearr_21612_21635 = state_21591__$1;
(statearr_21612_21635[(2)] = inst_21571);

(statearr_21612_21635[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___21621,sip_chan,p_register,p_extend,p_relay_invite))
;
return ((function (switch__11474__auto__,c__11552__auto___21621,sip_chan,p_register,p_extend,p_relay_invite){
return (function() {
var aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto__ = null;
var aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto____0 = (function (){
var statearr_21616 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_21616[(0)] = aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto__);

(statearr_21616[(1)] = (1));

return statearr_21616;
});
var aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto____1 = (function (state_21591){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_21591);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e21617){if((e21617 instanceof Object)){
var ex__11478__auto__ = e21617;
var statearr_21618_21636 = state_21591;
(statearr_21618_21636[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_21591);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e21617;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__21637 = state_21591;
state_21591 = G__21637;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto__ = function(state_21591){
switch(arguments.length){
case 0:
return aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto____0.call(this);
case 1:
return aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto____1.call(this,state_21591);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto____0;
aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto____1;
return aqua_node$sip_dir$create_mix_dir_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___21621,sip_chan,p_register,p_extend,p_relay_invite))
})();
var state__11554__auto__ = (function (){var statearr_21619 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_21619[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___21621);

return statearr_21619;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___21621,sip_chan,p_register,p_extend,p_relay_invite))
);


return sip_chan;
});
aqua_node.sip_dir.register_to_mix = (function aqua_node$sip_dir$register_to_mix(config,name,circ_id){

var cmd = aqua_node.buf.new1((function (){var G__21639 = new cljs.core.Keyword(null,"register-to-mix","register-to-mix",721776763);
return (aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1 ? aqua_node.sip_helpers.from_cmd.cljs$core$IFn$_invoke$arity$1(G__21639) : aqua_node.sip_helpers.from_cmd.call(null,G__21639));
})());
var dest = aqua_node.buf.new$(aqua_node.parse.dest_to_tor_str(new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"host","host",-1558485167),new cljs.core.Keyword(null,"external-ip","external-ip",-923718526).cljs$core$IFn$_invoke$arity$1(config),new cljs.core.Keyword(null,"port","port",1534937262),(0),new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"ip4","ip4",980997778),new cljs.core.Keyword(null,"proto","proto",811784976),new cljs.core.Keyword(null,"udp","udp",-1470533806)], null)));
var name_b = aqua_node.buf.new$(name);
aqua_node.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["SIP: registering",name,"on mix",circ_id], 0));

return aqua_node.circ.relay_sip(config,circ_id,new cljs.core.Keyword(null,"f-enc","f-enc",-1817353431),aqua_node.buf.cat.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cmd,dest,aqua_node.buf.zero,name_b,aqua_node.buf.zero,new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"aqua-id","aqua-id",-1107267730).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(config))),new cljs.core.Keyword(null,"pub","pub",-1189143908).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"aqua-id","aqua-id",-1107267730).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(config)))], 0)));
});
