// Compiled by ClojureScript 0.0-3211 {:static-fns true, :target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(f){
if(typeof cljs.core.async.t34611 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t34611 = (function (fn_handler,f,meta34612){
this.fn_handler = fn_handler;
this.f = f;
this.meta34612 = meta34612;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t34611.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34613,meta34612__$1){
var self__ = this;
var _34613__$1 = this;
return (new cljs.core.async.t34611(self__.fn_handler,self__.f,meta34612__$1));
});

cljs.core.async.t34611.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34613){
var self__ = this;
var _34613__$1 = this;
return self__.meta34612;
});

cljs.core.async.t34611.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t34611.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t34611.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t34611.cljs$lang$type = true;

cljs.core.async.t34611.cljs$lang$ctorStr = "cljs.core.async/t34611";

cljs.core.async.t34611.cljs$lang$ctorPrWriter = (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t34611");
});

cljs.core.async.__GT_t34611 = (function cljs$core$async$fn_handler_$___GT_t34611(fn_handler__$1,f__$1,meta34612){
return (new cljs.core.async.t34611(fn_handler__$1,f__$1,meta34612));
});

}

return (new cljs.core.async.t34611(cljs$core$async$fn_handler,f,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 * val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 * buffered, but oldest elements in buffer will be dropped (not
 * transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full.
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
var G__34615 = buff;
if(G__34615){
var bit__4945__auto__ = null;
if(cljs.core.truth_((function (){var or__4271__auto__ = bit__4945__auto__;
if(cljs.core.truth_(or__4271__auto__)){
return or__4271__auto__;
} else {
return G__34615.cljs$core$async$impl$protocols$UnblockingBuffer$;
}
})())){
return true;
} else {
if((!G__34615.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,G__34615);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,G__34615);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 * (filter p) etc or a composition thereof), and an optional exception handler.
 * If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 * transducer is supplied a buffer must be specified. ex-handler must be a
 * fn of one argument - if an exception occurs during transformation it will be called
 * with the thrown value as an argument, and any non-nil return value will be placed
 * in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(){
var G__34617 = arguments.length;
switch (G__34617) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([new cljs.core.Symbol(null,"buf-or-n","buf-or-n",-1646815050,null)], 0)))].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;
/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 * return nil if closed. Will park if nothing is available.
 * Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(){
var G__34620 = arguments.length;
switch (G__34620) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler(fn1));
if(cljs.core.truth_(ret)){
var val_34625 = (function (){var G__34621 = ret;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__34621) : cljs.core.deref.call(null,G__34621));
})();
if(cljs.core.truth_(on_caller_QMARK_)){
var G__34622_34626 = val_34625;
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(G__34622_34626) : fn1.call(null,G__34622_34626));
} else {
cljs.core.async.impl.dispatch.run(((function (val_34625,ret){
return (function (){
var G__34623 = val_34625;
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(G__34623) : fn1.call(null,G__34623));
});})(val_34625,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;
cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 * inside a (go ...) block. Will park if no buffer space is available.
 * Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(){
var G__34628 = arguments.length;
switch (G__34628) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4402__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4402__auto__)){
var ret = temp__4402__auto__;
var G__34629 = ret;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__34629) : cljs.core.deref.call(null,G__34629));
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4402__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler(fn1));
if(cljs.core.truth_(temp__4402__auto__)){
var retb = temp__4402__auto__;
var ret = (function (){var G__34630 = retb;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__34630) : cljs.core.deref.call(null,G__34630));
})();
if(cljs.core.truth_(on_caller_QMARK_)){
var G__34631_34634 = ret;
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(G__34631_34634) : fn1.call(null,G__34631_34634));
} else {
cljs.core.async.impl.dispatch.run(((function (ret,retb,temp__4402__auto__){
return (function (){
var G__34632 = ret;
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(G__34632) : fn1.call(null,G__34632));
});})(ret,retb,temp__4402__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;
cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__5156__auto___34635 = n;
var x_34636 = (0);
while(true){
if((x_34636 < n__5156__auto___34635)){
(a[x_34636] = (0));

var G__34637 = (x_34636 + (1));
x_34636 = G__34637;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(i,n)){
return a;
} else {
var j = cljs.core.rand_int(i);
(a[i] = (a[j]));

(a[j] = i);

var G__34638 = (i + (1));
i = G__34638;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = (function (){var G__34646 = true;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__34646) : cljs.core.atom.call(null,G__34646));
})();
if(typeof cljs.core.async.t34647 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t34647 = (function (alt_flag,flag,meta34648){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta34648 = meta34648;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t34647.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_34649,meta34648__$1){
var self__ = this;
var _34649__$1 = this;
return (new cljs.core.async.t34647(self__.alt_flag,self__.flag,meta34648__$1));
});})(flag))
;

cljs.core.async.t34647.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_34649){
var self__ = this;
var _34649__$1 = this;
return self__.meta34648;
});})(flag))
;

cljs.core.async.t34647.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t34647.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__34650 = self__.flag;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__34650) : cljs.core.deref.call(null,G__34650));
});})(flag))
;

cljs.core.async.t34647.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__34651_34653 = self__.flag;
var G__34652_34654 = null;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__34651_34653,G__34652_34654) : cljs.core.reset_BANG_.call(null,G__34651_34653,G__34652_34654));

return true;
});})(flag))
;

cljs.core.async.t34647.cljs$lang$type = true;

cljs.core.async.t34647.cljs$lang$ctorStr = "cljs.core.async/t34647";

cljs.core.async.t34647.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t34647");
});})(flag))
;

cljs.core.async.__GT_t34647 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t34647(alt_flag__$1,flag__$1,meta34648){
return (new cljs.core.async.t34647(alt_flag__$1,flag__$1,meta34648));
});})(flag))
;

}

return (new cljs.core.async.t34647(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t34658 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t34658 = (function (alt_handler,flag,cb,meta34659){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta34659 = meta34659;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t34658.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34660,meta34659__$1){
var self__ = this;
var _34660__$1 = this;
return (new cljs.core.async.t34658(self__.alt_handler,self__.flag,self__.cb,meta34659__$1));
});

cljs.core.async.t34658.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34660){
var self__ = this;
var _34660__$1 = this;
return self__.meta34659;
});

cljs.core.async.t34658.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t34658.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
});

cljs.core.async.t34658.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
});

cljs.core.async.t34658.cljs$lang$type = true;

cljs.core.async.t34658.cljs$lang$ctorStr = "cljs.core.async/t34658";

cljs.core.async.t34658.cljs$lang$ctorPrWriter = (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t34658");
});

cljs.core.async.__GT_t34658 = (function cljs$core$async$alt_handler_$___GT_t34658(alt_handler__$1,flag__$1,cb__$1,meta34659){
return (new cljs.core.async.t34658(alt_handler__$1,flag__$1,cb__$1,meta34659));
});

}

return (new cljs.core.async.t34658(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(function (){var G__34668 = (0);
return (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1(G__34668) : port.call(null,G__34668));
})():null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (function (){var G__34669 = (1);
return (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1(G__34669) : port.call(null,G__34669));
})();
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__34661_SHARP_){
var G__34670 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__34661_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__34670) : fret.call(null,G__34670));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__34662_SHARP_){
var G__34671 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__34662_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__34671) : fret.call(null,G__34671));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(function (){var G__34672 = vbox;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__34672) : cljs.core.deref.call(null,G__34672));
})(),(function (){var or__4271__auto__ = wport;
if(cljs.core.truth_(or__4271__auto__)){
return or__4271__auto__;
} else {
return port;
}
})()], null));
} else {
var G__34673 = (i + (1));
i = G__34673;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4271__auto__ = ret;
if(cljs.core.truth_(or__4271__auto__)){
return or__4271__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4404__auto__ = (function (){var and__4259__auto__ = cljs.core.async.impl.protocols.active_QMARK_(flag);
if(cljs.core.truth_(and__4259__auto__)){
return cljs.core.async.impl.protocols.commit(flag);
} else {
return and__4259__auto__;
}
})();
if(cljs.core.truth_(temp__4404__auto__)){
var got = temp__4404__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 * [channel-to-put-to val-to-put], in any combination. Takes will be
 * made as if by <!, and puts will be made as if by >!. Unless
 * the :priority option is true, if more than one port operation is
 * ready a non-deterministic choice will be made. If no operation is
 * ready and a :default value is supplied, [default-val :default] will
 * be returned, otherwise alts! will park until the first operation to
 * become ready completes. Returns [val port] of the completed
 * operation, where val is the value taken for takes, and a
 * boolean (true unless already closed, as per put!) for puts.
 * 
 * opts are passed as :key val ... Supported options:
 * 
 * :default val - the value to use if none of the operations are immediately ready
 * :priority true - (default nil) when true, the operations will be tried in order.
 * 
 * Note: there is no guarantee that the port exps or val exprs will be
 * used, nor in what order should they be, so they should not be
 * depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(){
var argseq__5311__auto__ = ((((1) < arguments.length))?(new cljs.core.IndexedSeq(Array.prototype.slice.call(arguments,(1)),(0))):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5311__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__34676){
var map__34677 = p__34676;
var map__34677__$1 = ((cljs.core.seq_QMARK_(map__34677))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__34677):map__34677);
var opts = map__34677__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq34674){
var G__34675 = cljs.core.first(seq34674);
var seq34674__$1 = cljs.core.next(seq34674);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__34675,seq34674__$1);
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(){
var G__34679 = arguments.length;
switch (G__34679) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__11552__auto___34728 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___34728){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___34728){
return (function (state_34703){
var state_val_34704 = (state_34703[(1)]);
if((state_val_34704 === (7))){
var inst_34699 = (state_34703[(2)]);
var state_34703__$1 = state_34703;
var statearr_34705_34729 = state_34703__$1;
(statearr_34705_34729[(2)] = inst_34699);

(statearr_34705_34729[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (1))){
var state_34703__$1 = state_34703;
var statearr_34706_34730 = state_34703__$1;
(statearr_34706_34730[(2)] = null);

(statearr_34706_34730[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (4))){
var inst_34682 = (state_34703[(7)]);
var inst_34682__$1 = (state_34703[(2)]);
var inst_34683 = (inst_34682__$1 == null);
var state_34703__$1 = (function (){var statearr_34707 = state_34703;
(statearr_34707[(7)] = inst_34682__$1);

return statearr_34707;
})();
if(cljs.core.truth_(inst_34683)){
var statearr_34708_34731 = state_34703__$1;
(statearr_34708_34731[(1)] = (5));

} else {
var statearr_34709_34732 = state_34703__$1;
(statearr_34709_34732[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (13))){
var state_34703__$1 = state_34703;
var statearr_34710_34733 = state_34703__$1;
(statearr_34710_34733[(2)] = null);

(statearr_34710_34733[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (6))){
var inst_34682 = (state_34703[(7)]);
var state_34703__$1 = state_34703;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_34703__$1,(11),to,inst_34682);
} else {
if((state_val_34704 === (3))){
var inst_34701 = (state_34703[(2)]);
var state_34703__$1 = state_34703;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34703__$1,inst_34701);
} else {
if((state_val_34704 === (12))){
var state_34703__$1 = state_34703;
var statearr_34711_34734 = state_34703__$1;
(statearr_34711_34734[(2)] = null);

(statearr_34711_34734[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (2))){
var state_34703__$1 = state_34703;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34703__$1,(4),from);
} else {
if((state_val_34704 === (11))){
var inst_34692 = (state_34703[(2)]);
var state_34703__$1 = state_34703;
if(cljs.core.truth_(inst_34692)){
var statearr_34712_34735 = state_34703__$1;
(statearr_34712_34735[(1)] = (12));

} else {
var statearr_34713_34736 = state_34703__$1;
(statearr_34713_34736[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (9))){
var state_34703__$1 = state_34703;
var statearr_34714_34737 = state_34703__$1;
(statearr_34714_34737[(2)] = null);

(statearr_34714_34737[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (5))){
var state_34703__$1 = state_34703;
if(cljs.core.truth_(close_QMARK_)){
var statearr_34715_34738 = state_34703__$1;
(statearr_34715_34738[(1)] = (8));

} else {
var statearr_34716_34739 = state_34703__$1;
(statearr_34716_34739[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (14))){
var inst_34697 = (state_34703[(2)]);
var state_34703__$1 = state_34703;
var statearr_34717_34740 = state_34703__$1;
(statearr_34717_34740[(2)] = inst_34697);

(statearr_34717_34740[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (10))){
var inst_34689 = (state_34703[(2)]);
var state_34703__$1 = state_34703;
var statearr_34718_34741 = state_34703__$1;
(statearr_34718_34741[(2)] = inst_34689);

(statearr_34718_34741[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34704 === (8))){
var inst_34686 = cljs.core.async.close_BANG_(to);
var state_34703__$1 = state_34703;
var statearr_34719_34742 = state_34703__$1;
(statearr_34719_34742[(2)] = inst_34686);

(statearr_34719_34742[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___34728))
;
return ((function (switch__11474__auto__,c__11552__auto___34728){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_34723 = [null,null,null,null,null,null,null,null];
(statearr_34723[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_34723[(1)] = (1));

return statearr_34723;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_34703){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_34703);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e34724){if((e34724 instanceof Object)){
var ex__11478__auto__ = e34724;
var statearr_34725_34743 = state_34703;
(statearr_34725_34743[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_34703);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e34724;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__34744 = state_34703;
state_34703 = G__34744;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_34703){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_34703);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___34728))
})();
var state__11554__auto__ = (function (){var statearr_34726 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_34726[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___34728);

return statearr_34726;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___34728))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;
cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(new cljs.core.Symbol(null,"pos?","pos?",-244377722,null),new cljs.core.Symbol(null,"n","n",-2092305744,null))], 0)))].join('')));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process = ((function (jobs,results){
return (function (p__34930){
var vec__34931 = p__34930;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__34931,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__34931,(1),null);
var job = vec__34931;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__11552__auto___35115 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___35115,res,vec__34931,v,p,job,jobs,results){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___35115,res,vec__34931,v,p,job,jobs,results){
return (function (state_34936){
var state_val_34937 = (state_34936[(1)]);
if((state_val_34937 === (1))){
var state_34936__$1 = state_34936;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_34936__$1,(2),res,v);
} else {
if((state_val_34937 === (2))){
var inst_34933 = (state_34936[(2)]);
var inst_34934 = cljs.core.async.close_BANG_(res);
var state_34936__$1 = (function (){var statearr_34938 = state_34936;
(statearr_34938[(7)] = inst_34933);

return statearr_34938;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_34936__$1,inst_34934);
} else {
return null;
}
}
});})(c__11552__auto___35115,res,vec__34931,v,p,job,jobs,results))
;
return ((function (switch__11474__auto__,c__11552__auto___35115,res,vec__34931,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0 = (function (){
var statearr_34942 = [null,null,null,null,null,null,null,null];
(statearr_34942[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__);

(statearr_34942[(1)] = (1));

return statearr_34942;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1 = (function (state_34936){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_34936);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e34943){if((e34943 instanceof Object)){
var ex__11478__auto__ = e34943;
var statearr_34944_35116 = state_34936;
(statearr_34944_35116[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_34936);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e34943;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35117 = state_34936;
state_34936 = G__35117;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = function(state_34936){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1.call(this,state_34936);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___35115,res,vec__34931,v,p,job,jobs,results))
})();
var state__11554__auto__ = (function (){var statearr_34945 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_34945[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___35115);

return statearr_34945;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___35115,res,vec__34931,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__34946){
var vec__34947 = p__34946;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__34947,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__34947,(1),null);
var job = vec__34947;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var G__34948_35118 = v;
var G__34949_35119 = res;
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(G__34948_35118,G__34949_35119) : xf.call(null,G__34948_35118,G__34949_35119));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results,process))
;
var n__5156__auto___35120 = n;
var __35121 = (0);
while(true){
if((__35121 < n__5156__auto___35120)){
var G__34950_35122 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__34950_35122) {
case "compute":
var c__11552__auto___35124 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__35121,c__11552__auto___35124,G__34950_35122,n__5156__auto___35120,jobs,results,process,async){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (__35121,c__11552__auto___35124,G__34950_35122,n__5156__auto___35120,jobs,results,process,async){
return (function (state_34963){
var state_val_34964 = (state_34963[(1)]);
if((state_val_34964 === (1))){
var state_34963__$1 = state_34963;
var statearr_34965_35125 = state_34963__$1;
(statearr_34965_35125[(2)] = null);

(statearr_34965_35125[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34964 === (2))){
var state_34963__$1 = state_34963;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34963__$1,(4),jobs);
} else {
if((state_val_34964 === (3))){
var inst_34961 = (state_34963[(2)]);
var state_34963__$1 = state_34963;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34963__$1,inst_34961);
} else {
if((state_val_34964 === (4))){
var inst_34953 = (state_34963[(2)]);
var inst_34954 = process(inst_34953);
var state_34963__$1 = state_34963;
if(cljs.core.truth_(inst_34954)){
var statearr_34966_35126 = state_34963__$1;
(statearr_34966_35126[(1)] = (5));

} else {
var statearr_34967_35127 = state_34963__$1;
(statearr_34967_35127[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34964 === (5))){
var state_34963__$1 = state_34963;
var statearr_34968_35128 = state_34963__$1;
(statearr_34968_35128[(2)] = null);

(statearr_34968_35128[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34964 === (6))){
var state_34963__$1 = state_34963;
var statearr_34969_35129 = state_34963__$1;
(statearr_34969_35129[(2)] = null);

(statearr_34969_35129[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34964 === (7))){
var inst_34959 = (state_34963[(2)]);
var state_34963__$1 = state_34963;
var statearr_34970_35130 = state_34963__$1;
(statearr_34970_35130[(2)] = inst_34959);

(statearr_34970_35130[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__35121,c__11552__auto___35124,G__34950_35122,n__5156__auto___35120,jobs,results,process,async))
;
return ((function (__35121,switch__11474__auto__,c__11552__auto___35124,G__34950_35122,n__5156__auto___35120,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0 = (function (){
var statearr_34974 = [null,null,null,null,null,null,null];
(statearr_34974[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__);

(statearr_34974[(1)] = (1));

return statearr_34974;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1 = (function (state_34963){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_34963);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e34975){if((e34975 instanceof Object)){
var ex__11478__auto__ = e34975;
var statearr_34976_35131 = state_34963;
(statearr_34976_35131[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_34963);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e34975;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35132 = state_34963;
state_34963 = G__35132;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = function(state_34963){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1.call(this,state_34963);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__;
})()
;})(__35121,switch__11474__auto__,c__11552__auto___35124,G__34950_35122,n__5156__auto___35120,jobs,results,process,async))
})();
var state__11554__auto__ = (function (){var statearr_34977 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_34977[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___35124);

return statearr_34977;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(__35121,c__11552__auto___35124,G__34950_35122,n__5156__auto___35120,jobs,results,process,async))
);


break;
case "async":
var c__11552__auto___35133 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__35121,c__11552__auto___35133,G__34950_35122,n__5156__auto___35120,jobs,results,process,async){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (__35121,c__11552__auto___35133,G__34950_35122,n__5156__auto___35120,jobs,results,process,async){
return (function (state_34990){
var state_val_34991 = (state_34990[(1)]);
if((state_val_34991 === (1))){
var state_34990__$1 = state_34990;
var statearr_34992_35134 = state_34990__$1;
(statearr_34992_35134[(2)] = null);

(statearr_34992_35134[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34991 === (2))){
var state_34990__$1 = state_34990;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_34990__$1,(4),jobs);
} else {
if((state_val_34991 === (3))){
var inst_34988 = (state_34990[(2)]);
var state_34990__$1 = state_34990;
return cljs.core.async.impl.ioc_helpers.return_chan(state_34990__$1,inst_34988);
} else {
if((state_val_34991 === (4))){
var inst_34980 = (state_34990[(2)]);
var inst_34981 = async(inst_34980);
var state_34990__$1 = state_34990;
if(cljs.core.truth_(inst_34981)){
var statearr_34993_35135 = state_34990__$1;
(statearr_34993_35135[(1)] = (5));

} else {
var statearr_34994_35136 = state_34990__$1;
(statearr_34994_35136[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34991 === (5))){
var state_34990__$1 = state_34990;
var statearr_34995_35137 = state_34990__$1;
(statearr_34995_35137[(2)] = null);

(statearr_34995_35137[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34991 === (6))){
var state_34990__$1 = state_34990;
var statearr_34996_35138 = state_34990__$1;
(statearr_34996_35138[(2)] = null);

(statearr_34996_35138[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_34991 === (7))){
var inst_34986 = (state_34990[(2)]);
var state_34990__$1 = state_34990;
var statearr_34997_35139 = state_34990__$1;
(statearr_34997_35139[(2)] = inst_34986);

(statearr_34997_35139[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__35121,c__11552__auto___35133,G__34950_35122,n__5156__auto___35120,jobs,results,process,async))
;
return ((function (__35121,switch__11474__auto__,c__11552__auto___35133,G__34950_35122,n__5156__auto___35120,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0 = (function (){
var statearr_35001 = [null,null,null,null,null,null,null];
(statearr_35001[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__);

(statearr_35001[(1)] = (1));

return statearr_35001;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1 = (function (state_34990){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_34990);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e35002){if((e35002 instanceof Object)){
var ex__11478__auto__ = e35002;
var statearr_35003_35140 = state_34990;
(statearr_35003_35140[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_34990);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e35002;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35141 = state_34990;
state_34990 = G__35141;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = function(state_34990){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1.call(this,state_34990);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__;
})()
;})(__35121,switch__11474__auto__,c__11552__auto___35133,G__34950_35122,n__5156__auto___35120,jobs,results,process,async))
})();
var state__11554__auto__ = (function (){var statearr_35004 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_35004[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___35133);

return statearr_35004;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(__35121,c__11552__auto___35133,G__34950_35122,n__5156__auto___35120,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__35142 = (__35121 + (1));
__35121 = G__35142;
continue;
} else {
}
break;
}

var c__11552__auto___35143 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___35143,jobs,results,process,async){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___35143,jobs,results,process,async){
return (function (state_35026){
var state_val_35027 = (state_35026[(1)]);
if((state_val_35027 === (1))){
var state_35026__$1 = state_35026;
var statearr_35028_35144 = state_35026__$1;
(statearr_35028_35144[(2)] = null);

(statearr_35028_35144[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35027 === (2))){
var state_35026__$1 = state_35026;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35026__$1,(4),from);
} else {
if((state_val_35027 === (3))){
var inst_35024 = (state_35026[(2)]);
var state_35026__$1 = state_35026;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35026__$1,inst_35024);
} else {
if((state_val_35027 === (4))){
var inst_35007 = (state_35026[(7)]);
var inst_35007__$1 = (state_35026[(2)]);
var inst_35008 = (inst_35007__$1 == null);
var state_35026__$1 = (function (){var statearr_35029 = state_35026;
(statearr_35029[(7)] = inst_35007__$1);

return statearr_35029;
})();
if(cljs.core.truth_(inst_35008)){
var statearr_35030_35145 = state_35026__$1;
(statearr_35030_35145[(1)] = (5));

} else {
var statearr_35031_35146 = state_35026__$1;
(statearr_35031_35146[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35027 === (5))){
var inst_35010 = cljs.core.async.close_BANG_(jobs);
var state_35026__$1 = state_35026;
var statearr_35032_35147 = state_35026__$1;
(statearr_35032_35147[(2)] = inst_35010);

(statearr_35032_35147[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35027 === (6))){
var inst_35012 = (state_35026[(8)]);
var inst_35007 = (state_35026[(7)]);
var inst_35012__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_35013 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_35014 = [inst_35007,inst_35012__$1];
var inst_35015 = (new cljs.core.PersistentVector(null,2,(5),inst_35013,inst_35014,null));
var state_35026__$1 = (function (){var statearr_35033 = state_35026;
(statearr_35033[(8)] = inst_35012__$1);

return statearr_35033;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35026__$1,(8),jobs,inst_35015);
} else {
if((state_val_35027 === (7))){
var inst_35022 = (state_35026[(2)]);
var state_35026__$1 = state_35026;
var statearr_35034_35148 = state_35026__$1;
(statearr_35034_35148[(2)] = inst_35022);

(statearr_35034_35148[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35027 === (8))){
var inst_35012 = (state_35026[(8)]);
var inst_35017 = (state_35026[(2)]);
var state_35026__$1 = (function (){var statearr_35035 = state_35026;
(statearr_35035[(9)] = inst_35017);

return statearr_35035;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35026__$1,(9),results,inst_35012);
} else {
if((state_val_35027 === (9))){
var inst_35019 = (state_35026[(2)]);
var state_35026__$1 = (function (){var statearr_35036 = state_35026;
(statearr_35036[(10)] = inst_35019);

return statearr_35036;
})();
var statearr_35037_35149 = state_35026__$1;
(statearr_35037_35149[(2)] = null);

(statearr_35037_35149[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___35143,jobs,results,process,async))
;
return ((function (switch__11474__auto__,c__11552__auto___35143,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0 = (function (){
var statearr_35041 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_35041[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__);

(statearr_35041[(1)] = (1));

return statearr_35041;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1 = (function (state_35026){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_35026);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e35042){if((e35042 instanceof Object)){
var ex__11478__auto__ = e35042;
var statearr_35043_35150 = state_35026;
(statearr_35043_35150[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_35026);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e35042;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35151 = state_35026;
state_35026 = G__35151;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = function(state_35026){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1.call(this,state_35026);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___35143,jobs,results,process,async))
})();
var state__11554__auto__ = (function (){var statearr_35044 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_35044[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___35143);

return statearr_35044;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___35143,jobs,results,process,async))
);


var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__,jobs,results,process,async){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__,jobs,results,process,async){
return (function (state_35082){
var state_val_35083 = (state_35082[(1)]);
if((state_val_35083 === (7))){
var inst_35078 = (state_35082[(2)]);
var state_35082__$1 = state_35082;
var statearr_35084_35152 = state_35082__$1;
(statearr_35084_35152[(2)] = inst_35078);

(statearr_35084_35152[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (20))){
var state_35082__$1 = state_35082;
var statearr_35085_35153 = state_35082__$1;
(statearr_35085_35153[(2)] = null);

(statearr_35085_35153[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (1))){
var state_35082__$1 = state_35082;
var statearr_35086_35154 = state_35082__$1;
(statearr_35086_35154[(2)] = null);

(statearr_35086_35154[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (4))){
var inst_35047 = (state_35082[(7)]);
var inst_35047__$1 = (state_35082[(2)]);
var inst_35048 = (inst_35047__$1 == null);
var state_35082__$1 = (function (){var statearr_35087 = state_35082;
(statearr_35087[(7)] = inst_35047__$1);

return statearr_35087;
})();
if(cljs.core.truth_(inst_35048)){
var statearr_35088_35155 = state_35082__$1;
(statearr_35088_35155[(1)] = (5));

} else {
var statearr_35089_35156 = state_35082__$1;
(statearr_35089_35156[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (15))){
var inst_35060 = (state_35082[(8)]);
var state_35082__$1 = state_35082;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35082__$1,(18),to,inst_35060);
} else {
if((state_val_35083 === (21))){
var inst_35073 = (state_35082[(2)]);
var state_35082__$1 = state_35082;
var statearr_35090_35157 = state_35082__$1;
(statearr_35090_35157[(2)] = inst_35073);

(statearr_35090_35157[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (13))){
var inst_35075 = (state_35082[(2)]);
var state_35082__$1 = (function (){var statearr_35091 = state_35082;
(statearr_35091[(9)] = inst_35075);

return statearr_35091;
})();
var statearr_35092_35158 = state_35082__$1;
(statearr_35092_35158[(2)] = null);

(statearr_35092_35158[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (6))){
var inst_35047 = (state_35082[(7)]);
var state_35082__$1 = state_35082;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35082__$1,(11),inst_35047);
} else {
if((state_val_35083 === (17))){
var inst_35068 = (state_35082[(2)]);
var state_35082__$1 = state_35082;
if(cljs.core.truth_(inst_35068)){
var statearr_35093_35159 = state_35082__$1;
(statearr_35093_35159[(1)] = (19));

} else {
var statearr_35094_35160 = state_35082__$1;
(statearr_35094_35160[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (3))){
var inst_35080 = (state_35082[(2)]);
var state_35082__$1 = state_35082;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35082__$1,inst_35080);
} else {
if((state_val_35083 === (12))){
var inst_35057 = (state_35082[(10)]);
var state_35082__$1 = state_35082;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35082__$1,(14),inst_35057);
} else {
if((state_val_35083 === (2))){
var state_35082__$1 = state_35082;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35082__$1,(4),results);
} else {
if((state_val_35083 === (19))){
var state_35082__$1 = state_35082;
var statearr_35095_35161 = state_35082__$1;
(statearr_35095_35161[(2)] = null);

(statearr_35095_35161[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (11))){
var inst_35057 = (state_35082[(2)]);
var state_35082__$1 = (function (){var statearr_35096 = state_35082;
(statearr_35096[(10)] = inst_35057);

return statearr_35096;
})();
var statearr_35097_35162 = state_35082__$1;
(statearr_35097_35162[(2)] = null);

(statearr_35097_35162[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (9))){
var state_35082__$1 = state_35082;
var statearr_35098_35163 = state_35082__$1;
(statearr_35098_35163[(2)] = null);

(statearr_35098_35163[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (5))){
var state_35082__$1 = state_35082;
if(cljs.core.truth_(close_QMARK_)){
var statearr_35099_35164 = state_35082__$1;
(statearr_35099_35164[(1)] = (8));

} else {
var statearr_35100_35165 = state_35082__$1;
(statearr_35100_35165[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (14))){
var inst_35060 = (state_35082[(8)]);
var inst_35062 = (state_35082[(11)]);
var inst_35060__$1 = (state_35082[(2)]);
var inst_35061 = (inst_35060__$1 == null);
var inst_35062__$1 = cljs.core.not(inst_35061);
var state_35082__$1 = (function (){var statearr_35101 = state_35082;
(statearr_35101[(8)] = inst_35060__$1);

(statearr_35101[(11)] = inst_35062__$1);

return statearr_35101;
})();
if(inst_35062__$1){
var statearr_35102_35166 = state_35082__$1;
(statearr_35102_35166[(1)] = (15));

} else {
var statearr_35103_35167 = state_35082__$1;
(statearr_35103_35167[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (16))){
var inst_35062 = (state_35082[(11)]);
var state_35082__$1 = state_35082;
var statearr_35104_35168 = state_35082__$1;
(statearr_35104_35168[(2)] = inst_35062);

(statearr_35104_35168[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (10))){
var inst_35054 = (state_35082[(2)]);
var state_35082__$1 = state_35082;
var statearr_35105_35169 = state_35082__$1;
(statearr_35105_35169[(2)] = inst_35054);

(statearr_35105_35169[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (18))){
var inst_35065 = (state_35082[(2)]);
var state_35082__$1 = state_35082;
var statearr_35106_35170 = state_35082__$1;
(statearr_35106_35170[(2)] = inst_35065);

(statearr_35106_35170[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35083 === (8))){
var inst_35051 = cljs.core.async.close_BANG_(to);
var state_35082__$1 = state_35082;
var statearr_35107_35171 = state_35082__$1;
(statearr_35107_35171[(2)] = inst_35051);

(statearr_35107_35171[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto__,jobs,results,process,async))
;
return ((function (switch__11474__auto__,c__11552__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0 = (function (){
var statearr_35111 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_35111[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__);

(statearr_35111[(1)] = (1));

return statearr_35111;
});
var cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1 = (function (state_35082){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_35082);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e35112){if((e35112 instanceof Object)){
var ex__11478__auto__ = e35112;
var statearr_35113_35172 = state_35082;
(statearr_35113_35172[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_35082);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e35112;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35173 = state_35082;
state_35082 = G__35173;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__ = function(state_35082){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1.call(this,state_35082);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__11475__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__,jobs,results,process,async))
})();
var state__11554__auto__ = (function (){var statearr_35114 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_35114[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_35114;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__,jobs,results,process,async))
);

return c__11552__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel, subject to the async function af, with parallelism n. af
 * must be a function of two arguments, the first an input value and
 * the second a channel on which to place the result(s). af must close!
 * the channel before returning.  The presumption is that af will
 * return immediately, having launched some asynchronous operation
 * whose completion/callback will manipulate the result channel. Outputs
 * will be returned in order relative to  the inputs. By default, the to
 * channel will be closed when the from channel closes, but can be
 * determined by the close?  parameter. Will stop consuming the from
 * channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(){
var G__35175 = arguments.length;
switch (G__35175) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;
/**
 * Takes elements from the from channel and supplies them to the to
 * channel, subject to the transducer xf, with parallelism n. Because
 * it is parallel, the transducer will be applied independently to each
 * element, not across elements, and may produce zero or more outputs
 * per input.  Outputs will be returned in order relative to the
 * inputs. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes.
 * 
 * Note this is supplied for API compatibility with the Clojure version.
 * Values of N > 1 will not result in actual concurrency in a
 * single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(){
var G__35178 = arguments.length;
switch (G__35178) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;
/**
 * Takes a predicate and a source channel and returns a vector of two
 * channels, the first of which will contain the values for which the
 * predicate returned true, the second those for which it returned
 * false.
 * 
 * The out channels will be unbuffered by default, or two buf-or-ns can
 * be supplied. The channels will close after the source channel has
 * closed.
 */
cljs.core.async.split = (function cljs$core$async$split(){
var G__35181 = arguments.length;
switch (G__35181) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__11552__auto___35234 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___35234,tc,fc){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___35234,tc,fc){
return (function (state_35207){
var state_val_35208 = (state_35207[(1)]);
if((state_val_35208 === (7))){
var inst_35203 = (state_35207[(2)]);
var state_35207__$1 = state_35207;
var statearr_35209_35235 = state_35207__$1;
(statearr_35209_35235[(2)] = inst_35203);

(statearr_35209_35235[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (1))){
var state_35207__$1 = state_35207;
var statearr_35210_35236 = state_35207__$1;
(statearr_35210_35236[(2)] = null);

(statearr_35210_35236[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (4))){
var inst_35184 = (state_35207[(7)]);
var inst_35184__$1 = (state_35207[(2)]);
var inst_35185 = (inst_35184__$1 == null);
var state_35207__$1 = (function (){var statearr_35211 = state_35207;
(statearr_35211[(7)] = inst_35184__$1);

return statearr_35211;
})();
if(cljs.core.truth_(inst_35185)){
var statearr_35212_35237 = state_35207__$1;
(statearr_35212_35237[(1)] = (5));

} else {
var statearr_35213_35238 = state_35207__$1;
(statearr_35213_35238[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (13))){
var state_35207__$1 = state_35207;
var statearr_35214_35239 = state_35207__$1;
(statearr_35214_35239[(2)] = null);

(statearr_35214_35239[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (6))){
var inst_35184 = (state_35207[(7)]);
var inst_35190 = (function (){var G__35215 = inst_35184;
return (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(G__35215) : p.call(null,G__35215));
})();
var state_35207__$1 = state_35207;
if(cljs.core.truth_(inst_35190)){
var statearr_35216_35240 = state_35207__$1;
(statearr_35216_35240[(1)] = (9));

} else {
var statearr_35217_35241 = state_35207__$1;
(statearr_35217_35241[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (3))){
var inst_35205 = (state_35207[(2)]);
var state_35207__$1 = state_35207;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35207__$1,inst_35205);
} else {
if((state_val_35208 === (12))){
var state_35207__$1 = state_35207;
var statearr_35218_35242 = state_35207__$1;
(statearr_35218_35242[(2)] = null);

(statearr_35218_35242[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (2))){
var state_35207__$1 = state_35207;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35207__$1,(4),ch);
} else {
if((state_val_35208 === (11))){
var inst_35184 = (state_35207[(7)]);
var inst_35194 = (state_35207[(2)]);
var state_35207__$1 = state_35207;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35207__$1,(8),inst_35194,inst_35184);
} else {
if((state_val_35208 === (9))){
var state_35207__$1 = state_35207;
var statearr_35219_35243 = state_35207__$1;
(statearr_35219_35243[(2)] = tc);

(statearr_35219_35243[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (5))){
var inst_35187 = cljs.core.async.close_BANG_(tc);
var inst_35188 = cljs.core.async.close_BANG_(fc);
var state_35207__$1 = (function (){var statearr_35220 = state_35207;
(statearr_35220[(8)] = inst_35187);

return statearr_35220;
})();
var statearr_35221_35244 = state_35207__$1;
(statearr_35221_35244[(2)] = inst_35188);

(statearr_35221_35244[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (14))){
var inst_35201 = (state_35207[(2)]);
var state_35207__$1 = state_35207;
var statearr_35222_35245 = state_35207__$1;
(statearr_35222_35245[(2)] = inst_35201);

(statearr_35222_35245[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (10))){
var state_35207__$1 = state_35207;
var statearr_35223_35246 = state_35207__$1;
(statearr_35223_35246[(2)] = fc);

(statearr_35223_35246[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35208 === (8))){
var inst_35196 = (state_35207[(2)]);
var state_35207__$1 = state_35207;
if(cljs.core.truth_(inst_35196)){
var statearr_35224_35247 = state_35207__$1;
(statearr_35224_35247[(1)] = (12));

} else {
var statearr_35225_35248 = state_35207__$1;
(statearr_35225_35248[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___35234,tc,fc))
;
return ((function (switch__11474__auto__,c__11552__auto___35234,tc,fc){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_35229 = [null,null,null,null,null,null,null,null,null];
(statearr_35229[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_35229[(1)] = (1));

return statearr_35229;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_35207){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_35207);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e35230){if((e35230 instanceof Object)){
var ex__11478__auto__ = e35230;
var statearr_35231_35249 = state_35207;
(statearr_35231_35249[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_35207);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e35230;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35250 = state_35207;
state_35207 = G__35250;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_35207){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_35207);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___35234,tc,fc))
})();
var state__11554__auto__ = (function (){var statearr_35232 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_35232[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___35234);

return statearr_35232;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___35234,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;
/**
 * f should be a function of 2 arguments. Returns a channel containing
 * the single result of applying f to init and the first item from the
 * channel, then applying f to that result and the 2nd item, etc. If
 * the channel closes without yielding items, returns init and f is not
 * called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__){
return (function (state_35299){
var state_val_35300 = (state_35299[(1)]);
if((state_val_35300 === (1))){
var inst_35285 = init;
var state_35299__$1 = (function (){var statearr_35301 = state_35299;
(statearr_35301[(7)] = inst_35285);

return statearr_35301;
})();
var statearr_35302_35319 = state_35299__$1;
(statearr_35302_35319[(2)] = null);

(statearr_35302_35319[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35300 === (2))){
var state_35299__$1 = state_35299;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35299__$1,(4),ch);
} else {
if((state_val_35300 === (3))){
var inst_35297 = (state_35299[(2)]);
var state_35299__$1 = state_35299;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35299__$1,inst_35297);
} else {
if((state_val_35300 === (4))){
var inst_35288 = (state_35299[(8)]);
var inst_35288__$1 = (state_35299[(2)]);
var inst_35289 = (inst_35288__$1 == null);
var state_35299__$1 = (function (){var statearr_35303 = state_35299;
(statearr_35303[(8)] = inst_35288__$1);

return statearr_35303;
})();
if(cljs.core.truth_(inst_35289)){
var statearr_35304_35320 = state_35299__$1;
(statearr_35304_35320[(1)] = (5));

} else {
var statearr_35305_35321 = state_35299__$1;
(statearr_35305_35321[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35300 === (5))){
var inst_35285 = (state_35299[(7)]);
var state_35299__$1 = state_35299;
var statearr_35306_35322 = state_35299__$1;
(statearr_35306_35322[(2)] = inst_35285);

(statearr_35306_35322[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35300 === (6))){
var inst_35288 = (state_35299[(8)]);
var inst_35285 = (state_35299[(7)]);
var inst_35292 = (function (){var G__35307 = inst_35285;
var G__35308 = inst_35288;
return (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(G__35307,G__35308) : f.call(null,G__35307,G__35308));
})();
var inst_35285__$1 = inst_35292;
var state_35299__$1 = (function (){var statearr_35309 = state_35299;
(statearr_35309[(7)] = inst_35285__$1);

return statearr_35309;
})();
var statearr_35310_35323 = state_35299__$1;
(statearr_35310_35323[(2)] = null);

(statearr_35310_35323[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35300 === (7))){
var inst_35295 = (state_35299[(2)]);
var state_35299__$1 = state_35299;
var statearr_35311_35324 = state_35299__$1;
(statearr_35311_35324[(2)] = inst_35295);

(statearr_35311_35324[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__11552__auto__))
;
return ((function (switch__11474__auto__,c__11552__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__11475__auto__ = null;
var cljs$core$async$reduce_$_state_machine__11475__auto____0 = (function (){
var statearr_35315 = [null,null,null,null,null,null,null,null,null];
(statearr_35315[(0)] = cljs$core$async$reduce_$_state_machine__11475__auto__);

(statearr_35315[(1)] = (1));

return statearr_35315;
});
var cljs$core$async$reduce_$_state_machine__11475__auto____1 = (function (state_35299){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_35299);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e35316){if((e35316 instanceof Object)){
var ex__11478__auto__ = e35316;
var statearr_35317_35325 = state_35299;
(statearr_35317_35325[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_35299);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e35316;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35326 = state_35299;
state_35299 = G__35326;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__11475__auto__ = function(state_35299){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__11475__auto____1.call(this,state_35299);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__11475__auto____0;
cljs$core$async$reduce_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__11475__auto____1;
return cljs$core$async$reduce_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__))
})();
var state__11554__auto__ = (function (){var statearr_35318 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_35318[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_35318;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__))
);

return c__11552__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 * By default the channel will be closed after the items are copied,
 * but can be determined by the close? parameter.
 * 
 * Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(){
var G__35328 = arguments.length;
switch (G__35328) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__){
return (function (state_35353){
var state_val_35354 = (state_35353[(1)]);
if((state_val_35354 === (7))){
var inst_35335 = (state_35353[(2)]);
var state_35353__$1 = state_35353;
var statearr_35355_35379 = state_35353__$1;
(statearr_35355_35379[(2)] = inst_35335);

(statearr_35355_35379[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (1))){
var inst_35329 = cljs.core.seq(coll);
var inst_35330 = inst_35329;
var state_35353__$1 = (function (){var statearr_35356 = state_35353;
(statearr_35356[(7)] = inst_35330);

return statearr_35356;
})();
var statearr_35357_35380 = state_35353__$1;
(statearr_35357_35380[(2)] = null);

(statearr_35357_35380[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (4))){
var inst_35330 = (state_35353[(7)]);
var inst_35333 = cljs.core.first(inst_35330);
var state_35353__$1 = state_35353;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_35353__$1,(7),ch,inst_35333);
} else {
if((state_val_35354 === (13))){
var inst_35347 = (state_35353[(2)]);
var state_35353__$1 = state_35353;
var statearr_35358_35381 = state_35353__$1;
(statearr_35358_35381[(2)] = inst_35347);

(statearr_35358_35381[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (6))){
var inst_35338 = (state_35353[(2)]);
var state_35353__$1 = state_35353;
if(cljs.core.truth_(inst_35338)){
var statearr_35359_35382 = state_35353__$1;
(statearr_35359_35382[(1)] = (8));

} else {
var statearr_35360_35383 = state_35353__$1;
(statearr_35360_35383[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (3))){
var inst_35351 = (state_35353[(2)]);
var state_35353__$1 = state_35353;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35353__$1,inst_35351);
} else {
if((state_val_35354 === (12))){
var state_35353__$1 = state_35353;
var statearr_35361_35384 = state_35353__$1;
(statearr_35361_35384[(2)] = null);

(statearr_35361_35384[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (2))){
var inst_35330 = (state_35353[(7)]);
var state_35353__$1 = state_35353;
if(cljs.core.truth_(inst_35330)){
var statearr_35362_35385 = state_35353__$1;
(statearr_35362_35385[(1)] = (4));

} else {
var statearr_35363_35386 = state_35353__$1;
(statearr_35363_35386[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (11))){
var inst_35344 = cljs.core.async.close_BANG_(ch);
var state_35353__$1 = state_35353;
var statearr_35364_35387 = state_35353__$1;
(statearr_35364_35387[(2)] = inst_35344);

(statearr_35364_35387[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (9))){
var state_35353__$1 = state_35353;
if(cljs.core.truth_(close_QMARK_)){
var statearr_35365_35388 = state_35353__$1;
(statearr_35365_35388[(1)] = (11));

} else {
var statearr_35366_35389 = state_35353__$1;
(statearr_35366_35389[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (5))){
var inst_35330 = (state_35353[(7)]);
var state_35353__$1 = state_35353;
var statearr_35367_35390 = state_35353__$1;
(statearr_35367_35390[(2)] = inst_35330);

(statearr_35367_35390[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (10))){
var inst_35349 = (state_35353[(2)]);
var state_35353__$1 = state_35353;
var statearr_35368_35391 = state_35353__$1;
(statearr_35368_35391[(2)] = inst_35349);

(statearr_35368_35391[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35354 === (8))){
var inst_35330 = (state_35353[(7)]);
var inst_35340 = cljs.core.next(inst_35330);
var inst_35330__$1 = inst_35340;
var state_35353__$1 = (function (){var statearr_35369 = state_35353;
(statearr_35369[(7)] = inst_35330__$1);

return statearr_35369;
})();
var statearr_35370_35392 = state_35353__$1;
(statearr_35370_35392[(2)] = null);

(statearr_35370_35392[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto__))
;
return ((function (switch__11474__auto__,c__11552__auto__){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_35374 = [null,null,null,null,null,null,null,null];
(statearr_35374[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_35374[(1)] = (1));

return statearr_35374;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_35353){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_35353);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e35375){if((e35375 instanceof Object)){
var ex__11478__auto__ = e35375;
var statearr_35376_35393 = state_35353;
(statearr_35376_35393[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_35353);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e35375;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35394 = state_35353;
state_35353 = G__35394;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_35353){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_35353);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__))
})();
var state__11554__auto__ = (function (){var statearr_35377 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_35377[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_35377;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__))
);

return c__11552__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates and returns a channel which contains the contents of coll,
 * closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});

cljs.core.async.Mux = (function (){var obj35396 = {};
return obj35396;
})();

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((function (){var and__4259__auto__ = _;
if(and__4259__auto__){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1;
} else {
return and__4259__auto__;
}
})()){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__4907__auto__ = (((_ == null))?null:_);
return (function (){var or__4271__auto__ = (cljs.core.async.muxch_STAR_[(function (){var G__35400 = x__4907__auto__;
return goog.typeOf(G__35400);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
})().call(null,_);
}
});


cljs.core.async.Mult = (function (){var obj35402 = {};
return obj35402;
})();

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mult$tap_STAR_$arity$3;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.tap_STAR_[(function (){var G__35406 = x__4907__auto__;
return goog.typeOf(G__35406);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
})().call(null,m,ch,close_QMARK_);
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mult$untap_STAR_$arity$2;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.untap_STAR_[(function (){var G__35410 = x__4907__auto__;
return goog.typeOf(G__35410);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
})().call(null,m,ch);
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.untap_all_STAR_[(function (){var G__35414 = x__4907__auto__;
return goog.typeOf(G__35414);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
})().call(null,m);
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 * containing copies of the channel can be created with 'tap', and
 * detached with 'untap'.
 * 
 * Each item is distributed to all taps in parallel and synchronously,
 * i.e. each tap must accept before the next item is distributed. Use
 * buffering/windowing to prevent slow taps from holding up the mult.
 * 
 * Items received when there are no taps get dropped.
 * 
 * If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = (function (){var G__35644 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__35644) : cljs.core.atom.call(null,G__35644));
})();
var m = (function (){
if(typeof cljs.core.async.t35645 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t35645 = (function (mult,ch,cs,meta35646){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta35646 = meta35646;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t35645.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_35647,meta35646__$1){
var self__ = this;
var _35647__$1 = this;
return (new cljs.core.async.t35645(self__.mult,self__.ch,self__.cs,meta35646__$1));
});})(cs))
;

cljs.core.async.t35645.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_35647){
var self__ = this;
var _35647__$1 = this;
return self__.meta35646;
});})(cs))
;

cljs.core.async.t35645.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t35645.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t35645.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t35645.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t35645.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t35645.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__35648_35873 = self__.cs;
var G__35649_35874 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__35648_35873,G__35649_35874) : cljs.core.reset_BANG_.call(null,G__35648_35873,G__35649_35874));

return null;
});})(cs))
;

cljs.core.async.t35645.cljs$lang$type = true;

cljs.core.async.t35645.cljs$lang$ctorStr = "cljs.core.async/t35645";

cljs.core.async.t35645.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t35645");
});})(cs))
;

cljs.core.async.__GT_t35645 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t35645(mult__$1,ch__$1,cs__$1,meta35646){
return (new cljs.core.async.t35645(mult__$1,ch__$1,cs__$1,meta35646));
});})(cs))
;

}

return (new cljs.core.async.t35645(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (function (){var G__35650 = null;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__35650) : cljs.core.atom.call(null,G__35650));
})();
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__11552__auto___35875 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___35875,cs,m,dchan,dctr,done){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___35875,cs,m,dchan,dctr,done){
return (function (state_35781){
var state_val_35782 = (state_35781[(1)]);
if((state_val_35782 === (7))){
var inst_35777 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35783_35876 = state_35781__$1;
(statearr_35783_35876[(2)] = inst_35777);

(statearr_35783_35876[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (20))){
var inst_35682 = (state_35781[(7)]);
var inst_35692 = cljs.core.first(inst_35682);
var inst_35693 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_35692,(0),null);
var inst_35694 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_35692,(1),null);
var state_35781__$1 = (function (){var statearr_35784 = state_35781;
(statearr_35784[(8)] = inst_35693);

return statearr_35784;
})();
if(cljs.core.truth_(inst_35694)){
var statearr_35785_35877 = state_35781__$1;
(statearr_35785_35877[(1)] = (22));

} else {
var statearr_35786_35878 = state_35781__$1;
(statearr_35786_35878[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (27))){
var inst_35722 = (state_35781[(9)]);
var inst_35724 = (state_35781[(10)]);
var inst_35653 = (state_35781[(11)]);
var inst_35729 = (state_35781[(12)]);
var inst_35729__$1 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_35722,inst_35724);
var inst_35730 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_35729__$1,inst_35653,done);
var state_35781__$1 = (function (){var statearr_35787 = state_35781;
(statearr_35787[(12)] = inst_35729__$1);

return statearr_35787;
})();
if(cljs.core.truth_(inst_35730)){
var statearr_35788_35879 = state_35781__$1;
(statearr_35788_35879[(1)] = (30));

} else {
var statearr_35789_35880 = state_35781__$1;
(statearr_35789_35880[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (1))){
var state_35781__$1 = state_35781;
var statearr_35790_35881 = state_35781__$1;
(statearr_35790_35881[(2)] = null);

(statearr_35790_35881[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (24))){
var inst_35682 = (state_35781[(7)]);
var inst_35699 = (state_35781[(2)]);
var inst_35700 = cljs.core.next(inst_35682);
var inst_35662 = inst_35700;
var inst_35663 = null;
var inst_35664 = (0);
var inst_35665 = (0);
var state_35781__$1 = (function (){var statearr_35791 = state_35781;
(statearr_35791[(13)] = inst_35662);

(statearr_35791[(14)] = inst_35699);

(statearr_35791[(15)] = inst_35665);

(statearr_35791[(16)] = inst_35663);

(statearr_35791[(17)] = inst_35664);

return statearr_35791;
})();
var statearr_35792_35882 = state_35781__$1;
(statearr_35792_35882[(2)] = null);

(statearr_35792_35882[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (39))){
var state_35781__$1 = state_35781;
var statearr_35796_35883 = state_35781__$1;
(statearr_35796_35883[(2)] = null);

(statearr_35796_35883[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (4))){
var inst_35653 = (state_35781[(11)]);
var inst_35653__$1 = (state_35781[(2)]);
var inst_35654 = (inst_35653__$1 == null);
var state_35781__$1 = (function (){var statearr_35797 = state_35781;
(statearr_35797[(11)] = inst_35653__$1);

return statearr_35797;
})();
if(cljs.core.truth_(inst_35654)){
var statearr_35798_35884 = state_35781__$1;
(statearr_35798_35884[(1)] = (5));

} else {
var statearr_35799_35885 = state_35781__$1;
(statearr_35799_35885[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (15))){
var inst_35662 = (state_35781[(13)]);
var inst_35665 = (state_35781[(15)]);
var inst_35663 = (state_35781[(16)]);
var inst_35664 = (state_35781[(17)]);
var inst_35678 = (state_35781[(2)]);
var inst_35679 = (inst_35665 + (1));
var tmp35793 = inst_35662;
var tmp35794 = inst_35663;
var tmp35795 = inst_35664;
var inst_35662__$1 = tmp35793;
var inst_35663__$1 = tmp35794;
var inst_35664__$1 = tmp35795;
var inst_35665__$1 = inst_35679;
var state_35781__$1 = (function (){var statearr_35800 = state_35781;
(statearr_35800[(13)] = inst_35662__$1);

(statearr_35800[(18)] = inst_35678);

(statearr_35800[(15)] = inst_35665__$1);

(statearr_35800[(16)] = inst_35663__$1);

(statearr_35800[(17)] = inst_35664__$1);

return statearr_35800;
})();
var statearr_35801_35886 = state_35781__$1;
(statearr_35801_35886[(2)] = null);

(statearr_35801_35886[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (21))){
var inst_35703 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35805_35887 = state_35781__$1;
(statearr_35805_35887[(2)] = inst_35703);

(statearr_35805_35887[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (31))){
var inst_35729 = (state_35781[(12)]);
var inst_35733 = done(null);
var inst_35734 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_35729);
var state_35781__$1 = (function (){var statearr_35806 = state_35781;
(statearr_35806[(19)] = inst_35733);

return statearr_35806;
})();
var statearr_35807_35888 = state_35781__$1;
(statearr_35807_35888[(2)] = inst_35734);

(statearr_35807_35888[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (32))){
var inst_35722 = (state_35781[(9)]);
var inst_35723 = (state_35781[(20)]);
var inst_35724 = (state_35781[(10)]);
var inst_35721 = (state_35781[(21)]);
var inst_35736 = (state_35781[(2)]);
var inst_35737 = (inst_35724 + (1));
var tmp35802 = inst_35722;
var tmp35803 = inst_35723;
var tmp35804 = inst_35721;
var inst_35721__$1 = tmp35804;
var inst_35722__$1 = tmp35802;
var inst_35723__$1 = tmp35803;
var inst_35724__$1 = inst_35737;
var state_35781__$1 = (function (){var statearr_35808 = state_35781;
(statearr_35808[(9)] = inst_35722__$1);

(statearr_35808[(22)] = inst_35736);

(statearr_35808[(20)] = inst_35723__$1);

(statearr_35808[(10)] = inst_35724__$1);

(statearr_35808[(21)] = inst_35721__$1);

return statearr_35808;
})();
var statearr_35809_35889 = state_35781__$1;
(statearr_35809_35889[(2)] = null);

(statearr_35809_35889[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (40))){
var inst_35749 = (state_35781[(23)]);
var inst_35753 = done(null);
var inst_35754 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_35749);
var state_35781__$1 = (function (){var statearr_35810 = state_35781;
(statearr_35810[(24)] = inst_35753);

return statearr_35810;
})();
var statearr_35811_35890 = state_35781__$1;
(statearr_35811_35890[(2)] = inst_35754);

(statearr_35811_35890[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (33))){
var inst_35740 = (state_35781[(25)]);
var inst_35742 = cljs.core.chunked_seq_QMARK_(inst_35740);
var state_35781__$1 = state_35781;
if(inst_35742){
var statearr_35812_35891 = state_35781__$1;
(statearr_35812_35891[(1)] = (36));

} else {
var statearr_35813_35892 = state_35781__$1;
(statearr_35813_35892[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (13))){
var inst_35672 = (state_35781[(26)]);
var inst_35675 = cljs.core.async.close_BANG_(inst_35672);
var state_35781__$1 = state_35781;
var statearr_35814_35893 = state_35781__$1;
(statearr_35814_35893[(2)] = inst_35675);

(statearr_35814_35893[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (22))){
var inst_35693 = (state_35781[(8)]);
var inst_35696 = cljs.core.async.close_BANG_(inst_35693);
var state_35781__$1 = state_35781;
var statearr_35815_35894 = state_35781__$1;
(statearr_35815_35894[(2)] = inst_35696);

(statearr_35815_35894[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (36))){
var inst_35740 = (state_35781[(25)]);
var inst_35744 = cljs.core.chunk_first(inst_35740);
var inst_35745 = cljs.core.chunk_rest(inst_35740);
var inst_35746 = cljs.core.count(inst_35744);
var inst_35721 = inst_35745;
var inst_35722 = inst_35744;
var inst_35723 = inst_35746;
var inst_35724 = (0);
var state_35781__$1 = (function (){var statearr_35816 = state_35781;
(statearr_35816[(9)] = inst_35722);

(statearr_35816[(20)] = inst_35723);

(statearr_35816[(10)] = inst_35724);

(statearr_35816[(21)] = inst_35721);

return statearr_35816;
})();
var statearr_35817_35895 = state_35781__$1;
(statearr_35817_35895[(2)] = null);

(statearr_35817_35895[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (41))){
var inst_35740 = (state_35781[(25)]);
var inst_35756 = (state_35781[(2)]);
var inst_35757 = cljs.core.next(inst_35740);
var inst_35721 = inst_35757;
var inst_35722 = null;
var inst_35723 = (0);
var inst_35724 = (0);
var state_35781__$1 = (function (){var statearr_35818 = state_35781;
(statearr_35818[(9)] = inst_35722);

(statearr_35818[(20)] = inst_35723);

(statearr_35818[(10)] = inst_35724);

(statearr_35818[(21)] = inst_35721);

(statearr_35818[(27)] = inst_35756);

return statearr_35818;
})();
var statearr_35819_35896 = state_35781__$1;
(statearr_35819_35896[(2)] = null);

(statearr_35819_35896[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (43))){
var state_35781__$1 = state_35781;
var statearr_35820_35897 = state_35781__$1;
(statearr_35820_35897[(2)] = null);

(statearr_35820_35897[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (29))){
var inst_35765 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35821_35898 = state_35781__$1;
(statearr_35821_35898[(2)] = inst_35765);

(statearr_35821_35898[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (44))){
var inst_35774 = (state_35781[(2)]);
var state_35781__$1 = (function (){var statearr_35822 = state_35781;
(statearr_35822[(28)] = inst_35774);

return statearr_35822;
})();
var statearr_35823_35899 = state_35781__$1;
(statearr_35823_35899[(2)] = null);

(statearr_35823_35899[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (6))){
var inst_35713 = (state_35781[(29)]);
var inst_35712 = (function (){var G__35824 = cs;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__35824) : cljs.core.deref.call(null,G__35824));
})();
var inst_35713__$1 = cljs.core.keys(inst_35712);
var inst_35714 = cljs.core.count(inst_35713__$1);
var inst_35715 = (function (){var G__35825 = dctr;
var G__35826 = inst_35714;
return (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__35825,G__35826) : cljs.core.reset_BANG_.call(null,G__35825,G__35826));
})();
var inst_35720 = cljs.core.seq(inst_35713__$1);
var inst_35721 = inst_35720;
var inst_35722 = null;
var inst_35723 = (0);
var inst_35724 = (0);
var state_35781__$1 = (function (){var statearr_35827 = state_35781;
(statearr_35827[(9)] = inst_35722);

(statearr_35827[(20)] = inst_35723);

(statearr_35827[(10)] = inst_35724);

(statearr_35827[(21)] = inst_35721);

(statearr_35827[(29)] = inst_35713__$1);

(statearr_35827[(30)] = inst_35715);

return statearr_35827;
})();
var statearr_35828_35900 = state_35781__$1;
(statearr_35828_35900[(2)] = null);

(statearr_35828_35900[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (28))){
var inst_35721 = (state_35781[(21)]);
var inst_35740 = (state_35781[(25)]);
var inst_35740__$1 = cljs.core.seq(inst_35721);
var state_35781__$1 = (function (){var statearr_35829 = state_35781;
(statearr_35829[(25)] = inst_35740__$1);

return statearr_35829;
})();
if(inst_35740__$1){
var statearr_35830_35901 = state_35781__$1;
(statearr_35830_35901[(1)] = (33));

} else {
var statearr_35831_35902 = state_35781__$1;
(statearr_35831_35902[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (25))){
var inst_35723 = (state_35781[(20)]);
var inst_35724 = (state_35781[(10)]);
var inst_35726 = (inst_35724 < inst_35723);
var inst_35727 = inst_35726;
var state_35781__$1 = state_35781;
if(cljs.core.truth_(inst_35727)){
var statearr_35832_35903 = state_35781__$1;
(statearr_35832_35903[(1)] = (27));

} else {
var statearr_35833_35904 = state_35781__$1;
(statearr_35833_35904[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (34))){
var state_35781__$1 = state_35781;
var statearr_35834_35905 = state_35781__$1;
(statearr_35834_35905[(2)] = null);

(statearr_35834_35905[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (17))){
var state_35781__$1 = state_35781;
var statearr_35835_35906 = state_35781__$1;
(statearr_35835_35906[(2)] = null);

(statearr_35835_35906[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (3))){
var inst_35779 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
return cljs.core.async.impl.ioc_helpers.return_chan(state_35781__$1,inst_35779);
} else {
if((state_val_35782 === (12))){
var inst_35708 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35836_35907 = state_35781__$1;
(statearr_35836_35907[(2)] = inst_35708);

(statearr_35836_35907[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (2))){
var state_35781__$1 = state_35781;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35781__$1,(4),ch);
} else {
if((state_val_35782 === (23))){
var state_35781__$1 = state_35781;
var statearr_35837_35908 = state_35781__$1;
(statearr_35837_35908[(2)] = null);

(statearr_35837_35908[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (35))){
var inst_35763 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35838_35909 = state_35781__$1;
(statearr_35838_35909[(2)] = inst_35763);

(statearr_35838_35909[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (19))){
var inst_35682 = (state_35781[(7)]);
var inst_35686 = cljs.core.chunk_first(inst_35682);
var inst_35687 = cljs.core.chunk_rest(inst_35682);
var inst_35688 = cljs.core.count(inst_35686);
var inst_35662 = inst_35687;
var inst_35663 = inst_35686;
var inst_35664 = inst_35688;
var inst_35665 = (0);
var state_35781__$1 = (function (){var statearr_35839 = state_35781;
(statearr_35839[(13)] = inst_35662);

(statearr_35839[(15)] = inst_35665);

(statearr_35839[(16)] = inst_35663);

(statearr_35839[(17)] = inst_35664);

return statearr_35839;
})();
var statearr_35840_35910 = state_35781__$1;
(statearr_35840_35910[(2)] = null);

(statearr_35840_35910[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (11))){
var inst_35662 = (state_35781[(13)]);
var inst_35682 = (state_35781[(7)]);
var inst_35682__$1 = cljs.core.seq(inst_35662);
var state_35781__$1 = (function (){var statearr_35841 = state_35781;
(statearr_35841[(7)] = inst_35682__$1);

return statearr_35841;
})();
if(inst_35682__$1){
var statearr_35842_35911 = state_35781__$1;
(statearr_35842_35911[(1)] = (16));

} else {
var statearr_35843_35912 = state_35781__$1;
(statearr_35843_35912[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (9))){
var inst_35710 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35844_35913 = state_35781__$1;
(statearr_35844_35913[(2)] = inst_35710);

(statearr_35844_35913[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (5))){
var inst_35660 = (function (){var G__35845 = cs;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__35845) : cljs.core.deref.call(null,G__35845));
})();
var inst_35661 = cljs.core.seq(inst_35660);
var inst_35662 = inst_35661;
var inst_35663 = null;
var inst_35664 = (0);
var inst_35665 = (0);
var state_35781__$1 = (function (){var statearr_35846 = state_35781;
(statearr_35846[(13)] = inst_35662);

(statearr_35846[(15)] = inst_35665);

(statearr_35846[(16)] = inst_35663);

(statearr_35846[(17)] = inst_35664);

return statearr_35846;
})();
var statearr_35847_35914 = state_35781__$1;
(statearr_35847_35914[(2)] = null);

(statearr_35847_35914[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (14))){
var state_35781__$1 = state_35781;
var statearr_35848_35915 = state_35781__$1;
(statearr_35848_35915[(2)] = null);

(statearr_35848_35915[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (45))){
var inst_35771 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35849_35916 = state_35781__$1;
(statearr_35849_35916[(2)] = inst_35771);

(statearr_35849_35916[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (26))){
var inst_35713 = (state_35781[(29)]);
var inst_35767 = (state_35781[(2)]);
var inst_35768 = cljs.core.seq(inst_35713);
var state_35781__$1 = (function (){var statearr_35850 = state_35781;
(statearr_35850[(31)] = inst_35767);

return statearr_35850;
})();
if(inst_35768){
var statearr_35851_35917 = state_35781__$1;
(statearr_35851_35917[(1)] = (42));

} else {
var statearr_35852_35918 = state_35781__$1;
(statearr_35852_35918[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (16))){
var inst_35682 = (state_35781[(7)]);
var inst_35684 = cljs.core.chunked_seq_QMARK_(inst_35682);
var state_35781__$1 = state_35781;
if(inst_35684){
var statearr_35853_35919 = state_35781__$1;
(statearr_35853_35919[(1)] = (19));

} else {
var statearr_35854_35920 = state_35781__$1;
(statearr_35854_35920[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (38))){
var inst_35760 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35855_35921 = state_35781__$1;
(statearr_35855_35921[(2)] = inst_35760);

(statearr_35855_35921[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (30))){
var state_35781__$1 = state_35781;
var statearr_35856_35922 = state_35781__$1;
(statearr_35856_35922[(2)] = null);

(statearr_35856_35922[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (10))){
var inst_35665 = (state_35781[(15)]);
var inst_35663 = (state_35781[(16)]);
var inst_35671 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_35663,inst_35665);
var inst_35672 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_35671,(0),null);
var inst_35673 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_35671,(1),null);
var state_35781__$1 = (function (){var statearr_35857 = state_35781;
(statearr_35857[(26)] = inst_35672);

return statearr_35857;
})();
if(cljs.core.truth_(inst_35673)){
var statearr_35858_35923 = state_35781__$1;
(statearr_35858_35923[(1)] = (13));

} else {
var statearr_35859_35924 = state_35781__$1;
(statearr_35859_35924[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (18))){
var inst_35706 = (state_35781[(2)]);
var state_35781__$1 = state_35781;
var statearr_35860_35925 = state_35781__$1;
(statearr_35860_35925[(2)] = inst_35706);

(statearr_35860_35925[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (42))){
var state_35781__$1 = state_35781;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_35781__$1,(45),dchan);
} else {
if((state_val_35782 === (37))){
var inst_35749 = (state_35781[(23)]);
var inst_35740 = (state_35781[(25)]);
var inst_35653 = (state_35781[(11)]);
var inst_35749__$1 = cljs.core.first(inst_35740);
var inst_35750 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_35749__$1,inst_35653,done);
var state_35781__$1 = (function (){var statearr_35861 = state_35781;
(statearr_35861[(23)] = inst_35749__$1);

return statearr_35861;
})();
if(cljs.core.truth_(inst_35750)){
var statearr_35862_35926 = state_35781__$1;
(statearr_35862_35926[(1)] = (39));

} else {
var statearr_35863_35927 = state_35781__$1;
(statearr_35863_35927[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_35782 === (8))){
var inst_35665 = (state_35781[(15)]);
var inst_35664 = (state_35781[(17)]);
var inst_35667 = (inst_35665 < inst_35664);
var inst_35668 = inst_35667;
var state_35781__$1 = state_35781;
if(cljs.core.truth_(inst_35668)){
var statearr_35864_35928 = state_35781__$1;
(statearr_35864_35928[(1)] = (10));

} else {
var statearr_35865_35929 = state_35781__$1;
(statearr_35865_35929[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___35875,cs,m,dchan,dctr,done))
;
return ((function (switch__11474__auto__,c__11552__auto___35875,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__11475__auto__ = null;
var cljs$core$async$mult_$_state_machine__11475__auto____0 = (function (){
var statearr_35869 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_35869[(0)] = cljs$core$async$mult_$_state_machine__11475__auto__);

(statearr_35869[(1)] = (1));

return statearr_35869;
});
var cljs$core$async$mult_$_state_machine__11475__auto____1 = (function (state_35781){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_35781);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e35870){if((e35870 instanceof Object)){
var ex__11478__auto__ = e35870;
var statearr_35871_35930 = state_35781;
(statearr_35871_35930[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_35781);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e35870;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__35931 = state_35781;
state_35781 = G__35931;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__11475__auto__ = function(state_35781){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__11475__auto____1.call(this,state_35781);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__11475__auto____0;
cljs$core$async$mult_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__11475__auto____1;
return cljs$core$async$mult_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___35875,cs,m,dchan,dctr,done))
})();
var state__11554__auto__ = (function (){var statearr_35872 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_35872[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___35875);

return statearr_35872;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___35875,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 * By default the channel will be closed when the source closes,
 * but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(){
var G__35933 = arguments.length;
switch (G__35933) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;
/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

cljs.core.async.Mix = (function (){var obj35936 = {};
return obj35936;
})();

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mix$admix_STAR_$arity$2;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.admix_STAR_[(function (){var G__35940 = x__4907__auto__;
return goog.typeOf(G__35940);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
})().call(null,m,ch);
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.unmix_STAR_[(function (){var G__35944 = x__4907__auto__;
return goog.typeOf(G__35944);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
})().call(null,m,ch);
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.unmix_all_STAR_[(function (){var G__35948 = x__4907__auto__;
return goog.typeOf(G__35948);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
})().call(null,m);
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.toggle_STAR_[(function (){var G__35952 = x__4907__auto__;
return goog.typeOf(G__35952);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
})().call(null,m,state_map);
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((function (){var and__4259__auto__ = m;
if(and__4259__auto__){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2;
} else {
return and__4259__auto__;
}
})()){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__4907__auto__ = (((m == null))?null:m);
return (function (){var or__4271__auto__ = (cljs.core.async.solo_mode_STAR_[(function (){var G__35956 = x__4907__auto__;
return goog.typeOf(G__35956);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
})().call(null,m,mode);
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(){
var argseq__5311__auto__ = ((((3) < arguments.length))?(new cljs.core.IndexedSeq(Array.prototype.slice.call(arguments,(3)),(0))):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5311__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__35961){
var map__35962 = p__35961;
var map__35962__$1 = ((cljs.core.seq_QMARK_(map__35962))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__35962):map__35962);
var opts = map__35962__$1;
var statearr_35963_35967 = state;
(statearr_35963_35967[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4404__auto__ = cljs.core.async.do_alts(((function (map__35962,map__35962__$1,opts){
return (function (val){
var statearr_35964_35968 = state;
(statearr_35964_35968[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
});})(map__35962,map__35962__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4404__auto__)){
var cb = temp__4404__auto__;
var statearr_35965_35969 = state;
(statearr_35965_35969[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = (function (){var G__35966 = cb;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__35966) : cljs.core.deref.call(null,G__35966));
})());


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq35957){
var G__35958 = cljs.core.first(seq35957);
var seq35957__$1 = cljs.core.next(seq35957);
var G__35959 = cljs.core.first(seq35957__$1);
var seq35957__$2 = cljs.core.next(seq35957__$1);
var G__35960 = cljs.core.first(seq35957__$2);
var seq35957__$3 = cljs.core.next(seq35957__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__35958,G__35959,G__35960,seq35957__$3);
});
/**
 * Creates and returns a mix of one or more input channels which will
 * be put on the supplied out channel. Input sources can be added to
 * the mix with 'admix', and removed with 'unmix'. A mix supports
 * soloing, muting and pausing multiple inputs atomically using
 * 'toggle', and can solo using either muting or pausing as determined
 * by 'solo-mode'.
 * 
 * Each channel can have zero or more boolean modes set via 'toggle':
 * 
 * :solo - when true, only this (ond other soloed) channel(s) will appear
 * in the mix output channel. :mute and :pause states of soloed
 * channels are ignored. If solo-mode is :mute, non-soloed
 * channels are muted, if :pause, non-soloed channels are
 * paused.
 * 
 * :mute - muted channels will have their contents consumed but not included in the mix
 * :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = (function (){var G__36103 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__36103) : cljs.core.atom.call(null,G__36103));
})();
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = (function (){var G__36104 = new cljs.core.Keyword(null,"mute","mute",1151223646);
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__36104) : cljs.core.atom.call(null,G__36104));
})();
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv(((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_((function (){var G__36105 = v;
return (attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(G__36105) : attr.call(null,G__36105));
})())){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = (function (){var G__36106 = cs;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36106) : cljs.core.deref.call(null,G__36106));
})();
var mode = (function (){var G__36107 = solo_mode;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36107) : cljs.core.deref.call(null,G__36107));
})();
var solos = pick(new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick(new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick(new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.cljs$core$IFn$_invoke$arity$2((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_(solos))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t36108 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t36108 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta36109){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta36109 = meta36109;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t36108.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_36110,meta36109__$1){
var self__ = this;
var _36110__$1 = this;
return (new cljs.core.async.t36108(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta36109__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_36110){
var self__ = this;
var _36110__$1 = this;
return self__.meta36109;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t36108.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t36108.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__36111_36236 = self__.cs;
var G__36112_36237 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__36111_36236,G__36112_36237) : cljs.core.reset_BANG_.call(null,G__36111_36236,G__36112_36237));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((function (){var G__36113 = mode;
return (self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(G__36113) : self__.solo_modes.call(null,G__36113));
})())){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"mode","mode",-2000032078,null))], 0)))].join('')));
}

var G__36114_36238 = self__.solo_mode;
var G__36115_36239 = mode;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__36114_36238,G__36115_36239) : cljs.core.reset_BANG_.call(null,G__36114_36238,G__36115_36239));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t36108.cljs$lang$type = true;

cljs.core.async.t36108.cljs$lang$ctorStr = "cljs.core.async/t36108";

cljs.core.async.t36108.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t36108");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t36108 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t36108(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta36109){
return (new cljs.core.async.t36108(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta36109));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t36108(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__11552__auto___36240 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___36240,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___36240,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_36187){
var state_val_36188 = (state_36187[(1)]);
if((state_val_36188 === (7))){
var inst_36129 = (state_36187[(7)]);
var inst_36134 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_36129);
var state_36187__$1 = state_36187;
var statearr_36189_36241 = state_36187__$1;
(statearr_36189_36241[(2)] = inst_36134);

(statearr_36189_36241[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (20))){
var inst_36144 = (state_36187[(8)]);
var state_36187__$1 = state_36187;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36187__$1,(23),out,inst_36144);
} else {
if((state_val_36188 === (1))){
var inst_36119 = (state_36187[(9)]);
var inst_36119__$1 = calc_state();
var inst_36120 = cljs.core.seq_QMARK_(inst_36119__$1);
var state_36187__$1 = (function (){var statearr_36190 = state_36187;
(statearr_36190[(9)] = inst_36119__$1);

return statearr_36190;
})();
if(inst_36120){
var statearr_36191_36242 = state_36187__$1;
(statearr_36191_36242[(1)] = (2));

} else {
var statearr_36192_36243 = state_36187__$1;
(statearr_36192_36243[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (24))){
var inst_36137 = (state_36187[(10)]);
var inst_36129 = inst_36137;
var state_36187__$1 = (function (){var statearr_36193 = state_36187;
(statearr_36193[(7)] = inst_36129);

return statearr_36193;
})();
var statearr_36194_36244 = state_36187__$1;
(statearr_36194_36244[(2)] = null);

(statearr_36194_36244[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (4))){
var inst_36119 = (state_36187[(9)]);
var inst_36125 = (state_36187[(2)]);
var inst_36126 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_36125,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_36127 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_36125,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_36128 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_36125,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_36129 = inst_36119;
var state_36187__$1 = (function (){var statearr_36195 = state_36187;
(statearr_36195[(11)] = inst_36126);

(statearr_36195[(7)] = inst_36129);

(statearr_36195[(12)] = inst_36128);

(statearr_36195[(13)] = inst_36127);

return statearr_36195;
})();
var statearr_36196_36245 = state_36187__$1;
(statearr_36196_36245[(2)] = null);

(statearr_36196_36245[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (15))){
var state_36187__$1 = state_36187;
var statearr_36197_36246 = state_36187__$1;
(statearr_36197_36246[(2)] = null);

(statearr_36197_36246[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (21))){
var inst_36137 = (state_36187[(10)]);
var inst_36129 = inst_36137;
var state_36187__$1 = (function (){var statearr_36198 = state_36187;
(statearr_36198[(7)] = inst_36129);

return statearr_36198;
})();
var statearr_36199_36247 = state_36187__$1;
(statearr_36199_36247[(2)] = null);

(statearr_36199_36247[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (13))){
var inst_36183 = (state_36187[(2)]);
var state_36187__$1 = state_36187;
var statearr_36200_36248 = state_36187__$1;
(statearr_36200_36248[(2)] = inst_36183);

(statearr_36200_36248[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (22))){
var inst_36181 = (state_36187[(2)]);
var state_36187__$1 = state_36187;
var statearr_36201_36249 = state_36187__$1;
(statearr_36201_36249[(2)] = inst_36181);

(statearr_36201_36249[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (6))){
var inst_36185 = (state_36187[(2)]);
var state_36187__$1 = state_36187;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36187__$1,inst_36185);
} else {
if((state_val_36188 === (25))){
var state_36187__$1 = state_36187;
var statearr_36202_36250 = state_36187__$1;
(statearr_36202_36250[(2)] = null);

(statearr_36202_36250[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (17))){
var inst_36160 = (state_36187[(14)]);
var state_36187__$1 = state_36187;
var statearr_36203_36251 = state_36187__$1;
(statearr_36203_36251[(2)] = inst_36160);

(statearr_36203_36251[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (3))){
var inst_36119 = (state_36187[(9)]);
var state_36187__$1 = state_36187;
var statearr_36204_36252 = state_36187__$1;
(statearr_36204_36252[(2)] = inst_36119);

(statearr_36204_36252[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (12))){
var inst_36138 = (state_36187[(15)]);
var inst_36145 = (state_36187[(16)]);
var inst_36160 = (state_36187[(14)]);
var inst_36160__$1 = (function (){var G__36205 = inst_36145;
return (inst_36138.cljs$core$IFn$_invoke$arity$1 ? inst_36138.cljs$core$IFn$_invoke$arity$1(G__36205) : inst_36138.call(null,G__36205));
})();
var state_36187__$1 = (function (){var statearr_36206 = state_36187;
(statearr_36206[(14)] = inst_36160__$1);

return statearr_36206;
})();
if(cljs.core.truth_(inst_36160__$1)){
var statearr_36207_36253 = state_36187__$1;
(statearr_36207_36253[(1)] = (17));

} else {
var statearr_36208_36254 = state_36187__$1;
(statearr_36208_36254[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (2))){
var inst_36119 = (state_36187[(9)]);
var inst_36122 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_36119);
var state_36187__$1 = state_36187;
var statearr_36209_36255 = state_36187__$1;
(statearr_36209_36255[(2)] = inst_36122);

(statearr_36209_36255[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (23))){
var inst_36172 = (state_36187[(2)]);
var state_36187__$1 = state_36187;
if(cljs.core.truth_(inst_36172)){
var statearr_36210_36256 = state_36187__$1;
(statearr_36210_36256[(1)] = (24));

} else {
var statearr_36211_36257 = state_36187__$1;
(statearr_36211_36257[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (19))){
var inst_36169 = (state_36187[(2)]);
var state_36187__$1 = state_36187;
if(cljs.core.truth_(inst_36169)){
var statearr_36212_36258 = state_36187__$1;
(statearr_36212_36258[(1)] = (20));

} else {
var statearr_36213_36259 = state_36187__$1;
(statearr_36213_36259[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (11))){
var inst_36144 = (state_36187[(8)]);
var inst_36150 = (inst_36144 == null);
var state_36187__$1 = state_36187;
if(cljs.core.truth_(inst_36150)){
var statearr_36214_36260 = state_36187__$1;
(statearr_36214_36260[(1)] = (14));

} else {
var statearr_36215_36261 = state_36187__$1;
(statearr_36215_36261[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (9))){
var inst_36137 = (state_36187[(10)]);
var inst_36137__$1 = (state_36187[(2)]);
var inst_36138 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_36137__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_36139 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_36137__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_36140 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_36137__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_36187__$1 = (function (){var statearr_36216 = state_36187;
(statearr_36216[(15)] = inst_36138);

(statearr_36216[(10)] = inst_36137__$1);

(statearr_36216[(17)] = inst_36139);

return statearr_36216;
})();
return cljs.core.async.ioc_alts_BANG_(state_36187__$1,(10),inst_36140);
} else {
if((state_val_36188 === (5))){
var inst_36129 = (state_36187[(7)]);
var inst_36132 = cljs.core.seq_QMARK_(inst_36129);
var state_36187__$1 = state_36187;
if(inst_36132){
var statearr_36217_36262 = state_36187__$1;
(statearr_36217_36262[(1)] = (7));

} else {
var statearr_36218_36263 = state_36187__$1;
(statearr_36218_36263[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (14))){
var inst_36145 = (state_36187[(16)]);
var inst_36152 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_36145);
var state_36187__$1 = state_36187;
var statearr_36219_36264 = state_36187__$1;
(statearr_36219_36264[(2)] = inst_36152);

(statearr_36219_36264[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (26))){
var inst_36177 = (state_36187[(2)]);
var state_36187__$1 = state_36187;
var statearr_36220_36265 = state_36187__$1;
(statearr_36220_36265[(2)] = inst_36177);

(statearr_36220_36265[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (16))){
var inst_36155 = (state_36187[(2)]);
var inst_36156 = calc_state();
var inst_36129 = inst_36156;
var state_36187__$1 = (function (){var statearr_36221 = state_36187;
(statearr_36221[(18)] = inst_36155);

(statearr_36221[(7)] = inst_36129);

return statearr_36221;
})();
var statearr_36222_36266 = state_36187__$1;
(statearr_36222_36266[(2)] = null);

(statearr_36222_36266[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (10))){
var inst_36145 = (state_36187[(16)]);
var inst_36144 = (state_36187[(8)]);
var inst_36143 = (state_36187[(2)]);
var inst_36144__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_36143,(0),null);
var inst_36145__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_36143,(1),null);
var inst_36146 = (inst_36144__$1 == null);
var inst_36147 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_36145__$1,change);
var inst_36148 = (inst_36146) || (inst_36147);
var state_36187__$1 = (function (){var statearr_36223 = state_36187;
(statearr_36223[(16)] = inst_36145__$1);

(statearr_36223[(8)] = inst_36144__$1);

return statearr_36223;
})();
if(cljs.core.truth_(inst_36148)){
var statearr_36224_36267 = state_36187__$1;
(statearr_36224_36267[(1)] = (11));

} else {
var statearr_36225_36268 = state_36187__$1;
(statearr_36225_36268[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (18))){
var inst_36138 = (state_36187[(15)]);
var inst_36139 = (state_36187[(17)]);
var inst_36145 = (state_36187[(16)]);
var inst_36164 = cljs.core.empty_QMARK_(inst_36138);
var inst_36165 = (function (){var G__36226 = inst_36145;
return (inst_36139.cljs$core$IFn$_invoke$arity$1 ? inst_36139.cljs$core$IFn$_invoke$arity$1(G__36226) : inst_36139.call(null,G__36226));
})();
var inst_36166 = cljs.core.not(inst_36165);
var inst_36167 = (inst_36164) && (inst_36166);
var state_36187__$1 = state_36187;
var statearr_36227_36269 = state_36187__$1;
(statearr_36227_36269[(2)] = inst_36167);

(statearr_36227_36269[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36188 === (8))){
var inst_36129 = (state_36187[(7)]);
var state_36187__$1 = state_36187;
var statearr_36228_36270 = state_36187__$1;
(statearr_36228_36270[(2)] = inst_36129);

(statearr_36228_36270[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___36240,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__11474__auto__,c__11552__auto___36240,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__11475__auto__ = null;
var cljs$core$async$mix_$_state_machine__11475__auto____0 = (function (){
var statearr_36232 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36232[(0)] = cljs$core$async$mix_$_state_machine__11475__auto__);

(statearr_36232[(1)] = (1));

return statearr_36232;
});
var cljs$core$async$mix_$_state_machine__11475__auto____1 = (function (state_36187){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_36187);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e36233){if((e36233 instanceof Object)){
var ex__11478__auto__ = e36233;
var statearr_36234_36271 = state_36187;
(statearr_36234_36271[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36187);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e36233;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36272 = state_36187;
state_36187 = G__36272;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__11475__auto__ = function(state_36187){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__11475__auto____1.call(this,state_36187);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__11475__auto____0;
cljs$core$async$mix_$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__11475__auto____1;
return cljs$core$async$mix_$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___36240,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__11554__auto__ = (function (){var statearr_36235 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_36235[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___36240);

return statearr_36235;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___36240,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 * state map is a map of channels -> channel-state-map. A
 * channel-state-map is a map of attrs -> boolean, where attr is one or
 * more of :mute, :pause or :solo. Any states supplied are merged with
 * the current state.
 * 
 * Note that channels can be added to a mix via toggle, which can be
 * used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

cljs.core.async.Pub = (function (){var obj36274 = {};
return obj36274;
})();

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((function (){var and__4259__auto__ = p;
if(and__4259__auto__){
return p.cljs$core$async$Pub$sub_STAR_$arity$4;
} else {
return and__4259__auto__;
}
})()){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__4907__auto__ = (((p == null))?null:p);
return (function (){var or__4271__auto__ = (cljs.core.async.sub_STAR_[(function (){var G__36278 = x__4907__auto__;
return goog.typeOf(G__36278);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
})().call(null,p,v,ch,close_QMARK_);
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((function (){var and__4259__auto__ = p;
if(and__4259__auto__){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3;
} else {
return and__4259__auto__;
}
})()){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__4907__auto__ = (((p == null))?null:p);
return (function (){var or__4271__auto__ = (cljs.core.async.unsub_STAR_[(function (){var G__36282 = x__4907__auto__;
return goog.typeOf(G__36282);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
})().call(null,p,v,ch);
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(){
var G__36284 = arguments.length;
switch (G__36284) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((function (){var and__4259__auto__ = p;
if(and__4259__auto__){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1;
} else {
return and__4259__auto__;
}
})()){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__4907__auto__ = (((p == null))?null:p);
return (function (){var or__4271__auto__ = (cljs.core.async.unsub_all_STAR_[(function (){var G__36286 = x__4907__auto__;
return goog.typeOf(G__36286);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
})().call(null,p);
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((function (){var and__4259__auto__ = p;
if(and__4259__auto__){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2;
} else {
return and__4259__auto__;
}
})()){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__4907__auto__ = (((p == null))?null:p);
return (function (){var or__4271__auto__ = (cljs.core.async.unsub_all_STAR_[(function (){var G__36288 = x__4907__auto__;
return goog.typeOf(G__36288);
})()]);
if(or__4271__auto__){
return or__4271__auto__;
} else {
var or__4271__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(or__4271__auto____$1){
return or__4271__auto____$1;
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
})().call(null,p,v);
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;

/**
 * Creates and returns a pub(lication) of the supplied channel,
 * partitioned into topics by the topic-fn. topic-fn will be applied to
 * each value on the channel and the result will determine the 'topic'
 * on which that value will be put. Channels can be subscribed to
 * receive copies of topics using 'sub', and unsubscribed using
 * 'unsub'. Each topic will be handled by an internal mult on a
 * dedicated channel. By default these internal channels are
 * unbuffered, but a buf-fn can be supplied which, given a topic,
 * creates a buffer with desired properties.
 * 
 * Each item is distributed to all subs in parallel and synchronously,
 * i.e. each sub must accept before the next item is distributed. Use
 * buffering/windowing to prevent slow subs from holding up the pub.
 * 
 * Items received when there are no matching subs get dropped.
 * 
 * Note that if buf-fns are used then each topic is handled
 * asynchronously, i.e. if a channel is subscribed to more than one
 * topic it should not expect them to be interleaved identically with
 * the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(){
var G__36292 = arguments.length;
switch (G__36292) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = (function (){var G__36293 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__36293) : cljs.core.atom.call(null,G__36293));
})();
var ensure_mult = ((function (mults){
return (function (topic){
var or__4271__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((function (){var G__36295 = mults;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36295) : cljs.core.deref.call(null,G__36295));
})(),topic);
if(cljs.core.truth_(or__4271__auto__)){
return or__4271__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,((function (or__4271__auto__,mults){
return (function (p1__36290_SHARP_){
if(cljs.core.truth_((function (){var G__36296 = topic;
return (p1__36290_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__36290_SHARP_.cljs$core$IFn$_invoke$arity$1(G__36296) : p1__36290_SHARP_.call(null,G__36296));
})())){
return p1__36290_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__36290_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((function (){var G__36297 = topic;
return (buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(G__36297) : buf_fn.call(null,G__36297));
})())));
}
});})(or__4271__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t36298 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t36298 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta36299){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta36299 = meta36299;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t36298.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_36300,meta36299__$1){
var self__ = this;
var _36300__$1 = this;
return (new cljs.core.async.t36298(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta36299__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t36298.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_36300){
var self__ = this;
var _36300__$1 = this;
return self__.meta36299;
});})(mults,ensure_mult))
;

cljs.core.async.t36298.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t36298.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t36298.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t36298.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (function (){var G__36301 = topic;
return (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(G__36301) : self__.ensure_mult.call(null,G__36301));
})();
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t36298.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4404__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((function (){var G__36302 = self__.mults;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36302) : cljs.core.deref.call(null,G__36302));
})(),topic);
if(cljs.core.truth_(temp__4404__auto__)){
var m = temp__4404__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t36298.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__36303 = self__.mults;
var G__36304 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__36303,G__36304) : cljs.core.reset_BANG_.call(null,G__36303,G__36304));
});})(mults,ensure_mult))
;

cljs.core.async.t36298.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t36298.cljs$lang$type = true;

cljs.core.async.t36298.cljs$lang$ctorStr = "cljs.core.async/t36298";

cljs.core.async.t36298.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t36298");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t36298 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t36298(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta36299){
return (new cljs.core.async.t36298(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta36299));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t36298(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__11552__auto___36428 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___36428,mults,ensure_mult,p){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___36428,mults,ensure_mult,p){
return (function (state_36376){
var state_val_36377 = (state_36376[(1)]);
if((state_val_36377 === (7))){
var inst_36372 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
var statearr_36378_36429 = state_36376__$1;
(statearr_36378_36429[(2)] = inst_36372);

(statearr_36378_36429[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (20))){
var state_36376__$1 = state_36376;
var statearr_36379_36430 = state_36376__$1;
(statearr_36379_36430[(2)] = null);

(statearr_36379_36430[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (1))){
var state_36376__$1 = state_36376;
var statearr_36380_36431 = state_36376__$1;
(statearr_36380_36431[(2)] = null);

(statearr_36380_36431[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (24))){
var inst_36355 = (state_36376[(7)]);
var inst_36364 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_36355);
var state_36376__$1 = state_36376;
var statearr_36381_36432 = state_36376__$1;
(statearr_36381_36432[(2)] = inst_36364);

(statearr_36381_36432[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (4))){
var inst_36307 = (state_36376[(8)]);
var inst_36307__$1 = (state_36376[(2)]);
var inst_36308 = (inst_36307__$1 == null);
var state_36376__$1 = (function (){var statearr_36382 = state_36376;
(statearr_36382[(8)] = inst_36307__$1);

return statearr_36382;
})();
if(cljs.core.truth_(inst_36308)){
var statearr_36383_36433 = state_36376__$1;
(statearr_36383_36433[(1)] = (5));

} else {
var statearr_36384_36434 = state_36376__$1;
(statearr_36384_36434[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (15))){
var inst_36349 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
var statearr_36385_36435 = state_36376__$1;
(statearr_36385_36435[(2)] = inst_36349);

(statearr_36385_36435[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (21))){
var inst_36369 = (state_36376[(2)]);
var state_36376__$1 = (function (){var statearr_36386 = state_36376;
(statearr_36386[(9)] = inst_36369);

return statearr_36386;
})();
var statearr_36387_36436 = state_36376__$1;
(statearr_36387_36436[(2)] = null);

(statearr_36387_36436[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (13))){
var inst_36331 = (state_36376[(10)]);
var inst_36333 = cljs.core.chunked_seq_QMARK_(inst_36331);
var state_36376__$1 = state_36376;
if(inst_36333){
var statearr_36388_36437 = state_36376__$1;
(statearr_36388_36437[(1)] = (16));

} else {
var statearr_36389_36438 = state_36376__$1;
(statearr_36389_36438[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (22))){
var inst_36361 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
if(cljs.core.truth_(inst_36361)){
var statearr_36390_36439 = state_36376__$1;
(statearr_36390_36439[(1)] = (23));

} else {
var statearr_36391_36440 = state_36376__$1;
(statearr_36391_36440[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (6))){
var inst_36307 = (state_36376[(8)]);
var inst_36357 = (state_36376[(11)]);
var inst_36355 = (state_36376[(7)]);
var inst_36355__$1 = (function (){var G__36392 = inst_36307;
return (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(G__36392) : topic_fn.call(null,G__36392));
})();
var inst_36356 = (function (){var G__36393 = mults;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36393) : cljs.core.deref.call(null,G__36393));
})();
var inst_36357__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_36356,inst_36355__$1);
var state_36376__$1 = (function (){var statearr_36394 = state_36376;
(statearr_36394[(11)] = inst_36357__$1);

(statearr_36394[(7)] = inst_36355__$1);

return statearr_36394;
})();
if(cljs.core.truth_(inst_36357__$1)){
var statearr_36395_36441 = state_36376__$1;
(statearr_36395_36441[(1)] = (19));

} else {
var statearr_36396_36442 = state_36376__$1;
(statearr_36396_36442[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (25))){
var inst_36366 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
var statearr_36397_36443 = state_36376__$1;
(statearr_36397_36443[(2)] = inst_36366);

(statearr_36397_36443[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (17))){
var inst_36331 = (state_36376[(10)]);
var inst_36340 = cljs.core.first(inst_36331);
var inst_36341 = cljs.core.async.muxch_STAR_(inst_36340);
var inst_36342 = cljs.core.async.close_BANG_(inst_36341);
var inst_36343 = cljs.core.next(inst_36331);
var inst_36317 = inst_36343;
var inst_36318 = null;
var inst_36319 = (0);
var inst_36320 = (0);
var state_36376__$1 = (function (){var statearr_36398 = state_36376;
(statearr_36398[(12)] = inst_36342);

(statearr_36398[(13)] = inst_36320);

(statearr_36398[(14)] = inst_36318);

(statearr_36398[(15)] = inst_36319);

(statearr_36398[(16)] = inst_36317);

return statearr_36398;
})();
var statearr_36399_36444 = state_36376__$1;
(statearr_36399_36444[(2)] = null);

(statearr_36399_36444[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (3))){
var inst_36374 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36376__$1,inst_36374);
} else {
if((state_val_36377 === (12))){
var inst_36351 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
var statearr_36400_36445 = state_36376__$1;
(statearr_36400_36445[(2)] = inst_36351);

(statearr_36400_36445[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (2))){
var state_36376__$1 = state_36376;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36376__$1,(4),ch);
} else {
if((state_val_36377 === (23))){
var state_36376__$1 = state_36376;
var statearr_36401_36446 = state_36376__$1;
(statearr_36401_36446[(2)] = null);

(statearr_36401_36446[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (19))){
var inst_36307 = (state_36376[(8)]);
var inst_36357 = (state_36376[(11)]);
var inst_36359 = cljs.core.async.muxch_STAR_(inst_36357);
var state_36376__$1 = state_36376;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36376__$1,(22),inst_36359,inst_36307);
} else {
if((state_val_36377 === (11))){
var inst_36331 = (state_36376[(10)]);
var inst_36317 = (state_36376[(16)]);
var inst_36331__$1 = cljs.core.seq(inst_36317);
var state_36376__$1 = (function (){var statearr_36402 = state_36376;
(statearr_36402[(10)] = inst_36331__$1);

return statearr_36402;
})();
if(inst_36331__$1){
var statearr_36403_36447 = state_36376__$1;
(statearr_36403_36447[(1)] = (13));

} else {
var statearr_36404_36448 = state_36376__$1;
(statearr_36404_36448[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (9))){
var inst_36353 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
var statearr_36405_36449 = state_36376__$1;
(statearr_36405_36449[(2)] = inst_36353);

(statearr_36405_36449[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (5))){
var inst_36314 = (function (){var G__36406 = mults;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36406) : cljs.core.deref.call(null,G__36406));
})();
var inst_36315 = cljs.core.vals(inst_36314);
var inst_36316 = cljs.core.seq(inst_36315);
var inst_36317 = inst_36316;
var inst_36318 = null;
var inst_36319 = (0);
var inst_36320 = (0);
var state_36376__$1 = (function (){var statearr_36407 = state_36376;
(statearr_36407[(13)] = inst_36320);

(statearr_36407[(14)] = inst_36318);

(statearr_36407[(15)] = inst_36319);

(statearr_36407[(16)] = inst_36317);

return statearr_36407;
})();
var statearr_36408_36450 = state_36376__$1;
(statearr_36408_36450[(2)] = null);

(statearr_36408_36450[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (14))){
var state_36376__$1 = state_36376;
var statearr_36412_36451 = state_36376__$1;
(statearr_36412_36451[(2)] = null);

(statearr_36412_36451[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (16))){
var inst_36331 = (state_36376[(10)]);
var inst_36335 = cljs.core.chunk_first(inst_36331);
var inst_36336 = cljs.core.chunk_rest(inst_36331);
var inst_36337 = cljs.core.count(inst_36335);
var inst_36317 = inst_36336;
var inst_36318 = inst_36335;
var inst_36319 = inst_36337;
var inst_36320 = (0);
var state_36376__$1 = (function (){var statearr_36413 = state_36376;
(statearr_36413[(13)] = inst_36320);

(statearr_36413[(14)] = inst_36318);

(statearr_36413[(15)] = inst_36319);

(statearr_36413[(16)] = inst_36317);

return statearr_36413;
})();
var statearr_36414_36452 = state_36376__$1;
(statearr_36414_36452[(2)] = null);

(statearr_36414_36452[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (10))){
var inst_36320 = (state_36376[(13)]);
var inst_36318 = (state_36376[(14)]);
var inst_36319 = (state_36376[(15)]);
var inst_36317 = (state_36376[(16)]);
var inst_36325 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_36318,inst_36320);
var inst_36326 = cljs.core.async.muxch_STAR_(inst_36325);
var inst_36327 = cljs.core.async.close_BANG_(inst_36326);
var inst_36328 = (inst_36320 + (1));
var tmp36409 = inst_36318;
var tmp36410 = inst_36319;
var tmp36411 = inst_36317;
var inst_36317__$1 = tmp36411;
var inst_36318__$1 = tmp36409;
var inst_36319__$1 = tmp36410;
var inst_36320__$1 = inst_36328;
var state_36376__$1 = (function (){var statearr_36415 = state_36376;
(statearr_36415[(13)] = inst_36320__$1);

(statearr_36415[(14)] = inst_36318__$1);

(statearr_36415[(15)] = inst_36319__$1);

(statearr_36415[(17)] = inst_36327);

(statearr_36415[(16)] = inst_36317__$1);

return statearr_36415;
})();
var statearr_36416_36453 = state_36376__$1;
(statearr_36416_36453[(2)] = null);

(statearr_36416_36453[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (18))){
var inst_36346 = (state_36376[(2)]);
var state_36376__$1 = state_36376;
var statearr_36417_36454 = state_36376__$1;
(statearr_36417_36454[(2)] = inst_36346);

(statearr_36417_36454[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36377 === (8))){
var inst_36320 = (state_36376[(13)]);
var inst_36319 = (state_36376[(15)]);
var inst_36322 = (inst_36320 < inst_36319);
var inst_36323 = inst_36322;
var state_36376__$1 = state_36376;
if(cljs.core.truth_(inst_36323)){
var statearr_36418_36455 = state_36376__$1;
(statearr_36418_36455[(1)] = (10));

} else {
var statearr_36419_36456 = state_36376__$1;
(statearr_36419_36456[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___36428,mults,ensure_mult,p))
;
return ((function (switch__11474__auto__,c__11552__auto___36428,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_36423 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36423[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_36423[(1)] = (1));

return statearr_36423;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_36376){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_36376);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e36424){if((e36424 instanceof Object)){
var ex__11478__auto__ = e36424;
var statearr_36425_36457 = state_36376;
(statearr_36425_36457[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36376);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e36424;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36458 = state_36376;
state_36376 = G__36458;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_36376){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_36376);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___36428,mults,ensure_mult,p))
})();
var state__11554__auto__ = (function (){var statearr_36426 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_36426[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___36428);

return statearr_36426;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___36428,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;
/**
 * Subscribes a channel to a topic of a pub.
 * 
 * By default the channel will be closed when the source closes,
 * but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(){
var G__36460 = arguments.length;
switch (G__36460) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;
/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(){
var G__36463 = arguments.length;
switch (G__36463) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1(p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2(p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;
/**
 * Takes a function and a collection of source channels, and returns a
 * channel which contains the values produced by applying f to the set
 * of first items taken from each source channel, followed by applying
 * f to the set of second items from each channel, until any one of the
 * channels is closed, at which point the output channel will be
 * closed. The returned channel will be unbuffered by default, or a
 * buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(){
var G__36466 = arguments.length;
switch (G__36466) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (function (){var G__36467 = null;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__36467) : cljs.core.atom.call(null,G__36467));
})();
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__11552__auto___36541 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___36541,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___36541,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_36506){
var state_val_36507 = (state_36506[(1)]);
if((state_val_36507 === (7))){
var state_36506__$1 = state_36506;
var statearr_36508_36542 = state_36506__$1;
(statearr_36508_36542[(2)] = null);

(statearr_36508_36542[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (1))){
var state_36506__$1 = state_36506;
var statearr_36509_36543 = state_36506__$1;
(statearr_36509_36543[(2)] = null);

(statearr_36509_36543[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (4))){
var inst_36470 = (state_36506[(7)]);
var inst_36472 = (inst_36470 < cnt);
var state_36506__$1 = state_36506;
if(cljs.core.truth_(inst_36472)){
var statearr_36510_36544 = state_36506__$1;
(statearr_36510_36544[(1)] = (6));

} else {
var statearr_36511_36545 = state_36506__$1;
(statearr_36511_36545[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (15))){
var inst_36502 = (state_36506[(2)]);
var state_36506__$1 = state_36506;
var statearr_36512_36546 = state_36506__$1;
(statearr_36512_36546[(2)] = inst_36502);

(statearr_36512_36546[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (13))){
var inst_36495 = cljs.core.async.close_BANG_(out);
var state_36506__$1 = state_36506;
var statearr_36513_36547 = state_36506__$1;
(statearr_36513_36547[(2)] = inst_36495);

(statearr_36513_36547[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (6))){
var state_36506__$1 = state_36506;
var statearr_36514_36548 = state_36506__$1;
(statearr_36514_36548[(2)] = null);

(statearr_36514_36548[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (3))){
var inst_36504 = (state_36506[(2)]);
var state_36506__$1 = state_36506;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36506__$1,inst_36504);
} else {
if((state_val_36507 === (12))){
var inst_36492 = (state_36506[(8)]);
var inst_36492__$1 = (state_36506[(2)]);
var inst_36493 = cljs.core.some(cljs.core.nil_QMARK_,inst_36492__$1);
var state_36506__$1 = (function (){var statearr_36515 = state_36506;
(statearr_36515[(8)] = inst_36492__$1);

return statearr_36515;
})();
if(cljs.core.truth_(inst_36493)){
var statearr_36516_36549 = state_36506__$1;
(statearr_36516_36549[(1)] = (13));

} else {
var statearr_36517_36550 = state_36506__$1;
(statearr_36517_36550[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (2))){
var inst_36469 = (function (){var G__36518 = dctr;
var G__36519 = cnt;
return (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__36518,G__36519) : cljs.core.reset_BANG_.call(null,G__36518,G__36519));
})();
var inst_36470 = (0);
var state_36506__$1 = (function (){var statearr_36520 = state_36506;
(statearr_36520[(7)] = inst_36470);

(statearr_36520[(9)] = inst_36469);

return statearr_36520;
})();
var statearr_36521_36551 = state_36506__$1;
(statearr_36521_36551[(2)] = null);

(statearr_36521_36551[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (11))){
var inst_36470 = (state_36506[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_36506,(10),Object,null,(9));
var inst_36479 = (function (){var G__36522 = inst_36470;
return (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(G__36522) : chs__$1.call(null,G__36522));
})();
var inst_36480 = (function (){var G__36523 = inst_36470;
return (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(G__36523) : done.call(null,G__36523));
})();
var inst_36481 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_36479,inst_36480);
var state_36506__$1 = state_36506;
var statearr_36524_36552 = state_36506__$1;
(statearr_36524_36552[(2)] = inst_36481);


cljs.core.async.impl.ioc_helpers.process_exception(state_36506__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (9))){
var inst_36470 = (state_36506[(7)]);
var inst_36483 = (state_36506[(2)]);
var inst_36484 = (inst_36470 + (1));
var inst_36470__$1 = inst_36484;
var state_36506__$1 = (function (){var statearr_36525 = state_36506;
(statearr_36525[(7)] = inst_36470__$1);

(statearr_36525[(10)] = inst_36483);

return statearr_36525;
})();
var statearr_36526_36553 = state_36506__$1;
(statearr_36526_36553[(2)] = null);

(statearr_36526_36553[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (5))){
var inst_36490 = (state_36506[(2)]);
var state_36506__$1 = (function (){var statearr_36527 = state_36506;
(statearr_36527[(11)] = inst_36490);

return statearr_36527;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36506__$1,(12),dchan);
} else {
if((state_val_36507 === (14))){
var inst_36492 = (state_36506[(8)]);
var inst_36497 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_36492);
var state_36506__$1 = state_36506;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36506__$1,(16),out,inst_36497);
} else {
if((state_val_36507 === (16))){
var inst_36499 = (state_36506[(2)]);
var state_36506__$1 = (function (){var statearr_36528 = state_36506;
(statearr_36528[(12)] = inst_36499);

return statearr_36528;
})();
var statearr_36529_36554 = state_36506__$1;
(statearr_36529_36554[(2)] = null);

(statearr_36529_36554[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (10))){
var inst_36474 = (state_36506[(2)]);
var inst_36475 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_36506__$1 = (function (){var statearr_36530 = state_36506;
(statearr_36530[(13)] = inst_36474);

return statearr_36530;
})();
var statearr_36531_36555 = state_36506__$1;
(statearr_36531_36555[(2)] = inst_36475);


cljs.core.async.impl.ioc_helpers.process_exception(state_36506__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36507 === (8))){
var inst_36488 = (state_36506[(2)]);
var state_36506__$1 = state_36506;
var statearr_36532_36556 = state_36506__$1;
(statearr_36532_36556[(2)] = inst_36488);

(statearr_36532_36556[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___36541,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__11474__auto__,c__11552__auto___36541,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_36536 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36536[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_36536[(1)] = (1));

return statearr_36536;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_36506){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_36506);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e36537){if((e36537 instanceof Object)){
var ex__11478__auto__ = e36537;
var statearr_36538_36557 = state_36506;
(statearr_36538_36557[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36506);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e36537;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36558 = state_36506;
state_36506 = G__36558;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_36506){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_36506);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___36541,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__11554__auto__ = (function (){var statearr_36539 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_36539[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___36541);

return statearr_36539;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___36541,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;
/**
 * Takes a collection of source channels and returns a channel which
 * contains all values taken from them. The returned channel will be
 * unbuffered by default, or a buf-or-n can be supplied. The channel
 * will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(){
var G__36561 = arguments.length;
switch (G__36561) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__11552__auto___36616 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___36616,out){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___36616,out){
return (function (state_36591){
var state_val_36592 = (state_36591[(1)]);
if((state_val_36592 === (7))){
var inst_36571 = (state_36591[(7)]);
var inst_36570 = (state_36591[(8)]);
var inst_36570__$1 = (state_36591[(2)]);
var inst_36571__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_36570__$1,(0),null);
var inst_36572 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_36570__$1,(1),null);
var inst_36573 = (inst_36571__$1 == null);
var state_36591__$1 = (function (){var statearr_36593 = state_36591;
(statearr_36593[(7)] = inst_36571__$1);

(statearr_36593[(9)] = inst_36572);

(statearr_36593[(8)] = inst_36570__$1);

return statearr_36593;
})();
if(cljs.core.truth_(inst_36573)){
var statearr_36594_36617 = state_36591__$1;
(statearr_36594_36617[(1)] = (8));

} else {
var statearr_36595_36618 = state_36591__$1;
(statearr_36595_36618[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36592 === (1))){
var inst_36562 = cljs.core.vec(chs);
var inst_36563 = inst_36562;
var state_36591__$1 = (function (){var statearr_36596 = state_36591;
(statearr_36596[(10)] = inst_36563);

return statearr_36596;
})();
var statearr_36597_36619 = state_36591__$1;
(statearr_36597_36619[(2)] = null);

(statearr_36597_36619[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36592 === (4))){
var inst_36563 = (state_36591[(10)]);
var state_36591__$1 = state_36591;
return cljs.core.async.ioc_alts_BANG_(state_36591__$1,(7),inst_36563);
} else {
if((state_val_36592 === (6))){
var inst_36587 = (state_36591[(2)]);
var state_36591__$1 = state_36591;
var statearr_36598_36620 = state_36591__$1;
(statearr_36598_36620[(2)] = inst_36587);

(statearr_36598_36620[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36592 === (3))){
var inst_36589 = (state_36591[(2)]);
var state_36591__$1 = state_36591;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36591__$1,inst_36589);
} else {
if((state_val_36592 === (2))){
var inst_36563 = (state_36591[(10)]);
var inst_36565 = cljs.core.count(inst_36563);
var inst_36566 = (inst_36565 > (0));
var state_36591__$1 = state_36591;
if(cljs.core.truth_(inst_36566)){
var statearr_36600_36621 = state_36591__$1;
(statearr_36600_36621[(1)] = (4));

} else {
var statearr_36601_36622 = state_36591__$1;
(statearr_36601_36622[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36592 === (11))){
var inst_36563 = (state_36591[(10)]);
var inst_36580 = (state_36591[(2)]);
var tmp36599 = inst_36563;
var inst_36563__$1 = tmp36599;
var state_36591__$1 = (function (){var statearr_36602 = state_36591;
(statearr_36602[(11)] = inst_36580);

(statearr_36602[(10)] = inst_36563__$1);

return statearr_36602;
})();
var statearr_36603_36623 = state_36591__$1;
(statearr_36603_36623[(2)] = null);

(statearr_36603_36623[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36592 === (9))){
var inst_36571 = (state_36591[(7)]);
var state_36591__$1 = state_36591;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36591__$1,(11),out,inst_36571);
} else {
if((state_val_36592 === (5))){
var inst_36585 = cljs.core.async.close_BANG_(out);
var state_36591__$1 = state_36591;
var statearr_36604_36624 = state_36591__$1;
(statearr_36604_36624[(2)] = inst_36585);

(statearr_36604_36624[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36592 === (10))){
var inst_36583 = (state_36591[(2)]);
var state_36591__$1 = state_36591;
var statearr_36605_36625 = state_36591__$1;
(statearr_36605_36625[(2)] = inst_36583);

(statearr_36605_36625[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36592 === (8))){
var inst_36571 = (state_36591[(7)]);
var inst_36572 = (state_36591[(9)]);
var inst_36563 = (state_36591[(10)]);
var inst_36570 = (state_36591[(8)]);
var inst_36575 = (function (){var cs = inst_36563;
var vec__36568 = inst_36570;
var v = inst_36571;
var c = inst_36572;
return ((function (cs,vec__36568,v,c,inst_36571,inst_36572,inst_36563,inst_36570,state_val_36592,c__11552__auto___36616,out){
return (function (p1__36559_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__36559_SHARP_);
});
;})(cs,vec__36568,v,c,inst_36571,inst_36572,inst_36563,inst_36570,state_val_36592,c__11552__auto___36616,out))
})();
var inst_36576 = cljs.core.filterv(inst_36575,inst_36563);
var inst_36563__$1 = inst_36576;
var state_36591__$1 = (function (){var statearr_36606 = state_36591;
(statearr_36606[(10)] = inst_36563__$1);

return statearr_36606;
})();
var statearr_36607_36626 = state_36591__$1;
(statearr_36607_36626[(2)] = null);

(statearr_36607_36626[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___36616,out))
;
return ((function (switch__11474__auto__,c__11552__auto___36616,out){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_36611 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36611[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_36611[(1)] = (1));

return statearr_36611;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_36591){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_36591);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e36612){if((e36612 instanceof Object)){
var ex__11478__auto__ = e36612;
var statearr_36613_36627 = state_36591;
(statearr_36613_36627[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36591);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e36612;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36628 = state_36591;
state_36591 = G__36628;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_36591){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_36591);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___36616,out))
})();
var state__11554__auto__ = (function (){var statearr_36614 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_36614[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___36616);

return statearr_36614;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___36616,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel containing the single (collection) result of the
 * items taken from the channel conjoined to the supplied
 * collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 * The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(){
var G__36630 = arguments.length;
switch (G__36630) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__11552__auto___36678 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___36678,out){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___36678,out){
return (function (state_36654){
var state_val_36655 = (state_36654[(1)]);
if((state_val_36655 === (7))){
var inst_36636 = (state_36654[(7)]);
var inst_36636__$1 = (state_36654[(2)]);
var inst_36637 = (inst_36636__$1 == null);
var inst_36638 = cljs.core.not(inst_36637);
var state_36654__$1 = (function (){var statearr_36656 = state_36654;
(statearr_36656[(7)] = inst_36636__$1);

return statearr_36656;
})();
if(inst_36638){
var statearr_36657_36679 = state_36654__$1;
(statearr_36657_36679[(1)] = (8));

} else {
var statearr_36658_36680 = state_36654__$1;
(statearr_36658_36680[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (1))){
var inst_36631 = (0);
var state_36654__$1 = (function (){var statearr_36659 = state_36654;
(statearr_36659[(8)] = inst_36631);

return statearr_36659;
})();
var statearr_36660_36681 = state_36654__$1;
(statearr_36660_36681[(2)] = null);

(statearr_36660_36681[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (4))){
var state_36654__$1 = state_36654;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36654__$1,(7),ch);
} else {
if((state_val_36655 === (6))){
var inst_36649 = (state_36654[(2)]);
var state_36654__$1 = state_36654;
var statearr_36661_36682 = state_36654__$1;
(statearr_36661_36682[(2)] = inst_36649);

(statearr_36661_36682[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (3))){
var inst_36651 = (state_36654[(2)]);
var inst_36652 = cljs.core.async.close_BANG_(out);
var state_36654__$1 = (function (){var statearr_36662 = state_36654;
(statearr_36662[(9)] = inst_36651);

return statearr_36662;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_36654__$1,inst_36652);
} else {
if((state_val_36655 === (2))){
var inst_36631 = (state_36654[(8)]);
var inst_36633 = (inst_36631 < n);
var state_36654__$1 = state_36654;
if(cljs.core.truth_(inst_36633)){
var statearr_36663_36683 = state_36654__$1;
(statearr_36663_36683[(1)] = (4));

} else {
var statearr_36664_36684 = state_36654__$1;
(statearr_36664_36684[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (11))){
var inst_36631 = (state_36654[(8)]);
var inst_36641 = (state_36654[(2)]);
var inst_36642 = (inst_36631 + (1));
var inst_36631__$1 = inst_36642;
var state_36654__$1 = (function (){var statearr_36665 = state_36654;
(statearr_36665[(8)] = inst_36631__$1);

(statearr_36665[(10)] = inst_36641);

return statearr_36665;
})();
var statearr_36666_36685 = state_36654__$1;
(statearr_36666_36685[(2)] = null);

(statearr_36666_36685[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (9))){
var state_36654__$1 = state_36654;
var statearr_36667_36686 = state_36654__$1;
(statearr_36667_36686[(2)] = null);

(statearr_36667_36686[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (5))){
var state_36654__$1 = state_36654;
var statearr_36668_36687 = state_36654__$1;
(statearr_36668_36687[(2)] = null);

(statearr_36668_36687[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (10))){
var inst_36646 = (state_36654[(2)]);
var state_36654__$1 = state_36654;
var statearr_36669_36688 = state_36654__$1;
(statearr_36669_36688[(2)] = inst_36646);

(statearr_36669_36688[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36655 === (8))){
var inst_36636 = (state_36654[(7)]);
var state_36654__$1 = state_36654;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36654__$1,(11),out,inst_36636);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___36678,out))
;
return ((function (switch__11474__auto__,c__11552__auto___36678,out){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_36673 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_36673[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_36673[(1)] = (1));

return statearr_36673;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_36654){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_36654);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e36674){if((e36674 instanceof Object)){
var ex__11478__auto__ = e36674;
var statearr_36675_36689 = state_36654;
(statearr_36675_36689[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36654);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e36674;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36690 = state_36654;
state_36654 = G__36690;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_36654){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_36654);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___36678,out))
})();
var state__11554__auto__ = (function (){var statearr_36676 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_36676[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___36678);

return statearr_36676;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___36678,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t36703 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t36703 = (function (map_LT_,f,ch,meta36704){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta36704 = meta36704;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t36703.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_36705,meta36704__$1){
var self__ = this;
var _36705__$1 = this;
return (new cljs.core.async.t36703(self__.map_LT_,self__.f,self__.ch,meta36704__$1));
});

cljs.core.async.t36703.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_36705){
var self__ = this;
var _36705__$1 = this;
return self__.meta36704;
});

cljs.core.async.t36703.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t36703.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t36703.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t36703.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t36703.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if(typeof cljs.core.async.t36706 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t36706 = (function (map_LT_,f,ch,meta36704,_,fn1,meta36707){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta36704 = meta36704;
this._ = _;
this.fn1 = fn1;
this.meta36707 = meta36707;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t36706.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_36708,meta36707__$1){
var self__ = this;
var _36708__$1 = this;
return (new cljs.core.async.t36706(self__.map_LT_,self__.f,self__.ch,self__.meta36704,self__._,self__.fn1,meta36707__$1));
});})(___$1))
;

cljs.core.async.t36706.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_36708){
var self__ = this;
var _36708__$1 = this;
return self__.meta36707;
});})(___$1))
;

cljs.core.async.t36706.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t36706.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
});})(___$1))
;

cljs.core.async.t36706.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__36691_SHARP_){
var G__36709 = (((p1__36691_SHARP_ == null))?null:(function (){var G__36710 = p1__36691_SHARP_;
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__36710) : self__.f.call(null,G__36710));
})());
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__36709) : f1.call(null,G__36709));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t36706.cljs$lang$type = true;

cljs.core.async.t36706.cljs$lang$ctorStr = "cljs.core.async/t36706";

cljs.core.async.t36706.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t36706");
});})(___$1))
;

cljs.core.async.__GT_t36706 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t36706(map_LT___$1,f__$1,ch__$1,meta36704__$1,___$2,fn1__$1,meta36707){
return (new cljs.core.async.t36706(map_LT___$1,f__$1,ch__$1,meta36704__$1,___$2,fn1__$1,meta36707));
});})(___$1))
;

}

return (new cljs.core.async.t36706(self__.map_LT_,self__.f,self__.ch,self__.meta36704,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4259__auto__ = ret;
if(cljs.core.truth_(and__4259__auto__)){
return !(((function (){var G__36711 = ret;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36711) : cljs.core.deref.call(null,G__36711));
})() == null));
} else {
return and__4259__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__36712 = (function (){var G__36713 = ret;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(G__36713) : cljs.core.deref.call(null,G__36713));
})();
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__36712) : self__.f.call(null,G__36712));
})());
} else {
return ret;
}
});

cljs.core.async.t36703.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t36703.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
});

cljs.core.async.t36703.cljs$lang$type = true;

cljs.core.async.t36703.cljs$lang$ctorStr = "cljs.core.async/t36703";

cljs.core.async.t36703.cljs$lang$ctorPrWriter = (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t36703");
});

cljs.core.async.__GT_t36703 = (function cljs$core$async$map_LT__$___GT_t36703(map_LT___$1,f__$1,ch__$1,meta36704){
return (new cljs.core.async.t36703(map_LT___$1,f__$1,ch__$1,meta36704));
});

}

return (new cljs.core.async.t36703(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t36718 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t36718 = (function (map_GT_,f,ch,meta36719){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta36719 = meta36719;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t36718.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_36720,meta36719__$1){
var self__ = this;
var _36720__$1 = this;
return (new cljs.core.async.t36718(self__.map_GT_,self__.f,self__.ch,meta36719__$1));
});

cljs.core.async.t36718.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_36720){
var self__ = this;
var _36720__$1 = this;
return self__.meta36719;
});

cljs.core.async.t36718.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t36718.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t36718.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t36718.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t36718.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t36718.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(function (){var G__36721 = val;
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__36721) : self__.f.call(null,G__36721));
})(),fn1);
});

cljs.core.async.t36718.cljs$lang$type = true;

cljs.core.async.t36718.cljs$lang$ctorStr = "cljs.core.async/t36718";

cljs.core.async.t36718.cljs$lang$ctorPrWriter = (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t36718");
});

cljs.core.async.__GT_t36718 = (function cljs$core$async$map_GT__$___GT_t36718(map_GT___$1,f__$1,ch__$1,meta36719){
return (new cljs.core.async.t36718(map_GT___$1,f__$1,ch__$1,meta36719));
});

}

return (new cljs.core.async.t36718(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t36726 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t36726 = (function (filter_GT_,p,ch,meta36727){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta36727 = meta36727;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t36726.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_36728,meta36727__$1){
var self__ = this;
var _36728__$1 = this;
return (new cljs.core.async.t36726(self__.filter_GT_,self__.p,self__.ch,meta36727__$1));
});

cljs.core.async.t36726.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_36728){
var self__ = this;
var _36728__$1 = this;
return self__.meta36727;
});

cljs.core.async.t36726.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t36726.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t36726.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t36726.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t36726.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t36726.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t36726.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((function (){var G__36729 = val;
return (self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(G__36729) : self__.p.call(null,G__36729));
})())){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
});

cljs.core.async.t36726.cljs$lang$type = true;

cljs.core.async.t36726.cljs$lang$ctorStr = "cljs.core.async/t36726";

cljs.core.async.t36726.cljs$lang$ctorPrWriter = (function (this__4850__auto__,writer__4851__auto__,opt__4852__auto__){
return cljs.core._write(writer__4851__auto__,"cljs.core.async/t36726");
});

cljs.core.async.__GT_t36726 = (function cljs$core$async$filter_GT__$___GT_t36726(filter_GT___$1,p__$1,ch__$1,meta36727){
return (new cljs.core.async.t36726(filter_GT___$1,p__$1,ch__$1,meta36727));
});

}

return (new cljs.core.async.t36726(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(){
var G__36731 = arguments.length;
switch (G__36731) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__11552__auto___36775 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___36775,out){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___36775,out){
return (function (state_36752){
var state_val_36753 = (state_36752[(1)]);
if((state_val_36753 === (7))){
var inst_36748 = (state_36752[(2)]);
var state_36752__$1 = state_36752;
var statearr_36754_36776 = state_36752__$1;
(statearr_36754_36776[(2)] = inst_36748);

(statearr_36754_36776[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (1))){
var state_36752__$1 = state_36752;
var statearr_36755_36777 = state_36752__$1;
(statearr_36755_36777[(2)] = null);

(statearr_36755_36777[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (4))){
var inst_36734 = (state_36752[(7)]);
var inst_36734__$1 = (state_36752[(2)]);
var inst_36735 = (inst_36734__$1 == null);
var state_36752__$1 = (function (){var statearr_36756 = state_36752;
(statearr_36756[(7)] = inst_36734__$1);

return statearr_36756;
})();
if(cljs.core.truth_(inst_36735)){
var statearr_36757_36778 = state_36752__$1;
(statearr_36757_36778[(1)] = (5));

} else {
var statearr_36758_36779 = state_36752__$1;
(statearr_36758_36779[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (6))){
var inst_36734 = (state_36752[(7)]);
var inst_36739 = (function (){var G__36759 = inst_36734;
return (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(G__36759) : p.call(null,G__36759));
})();
var state_36752__$1 = state_36752;
if(cljs.core.truth_(inst_36739)){
var statearr_36760_36780 = state_36752__$1;
(statearr_36760_36780[(1)] = (8));

} else {
var statearr_36761_36781 = state_36752__$1;
(statearr_36761_36781[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (3))){
var inst_36750 = (state_36752[(2)]);
var state_36752__$1 = state_36752;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36752__$1,inst_36750);
} else {
if((state_val_36753 === (2))){
var state_36752__$1 = state_36752;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36752__$1,(4),ch);
} else {
if((state_val_36753 === (11))){
var inst_36742 = (state_36752[(2)]);
var state_36752__$1 = state_36752;
var statearr_36762_36782 = state_36752__$1;
(statearr_36762_36782[(2)] = inst_36742);

(statearr_36762_36782[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (9))){
var state_36752__$1 = state_36752;
var statearr_36763_36783 = state_36752__$1;
(statearr_36763_36783[(2)] = null);

(statearr_36763_36783[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (5))){
var inst_36737 = cljs.core.async.close_BANG_(out);
var state_36752__$1 = state_36752;
var statearr_36764_36784 = state_36752__$1;
(statearr_36764_36784[(2)] = inst_36737);

(statearr_36764_36784[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (10))){
var inst_36745 = (state_36752[(2)]);
var state_36752__$1 = (function (){var statearr_36765 = state_36752;
(statearr_36765[(8)] = inst_36745);

return statearr_36765;
})();
var statearr_36766_36785 = state_36752__$1;
(statearr_36766_36785[(2)] = null);

(statearr_36766_36785[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36753 === (8))){
var inst_36734 = (state_36752[(7)]);
var state_36752__$1 = state_36752;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36752__$1,(11),out,inst_36734);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___36775,out))
;
return ((function (switch__11474__auto__,c__11552__auto___36775,out){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_36770 = [null,null,null,null,null,null,null,null,null];
(statearr_36770[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_36770[(1)] = (1));

return statearr_36770;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_36752){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_36752);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e36771){if((e36771 instanceof Object)){
var ex__11478__auto__ = e36771;
var statearr_36772_36786 = state_36752;
(statearr_36772_36786[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36752);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e36771;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__36787 = state_36752;
state_36752 = G__36787;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_36752){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_36752);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___36775,out))
})();
var state__11554__auto__ = (function (){var statearr_36773 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_36773[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___36775);

return statearr_36773;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___36775,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(){
var G__36789 = arguments.length;
switch (G__36789) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;
cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__11552__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto__){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto__){
return (function (state_36957){
var state_val_36958 = (state_36957[(1)]);
if((state_val_36958 === (7))){
var inst_36953 = (state_36957[(2)]);
var state_36957__$1 = state_36957;
var statearr_36959_37001 = state_36957__$1;
(statearr_36959_37001[(2)] = inst_36953);

(statearr_36959_37001[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (20))){
var inst_36923 = (state_36957[(7)]);
var inst_36934 = (state_36957[(2)]);
var inst_36935 = cljs.core.next(inst_36923);
var inst_36909 = inst_36935;
var inst_36910 = null;
var inst_36911 = (0);
var inst_36912 = (0);
var state_36957__$1 = (function (){var statearr_36960 = state_36957;
(statearr_36960[(8)] = inst_36910);

(statearr_36960[(9)] = inst_36909);

(statearr_36960[(10)] = inst_36911);

(statearr_36960[(11)] = inst_36912);

(statearr_36960[(12)] = inst_36934);

return statearr_36960;
})();
var statearr_36961_37002 = state_36957__$1;
(statearr_36961_37002[(2)] = null);

(statearr_36961_37002[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (1))){
var state_36957__$1 = state_36957;
var statearr_36962_37003 = state_36957__$1;
(statearr_36962_37003[(2)] = null);

(statearr_36962_37003[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (4))){
var inst_36898 = (state_36957[(13)]);
var inst_36898__$1 = (state_36957[(2)]);
var inst_36899 = (inst_36898__$1 == null);
var state_36957__$1 = (function (){var statearr_36963 = state_36957;
(statearr_36963[(13)] = inst_36898__$1);

return statearr_36963;
})();
if(cljs.core.truth_(inst_36899)){
var statearr_36964_37004 = state_36957__$1;
(statearr_36964_37004[(1)] = (5));

} else {
var statearr_36965_37005 = state_36957__$1;
(statearr_36965_37005[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (15))){
var state_36957__$1 = state_36957;
var statearr_36969_37006 = state_36957__$1;
(statearr_36969_37006[(2)] = null);

(statearr_36969_37006[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (21))){
var state_36957__$1 = state_36957;
var statearr_36970_37007 = state_36957__$1;
(statearr_36970_37007[(2)] = null);

(statearr_36970_37007[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (13))){
var inst_36910 = (state_36957[(8)]);
var inst_36909 = (state_36957[(9)]);
var inst_36911 = (state_36957[(10)]);
var inst_36912 = (state_36957[(11)]);
var inst_36919 = (state_36957[(2)]);
var inst_36920 = (inst_36912 + (1));
var tmp36966 = inst_36910;
var tmp36967 = inst_36909;
var tmp36968 = inst_36911;
var inst_36909__$1 = tmp36967;
var inst_36910__$1 = tmp36966;
var inst_36911__$1 = tmp36968;
var inst_36912__$1 = inst_36920;
var state_36957__$1 = (function (){var statearr_36971 = state_36957;
(statearr_36971[(8)] = inst_36910__$1);

(statearr_36971[(9)] = inst_36909__$1);

(statearr_36971[(14)] = inst_36919);

(statearr_36971[(10)] = inst_36911__$1);

(statearr_36971[(11)] = inst_36912__$1);

return statearr_36971;
})();
var statearr_36972_37008 = state_36957__$1;
(statearr_36972_37008[(2)] = null);

(statearr_36972_37008[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (22))){
var state_36957__$1 = state_36957;
var statearr_36973_37009 = state_36957__$1;
(statearr_36973_37009[(2)] = null);

(statearr_36973_37009[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (6))){
var inst_36898 = (state_36957[(13)]);
var inst_36907 = (function (){var G__36974 = inst_36898;
return (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(G__36974) : f.call(null,G__36974));
})();
var inst_36908 = cljs.core.seq(inst_36907);
var inst_36909 = inst_36908;
var inst_36910 = null;
var inst_36911 = (0);
var inst_36912 = (0);
var state_36957__$1 = (function (){var statearr_36975 = state_36957;
(statearr_36975[(8)] = inst_36910);

(statearr_36975[(9)] = inst_36909);

(statearr_36975[(10)] = inst_36911);

(statearr_36975[(11)] = inst_36912);

return statearr_36975;
})();
var statearr_36976_37010 = state_36957__$1;
(statearr_36976_37010[(2)] = null);

(statearr_36976_37010[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (17))){
var inst_36923 = (state_36957[(7)]);
var inst_36927 = cljs.core.chunk_first(inst_36923);
var inst_36928 = cljs.core.chunk_rest(inst_36923);
var inst_36929 = cljs.core.count(inst_36927);
var inst_36909 = inst_36928;
var inst_36910 = inst_36927;
var inst_36911 = inst_36929;
var inst_36912 = (0);
var state_36957__$1 = (function (){var statearr_36977 = state_36957;
(statearr_36977[(8)] = inst_36910);

(statearr_36977[(9)] = inst_36909);

(statearr_36977[(10)] = inst_36911);

(statearr_36977[(11)] = inst_36912);

return statearr_36977;
})();
var statearr_36978_37011 = state_36957__$1;
(statearr_36978_37011[(2)] = null);

(statearr_36978_37011[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (3))){
var inst_36955 = (state_36957[(2)]);
var state_36957__$1 = state_36957;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36957__$1,inst_36955);
} else {
if((state_val_36958 === (12))){
var inst_36943 = (state_36957[(2)]);
var state_36957__$1 = state_36957;
var statearr_36979_37012 = state_36957__$1;
(statearr_36979_37012[(2)] = inst_36943);

(statearr_36979_37012[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (2))){
var state_36957__$1 = state_36957;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36957__$1,(4),in$);
} else {
if((state_val_36958 === (23))){
var inst_36951 = (state_36957[(2)]);
var state_36957__$1 = state_36957;
var statearr_36980_37013 = state_36957__$1;
(statearr_36980_37013[(2)] = inst_36951);

(statearr_36980_37013[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (19))){
var inst_36938 = (state_36957[(2)]);
var state_36957__$1 = state_36957;
var statearr_36981_37014 = state_36957__$1;
(statearr_36981_37014[(2)] = inst_36938);

(statearr_36981_37014[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (11))){
var inst_36909 = (state_36957[(9)]);
var inst_36923 = (state_36957[(7)]);
var inst_36923__$1 = cljs.core.seq(inst_36909);
var state_36957__$1 = (function (){var statearr_36982 = state_36957;
(statearr_36982[(7)] = inst_36923__$1);

return statearr_36982;
})();
if(inst_36923__$1){
var statearr_36983_37015 = state_36957__$1;
(statearr_36983_37015[(1)] = (14));

} else {
var statearr_36984_37016 = state_36957__$1;
(statearr_36984_37016[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (9))){
var inst_36945 = (state_36957[(2)]);
var inst_36946 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_36957__$1 = (function (){var statearr_36985 = state_36957;
(statearr_36985[(15)] = inst_36945);

return statearr_36985;
})();
if(cljs.core.truth_(inst_36946)){
var statearr_36986_37017 = state_36957__$1;
(statearr_36986_37017[(1)] = (21));

} else {
var statearr_36987_37018 = state_36957__$1;
(statearr_36987_37018[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (5))){
var inst_36901 = cljs.core.async.close_BANG_(out);
var state_36957__$1 = state_36957;
var statearr_36988_37019 = state_36957__$1;
(statearr_36988_37019[(2)] = inst_36901);

(statearr_36988_37019[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (14))){
var inst_36923 = (state_36957[(7)]);
var inst_36925 = cljs.core.chunked_seq_QMARK_(inst_36923);
var state_36957__$1 = state_36957;
if(inst_36925){
var statearr_36989_37020 = state_36957__$1;
(statearr_36989_37020[(1)] = (17));

} else {
var statearr_36990_37021 = state_36957__$1;
(statearr_36990_37021[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (16))){
var inst_36941 = (state_36957[(2)]);
var state_36957__$1 = state_36957;
var statearr_36991_37022 = state_36957__$1;
(statearr_36991_37022[(2)] = inst_36941);

(statearr_36991_37022[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_36958 === (10))){
var inst_36910 = (state_36957[(8)]);
var inst_36912 = (state_36957[(11)]);
var inst_36917 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_36910,inst_36912);
var state_36957__$1 = state_36957;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36957__$1,(13),out,inst_36917);
} else {
if((state_val_36958 === (18))){
var inst_36923 = (state_36957[(7)]);
var inst_36932 = cljs.core.first(inst_36923);
var state_36957__$1 = state_36957;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36957__$1,(20),out,inst_36932);
} else {
if((state_val_36958 === (8))){
var inst_36911 = (state_36957[(10)]);
var inst_36912 = (state_36957[(11)]);
var inst_36914 = (inst_36912 < inst_36911);
var inst_36915 = inst_36914;
var state_36957__$1 = state_36957;
if(cljs.core.truth_(inst_36915)){
var statearr_36992_37023 = state_36957__$1;
(statearr_36992_37023[(1)] = (10));

} else {
var statearr_36993_37024 = state_36957__$1;
(statearr_36993_37024[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto__))
;
return ((function (switch__11474__auto__,c__11552__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__11475__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__11475__auto____0 = (function (){
var statearr_36997 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36997[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__11475__auto__);

(statearr_36997[(1)] = (1));

return statearr_36997;
});
var cljs$core$async$mapcat_STAR__$_state_machine__11475__auto____1 = (function (state_36957){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_36957);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e36998){if((e36998 instanceof Object)){
var ex__11478__auto__ = e36998;
var statearr_36999_37025 = state_36957;
(statearr_36999_37025[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36957);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e36998;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37026 = state_36957;
state_36957 = G__37026;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__11475__auto__ = function(state_36957){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__11475__auto____1.call(this,state_36957);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__11475__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__11475__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto__))
})();
var state__11554__auto__ = (function (){var statearr_37000 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_37000[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto__);

return statearr_37000;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto__))
);

return c__11552__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(){
var G__37028 = arguments.length;
switch (G__37028) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(){
var G__37031 = arguments.length;
switch (G__37031) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(){
var G__37034 = arguments.length;
switch (G__37034) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__11552__auto___37084 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___37084,out){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___37084,out){
return (function (state_37058){
var state_val_37059 = (state_37058[(1)]);
if((state_val_37059 === (7))){
var inst_37053 = (state_37058[(2)]);
var state_37058__$1 = state_37058;
var statearr_37060_37085 = state_37058__$1;
(statearr_37060_37085[(2)] = inst_37053);

(statearr_37060_37085[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37059 === (1))){
var inst_37035 = null;
var state_37058__$1 = (function (){var statearr_37061 = state_37058;
(statearr_37061[(7)] = inst_37035);

return statearr_37061;
})();
var statearr_37062_37086 = state_37058__$1;
(statearr_37062_37086[(2)] = null);

(statearr_37062_37086[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37059 === (4))){
var inst_37038 = (state_37058[(8)]);
var inst_37038__$1 = (state_37058[(2)]);
var inst_37039 = (inst_37038__$1 == null);
var inst_37040 = cljs.core.not(inst_37039);
var state_37058__$1 = (function (){var statearr_37063 = state_37058;
(statearr_37063[(8)] = inst_37038__$1);

return statearr_37063;
})();
if(inst_37040){
var statearr_37064_37087 = state_37058__$1;
(statearr_37064_37087[(1)] = (5));

} else {
var statearr_37065_37088 = state_37058__$1;
(statearr_37065_37088[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37059 === (6))){
var state_37058__$1 = state_37058;
var statearr_37066_37089 = state_37058__$1;
(statearr_37066_37089[(2)] = null);

(statearr_37066_37089[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37059 === (3))){
var inst_37055 = (state_37058[(2)]);
var inst_37056 = cljs.core.async.close_BANG_(out);
var state_37058__$1 = (function (){var statearr_37067 = state_37058;
(statearr_37067[(9)] = inst_37055);

return statearr_37067;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_37058__$1,inst_37056);
} else {
if((state_val_37059 === (2))){
var state_37058__$1 = state_37058;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37058__$1,(4),ch);
} else {
if((state_val_37059 === (11))){
var inst_37038 = (state_37058[(8)]);
var inst_37047 = (state_37058[(2)]);
var inst_37035 = inst_37038;
var state_37058__$1 = (function (){var statearr_37068 = state_37058;
(statearr_37068[(10)] = inst_37047);

(statearr_37068[(7)] = inst_37035);

return statearr_37068;
})();
var statearr_37069_37090 = state_37058__$1;
(statearr_37069_37090[(2)] = null);

(statearr_37069_37090[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37059 === (9))){
var inst_37038 = (state_37058[(8)]);
var state_37058__$1 = state_37058;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37058__$1,(11),out,inst_37038);
} else {
if((state_val_37059 === (5))){
var inst_37038 = (state_37058[(8)]);
var inst_37035 = (state_37058[(7)]);
var inst_37042 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_37038,inst_37035);
var state_37058__$1 = state_37058;
if(inst_37042){
var statearr_37071_37091 = state_37058__$1;
(statearr_37071_37091[(1)] = (8));

} else {
var statearr_37072_37092 = state_37058__$1;
(statearr_37072_37092[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37059 === (10))){
var inst_37050 = (state_37058[(2)]);
var state_37058__$1 = state_37058;
var statearr_37073_37093 = state_37058__$1;
(statearr_37073_37093[(2)] = inst_37050);

(statearr_37073_37093[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37059 === (8))){
var inst_37035 = (state_37058[(7)]);
var tmp37070 = inst_37035;
var inst_37035__$1 = tmp37070;
var state_37058__$1 = (function (){var statearr_37074 = state_37058;
(statearr_37074[(7)] = inst_37035__$1);

return statearr_37074;
})();
var statearr_37075_37094 = state_37058__$1;
(statearr_37075_37094[(2)] = null);

(statearr_37075_37094[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___37084,out))
;
return ((function (switch__11474__auto__,c__11552__auto___37084,out){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_37079 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_37079[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_37079[(1)] = (1));

return statearr_37079;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_37058){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_37058);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e37080){if((e37080 instanceof Object)){
var ex__11478__auto__ = e37080;
var statearr_37081_37095 = state_37058;
(statearr_37081_37095[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37058);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e37080;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37096 = state_37058;
state_37058 = G__37096;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_37058){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_37058);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___37084,out))
})();
var state__11554__auto__ = (function (){var statearr_37082 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_37082[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___37084);

return statearr_37082;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___37084,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(){
var G__37098 = arguments.length;
switch (G__37098) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__11552__auto___37167 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___37167,out){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___37167,out){
return (function (state_37136){
var state_val_37137 = (state_37136[(1)]);
if((state_val_37137 === (7))){
var inst_37132 = (state_37136[(2)]);
var state_37136__$1 = state_37136;
var statearr_37138_37168 = state_37136__$1;
(statearr_37138_37168[(2)] = inst_37132);

(statearr_37138_37168[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (1))){
var inst_37099 = (new Array(n));
var inst_37100 = inst_37099;
var inst_37101 = (0);
var state_37136__$1 = (function (){var statearr_37139 = state_37136;
(statearr_37139[(7)] = inst_37101);

(statearr_37139[(8)] = inst_37100);

return statearr_37139;
})();
var statearr_37140_37169 = state_37136__$1;
(statearr_37140_37169[(2)] = null);

(statearr_37140_37169[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (4))){
var inst_37104 = (state_37136[(9)]);
var inst_37104__$1 = (state_37136[(2)]);
var inst_37105 = (inst_37104__$1 == null);
var inst_37106 = cljs.core.not(inst_37105);
var state_37136__$1 = (function (){var statearr_37141 = state_37136;
(statearr_37141[(9)] = inst_37104__$1);

return statearr_37141;
})();
if(inst_37106){
var statearr_37142_37170 = state_37136__$1;
(statearr_37142_37170[(1)] = (5));

} else {
var statearr_37143_37171 = state_37136__$1;
(statearr_37143_37171[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (15))){
var inst_37126 = (state_37136[(2)]);
var state_37136__$1 = state_37136;
var statearr_37144_37172 = state_37136__$1;
(statearr_37144_37172[(2)] = inst_37126);

(statearr_37144_37172[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (13))){
var state_37136__$1 = state_37136;
var statearr_37145_37173 = state_37136__$1;
(statearr_37145_37173[(2)] = null);

(statearr_37145_37173[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (6))){
var inst_37101 = (state_37136[(7)]);
var inst_37122 = (inst_37101 > (0));
var state_37136__$1 = state_37136;
if(cljs.core.truth_(inst_37122)){
var statearr_37146_37174 = state_37136__$1;
(statearr_37146_37174[(1)] = (12));

} else {
var statearr_37147_37175 = state_37136__$1;
(statearr_37147_37175[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (3))){
var inst_37134 = (state_37136[(2)]);
var state_37136__$1 = state_37136;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37136__$1,inst_37134);
} else {
if((state_val_37137 === (12))){
var inst_37100 = (state_37136[(8)]);
var inst_37124 = cljs.core.vec(inst_37100);
var state_37136__$1 = state_37136;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37136__$1,(15),out,inst_37124);
} else {
if((state_val_37137 === (2))){
var state_37136__$1 = state_37136;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37136__$1,(4),ch);
} else {
if((state_val_37137 === (11))){
var inst_37116 = (state_37136[(2)]);
var inst_37117 = (new Array(n));
var inst_37100 = inst_37117;
var inst_37101 = (0);
var state_37136__$1 = (function (){var statearr_37148 = state_37136;
(statearr_37148[(7)] = inst_37101);

(statearr_37148[(10)] = inst_37116);

(statearr_37148[(8)] = inst_37100);

return statearr_37148;
})();
var statearr_37149_37176 = state_37136__$1;
(statearr_37149_37176[(2)] = null);

(statearr_37149_37176[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (9))){
var inst_37100 = (state_37136[(8)]);
var inst_37114 = cljs.core.vec(inst_37100);
var state_37136__$1 = state_37136;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37136__$1,(11),out,inst_37114);
} else {
if((state_val_37137 === (5))){
var inst_37104 = (state_37136[(9)]);
var inst_37101 = (state_37136[(7)]);
var inst_37109 = (state_37136[(11)]);
var inst_37100 = (state_37136[(8)]);
var inst_37108 = (inst_37100[inst_37101] = inst_37104);
var inst_37109__$1 = (inst_37101 + (1));
var inst_37110 = (inst_37109__$1 < n);
var state_37136__$1 = (function (){var statearr_37150 = state_37136;
(statearr_37150[(11)] = inst_37109__$1);

(statearr_37150[(12)] = inst_37108);

return statearr_37150;
})();
if(cljs.core.truth_(inst_37110)){
var statearr_37151_37177 = state_37136__$1;
(statearr_37151_37177[(1)] = (8));

} else {
var statearr_37152_37178 = state_37136__$1;
(statearr_37152_37178[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (14))){
var inst_37129 = (state_37136[(2)]);
var inst_37130 = cljs.core.async.close_BANG_(out);
var state_37136__$1 = (function (){var statearr_37154 = state_37136;
(statearr_37154[(13)] = inst_37129);

return statearr_37154;
})();
var statearr_37155_37179 = state_37136__$1;
(statearr_37155_37179[(2)] = inst_37130);

(statearr_37155_37179[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (10))){
var inst_37120 = (state_37136[(2)]);
var state_37136__$1 = state_37136;
var statearr_37156_37180 = state_37136__$1;
(statearr_37156_37180[(2)] = inst_37120);

(statearr_37156_37180[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37137 === (8))){
var inst_37109 = (state_37136[(11)]);
var inst_37100 = (state_37136[(8)]);
var tmp37153 = inst_37100;
var inst_37100__$1 = tmp37153;
var inst_37101 = inst_37109;
var state_37136__$1 = (function (){var statearr_37157 = state_37136;
(statearr_37157[(7)] = inst_37101);

(statearr_37157[(8)] = inst_37100__$1);

return statearr_37157;
})();
var statearr_37158_37181 = state_37136__$1;
(statearr_37158_37181[(2)] = null);

(statearr_37158_37181[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___37167,out))
;
return ((function (switch__11474__auto__,c__11552__auto___37167,out){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_37162 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37162[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_37162[(1)] = (1));

return statearr_37162;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_37136){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_37136);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e37163){if((e37163 instanceof Object)){
var ex__11478__auto__ = e37163;
var statearr_37164_37182 = state_37136;
(statearr_37164_37182[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37136);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e37163;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37183 = state_37136;
state_37136 = G__37183;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_37136){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_37136);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___37167,out))
})();
var state__11554__auto__ = (function (){var statearr_37165 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_37165[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___37167);

return statearr_37165;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___37167,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(){
var G__37185 = arguments.length;
switch (G__37185) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(arguments.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__11552__auto___37259 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__11552__auto___37259,out){
return (function (){
var f__11553__auto__ = (function (){var switch__11474__auto__ = ((function (c__11552__auto___37259,out){
return (function (state_37227){
var state_val_37228 = (state_37227[(1)]);
if((state_val_37228 === (7))){
var inst_37223 = (state_37227[(2)]);
var state_37227__$1 = state_37227;
var statearr_37229_37260 = state_37227__$1;
(statearr_37229_37260[(2)] = inst_37223);

(statearr_37229_37260[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (1))){
var inst_37186 = [];
var inst_37187 = inst_37186;
var inst_37188 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_37227__$1 = (function (){var statearr_37230 = state_37227;
(statearr_37230[(7)] = inst_37188);

(statearr_37230[(8)] = inst_37187);

return statearr_37230;
})();
var statearr_37231_37261 = state_37227__$1;
(statearr_37231_37261[(2)] = null);

(statearr_37231_37261[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (4))){
var inst_37191 = (state_37227[(9)]);
var inst_37191__$1 = (state_37227[(2)]);
var inst_37192 = (inst_37191__$1 == null);
var inst_37193 = cljs.core.not(inst_37192);
var state_37227__$1 = (function (){var statearr_37232 = state_37227;
(statearr_37232[(9)] = inst_37191__$1);

return statearr_37232;
})();
if(inst_37193){
var statearr_37233_37262 = state_37227__$1;
(statearr_37233_37262[(1)] = (5));

} else {
var statearr_37234_37263 = state_37227__$1;
(statearr_37234_37263[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (15))){
var inst_37217 = (state_37227[(2)]);
var state_37227__$1 = state_37227;
var statearr_37235_37264 = state_37227__$1;
(statearr_37235_37264[(2)] = inst_37217);

(statearr_37235_37264[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (13))){
var state_37227__$1 = state_37227;
var statearr_37236_37265 = state_37227__$1;
(statearr_37236_37265[(2)] = null);

(statearr_37236_37265[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (6))){
var inst_37187 = (state_37227[(8)]);
var inst_37212 = inst_37187.length;
var inst_37213 = (inst_37212 > (0));
var state_37227__$1 = state_37227;
if(cljs.core.truth_(inst_37213)){
var statearr_37237_37266 = state_37227__$1;
(statearr_37237_37266[(1)] = (12));

} else {
var statearr_37238_37267 = state_37227__$1;
(statearr_37238_37267[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (3))){
var inst_37225 = (state_37227[(2)]);
var state_37227__$1 = state_37227;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37227__$1,inst_37225);
} else {
if((state_val_37228 === (12))){
var inst_37187 = (state_37227[(8)]);
var inst_37215 = cljs.core.vec(inst_37187);
var state_37227__$1 = state_37227;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37227__$1,(15),out,inst_37215);
} else {
if((state_val_37228 === (2))){
var state_37227__$1 = state_37227;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37227__$1,(4),ch);
} else {
if((state_val_37228 === (11))){
var inst_37195 = (state_37227[(10)]);
var inst_37191 = (state_37227[(9)]);
var inst_37205 = (state_37227[(2)]);
var inst_37206 = [];
var inst_37207 = inst_37206.push(inst_37191);
var inst_37187 = inst_37206;
var inst_37188 = inst_37195;
var state_37227__$1 = (function (){var statearr_37239 = state_37227;
(statearr_37239[(7)] = inst_37188);

(statearr_37239[(8)] = inst_37187);

(statearr_37239[(11)] = inst_37205);

(statearr_37239[(12)] = inst_37207);

return statearr_37239;
})();
var statearr_37240_37268 = state_37227__$1;
(statearr_37240_37268[(2)] = null);

(statearr_37240_37268[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (9))){
var inst_37187 = (state_37227[(8)]);
var inst_37203 = cljs.core.vec(inst_37187);
var state_37227__$1 = state_37227;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37227__$1,(11),out,inst_37203);
} else {
if((state_val_37228 === (5))){
var inst_37188 = (state_37227[(7)]);
var inst_37195 = (state_37227[(10)]);
var inst_37191 = (state_37227[(9)]);
var inst_37195__$1 = (function (){var G__37241 = inst_37191;
return (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(G__37241) : f.call(null,G__37241));
})();
var inst_37196 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_37195__$1,inst_37188);
var inst_37197 = cljs.core.keyword_identical_QMARK_(inst_37188,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_37198 = (inst_37196) || (inst_37197);
var state_37227__$1 = (function (){var statearr_37242 = state_37227;
(statearr_37242[(10)] = inst_37195__$1);

return statearr_37242;
})();
if(cljs.core.truth_(inst_37198)){
var statearr_37243_37269 = state_37227__$1;
(statearr_37243_37269[(1)] = (8));

} else {
var statearr_37244_37270 = state_37227__$1;
(statearr_37244_37270[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (14))){
var inst_37220 = (state_37227[(2)]);
var inst_37221 = cljs.core.async.close_BANG_(out);
var state_37227__$1 = (function (){var statearr_37246 = state_37227;
(statearr_37246[(13)] = inst_37220);

return statearr_37246;
})();
var statearr_37247_37271 = state_37227__$1;
(statearr_37247_37271[(2)] = inst_37221);

(statearr_37247_37271[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (10))){
var inst_37210 = (state_37227[(2)]);
var state_37227__$1 = state_37227;
var statearr_37248_37272 = state_37227__$1;
(statearr_37248_37272[(2)] = inst_37210);

(statearr_37248_37272[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_37228 === (8))){
var inst_37195 = (state_37227[(10)]);
var inst_37187 = (state_37227[(8)]);
var inst_37191 = (state_37227[(9)]);
var inst_37200 = inst_37187.push(inst_37191);
var tmp37245 = inst_37187;
var inst_37187__$1 = tmp37245;
var inst_37188 = inst_37195;
var state_37227__$1 = (function (){var statearr_37249 = state_37227;
(statearr_37249[(7)] = inst_37188);

(statearr_37249[(8)] = inst_37187__$1);

(statearr_37249[(14)] = inst_37200);

return statearr_37249;
})();
var statearr_37250_37273 = state_37227__$1;
(statearr_37250_37273[(2)] = null);

(statearr_37250_37273[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__11552__auto___37259,out))
;
return ((function (switch__11474__auto__,c__11552__auto___37259,out){
return (function() {
var cljs$core$async$state_machine__11475__auto__ = null;
var cljs$core$async$state_machine__11475__auto____0 = (function (){
var statearr_37254 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37254[(0)] = cljs$core$async$state_machine__11475__auto__);

(statearr_37254[(1)] = (1));

return statearr_37254;
});
var cljs$core$async$state_machine__11475__auto____1 = (function (state_37227){
while(true){
var ret_value__11476__auto__ = (function (){try{while(true){
var result__11477__auto__ = switch__11474__auto__(state_37227);
if(cljs.core.keyword_identical_QMARK_(result__11477__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11477__auto__;
}
break;
}
}catch (e37255){if((e37255 instanceof Object)){
var ex__11478__auto__ = e37255;
var statearr_37256_37274 = state_37227;
(statearr_37256_37274[(5)] = ex__11478__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37227);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e37255;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11476__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__37275 = state_37227;
state_37227 = G__37275;
continue;
} else {
return ret_value__11476__auto__;
}
break;
}
});
cljs$core$async$state_machine__11475__auto__ = function(state_37227){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__11475__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__11475__auto____1.call(this,state_37227);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__11475__auto____0;
cljs$core$async$state_machine__11475__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__11475__auto____1;
return cljs$core$async$state_machine__11475__auto__;
})()
;})(switch__11474__auto__,c__11552__auto___37259,out))
})();
var state__11554__auto__ = (function (){var statearr_37257 = (function (){return (f__11553__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11553__auto__.cljs$core$IFn$_invoke$arity$0() : f__11553__auto__.call(null));
})();
(statearr_37257[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__11552__auto___37259);

return statearr_37257;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11554__auto__);
});})(c__11552__auto___37259,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;
